NullGT				.equ 0
State				.equ 1
SphereMapping		.equ 1
ReverseNormals		.equ 1
RepeatCount			.equ 1
Scales				.equ 2
ProjMatrix			.equ 3
CameraPos			.equ 7
CameraRot			.equ 8
TriStripGT			.equ 9
LightCol			.equ 10
LightPos			.equ 11
SpecularCol			.equ 12
OffsetGiftag		.equ 13
FrameGiftag			.equ 15
PointGiftag			.equ 17
TextureGiftag		.equ 18
SpriteGiftag		.equ 22
Tex0ADTag			.equ 29
Tex0AD				.equ 30
Tex0Offsets			.equ 31
FrameTime			.equ 32
CamposMarkers		.equ 32
SplineStuff			.equ 33
SplineMatrix		.equ 34
CurrScale			.equ 38
CurrPretrans		.equ 39
CurrRotanim			.equ 40
CurrPosttrans		.equ 41
CurrTexScale		.equ 42
AlphaAdd			.equ 43
AlphaNorm			.equ 45
GeomCommands		.equ 47

OutputBuffer		.equ 700

HarnessInfo			.equ 1023

CPSelect			.equ H'0001
CPStart				.equ H'0008
CPUp				.equ H'0010
CPRight				.equ H'0020
CPDown				.equ H'0040
CPLeft				.equ H'0080
CPL2				.equ H'0100
CPR2				.equ H'0200
CPL1				.equ H'0400
CPR1				.equ H'0800
CPTriangle			.equ H'1000
CPCircle			.equ H'2000
CPCross				.equ H'4000
CPSquare			.equ H'7FFF

.include "vcl_sml.i"

.init_vf_all
.init_vi_all
.syntax new

.macro SetSpriteTex0Imm	imm
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	loi			\imm
	muli.y		fTex0Offsets, fTex0Offsets, i
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0(vi00)
.endm

.macro SetSpriteTex0	reg
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	mul.y		fTex0Offsets, fTex0Offsets, \reg[z]
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0(vi00)
.endm

.macro SetADTex0	reg
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	mul.y		fTex0Offsets, fTex0Offsets, \reg[z]
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0AD(vi00)
	iaddiu		iDest, vi00, Tex0ADTag
	xgkick		iDest
.endm

.macro SetFrame reg
	lq.xy		fFrameConsts, FrameConstants(vi00)
	mul.y		fFrameOffset, fFrameConsts, \reg
	add.x		fFrameConsts, fFrameConsts, fFrameOffset[y]
	ftoi0.x		fFrameConsts, fFrameConsts
	sq.x		fFrameConsts, Frame(vi00)
	iaddiu		iDest, vi00, FrameTag
	xgkick		iDest
.endm

.macro	InsertGT to, from, NLOOP
	lq			Giftag, \from(vi00)
	iaddiu		\NLOOP, \NLOOP, 0x4000
	iaddiu		\NLOOP, \NLOOP, 0x4000
	mfir.x		Giftag, \NLOOP
	sq			Giftag, \to(vi00)
.endm

.macro TerribleTerribleArcSin dest, src
	mul.xy		RAtemp, \src, \src
	sub.w		RAtemp, vf00, RAtemp[x]
	rsqrt		q, RAtemp[x], RAtemp[w]
	add.x		RAtemp, vf00, q
	sub.w		RAtemp, vf00, RAtemp[y]
	rsqrt		q, RAtemp[y], RAtemp[w]
	add.y		RAtemp, vf00, q
	eatan		p, RAtemp[x]
	mfp.x		\dest, p
	eatan		p, RAtemp[y]
	mfp.y		\dest, p
.endm

.macro Spline	fDest, iSplinePos, iSplinePosCount
	mfir.x		fTime, \iSplinePos
	itof0.x		fTime, fTime						; Convert the spline counter to floating point
	mfir.x		fSplineTime, \iSplinePosCount
	itof0.x		fSplineTime, fSplineTime
	div			q, fTime[x], fSplineTime[x]			; Current spline count / total spline count = num between 0.0 and 1.0
	add			coeff, vf00, q	
	mini		coeff, coeff, vf00[w]				; Just to be sure, clamp the coeff to 0.0 to 1.0
	max			coeff, coeff, vf00[x]	
	add.x		coeff, vf00, vf00[w]
	mul.z		coeff, coeff, coeff[y]
	mul.w		coeff, coeff, coeff[z]
	loi			0.5
	mul			coeff, coeff, i
	MatrixLoad	SplineMat, SplineMatrix, vi00
	MatrixMultiplyVertex	\fDest, SplineMat, coeff
	lq			SplinePosMat[0], -3(iSplinePtr)
	lq			SplinePosMat[1], -2(iSplinePtr)
	lq			SplinePosMat[2], -1(iSplinePtr)
	lq			SplinePosMat[3], 0(iSplinePtr)
	MatrixMultiplyVertex	\fDest, SplinePosMat, \fDest
.endm

.macro   QuaternionNormalize   vecoutput,vector
   mul			vclsmlftemp, \vector,     \vector
   add.x		vclsmlftemp, vclsmlftemp, vclsmlftemp[w]
   add.x        vclsmlftemp, vclsmlftemp, vclsmlftemp[y]
   add.x        vclsmlftemp, vclsmlftemp, vclsmlftemp[z]
   rsqrt        q,           vf00[w],     vclsmlftemp[x]
   mul			\vecoutput,  \vector,     q
.endm

.macro DoSpline	fDest, SplineData
	ilw.w		iSplinePtr, \SplineData(vi00)		; Load the current spline pointer
	ilw.w		iSplinePosCount, 0(iSplinePtr)		; Load how many frames this spline should be used for
	ilw.z		iSplinePC, \SplineData(vi00)		; Load the current spline count
	iaddiu		iSplinePC, iSplinePC, 1				; Increment the current spline count
	ibne		iSplinePC, iSplinePosCount, samespline\fDest	; If we have reached the max spline count, move to the next spline
	iaddiu		iSplinePtr, iSplinePtr, 1			; Move the spline pointer along one
	isw.w		iSplinePtr, \SplineData(vi00)		; Then save it
	iadd		iSplinePC, vi00, vi00				; Reset the current spline counter to 0
samespline\fDest:
	isw.z		iSplinePC, \SplineData(vi00)		; Save the current spline counter
	mfir.x		fTime, iSplinePC
	itof0.x		fTime, fTime						; Convert the spline counter to floating point
	mfir.x		fSplineTime, iSplinePosCount
	itof0.x		fSplineTime, fSplineTime
	div			q, fTime[x], fSplineTime[x]			; Current spline count / total spline count = num between 0.0 and 1.0
	add			coeff, vf00, q	
	mini		coeff, coeff, vf00[w]				; Just to be sure, clamp the coeff to 0.0 to 1.0
	max			coeff, coeff, vf00[x]	
	add.x		coeff, vf00, vf00[w]
	mul.z		coeff, coeff, coeff[y]
	mul.w		coeff, coeff, coeff[z]
	loi			0.5
	mul			coeff, coeff, i
	MatrixLoad	SplineMat, SplineMatrix, vi00
	MatrixMultiplyVertex	\fDest, SplineMat, coeff
	lq			SplinePosMat[0], -3(iSplinePtr)
	lq			SplinePosMat[1], -2(iSplinePtr)
	lq			SplinePosMat[2], -1(iSplinePtr)
	lq			SplinePosMat[3], 0(iSplinePtr)
	MatrixMultiplyVertex	\fDest, SplinePosMat, \fDest
.endm

.macro ManualCamera
	lq.xyz		fCamPos, CameraPos(vi00)
	lq.xz		fCamRot, CameraRot(vi00)
	loi			0.5e-1
	ilw.w		iPad, HarnessInfo(vi00)	
	add			CamVel, vf00, vf00[x]
	iaddiu		iUp, vi00, CPUp
	iand		iIsDown, iPad, iUp
	ibne		iIsDown, vi00, notup
	addi.x		fCamRot, fCamRot, i
notup:
	iaddiu		iDown, vi00, CPDown
	iand		iIsDown, iPad, iDown
	ibne		iIsDown, vi00, notdown
	subi.x		fCamRot, fCamRot, i
notdown:
	iaddiu		iLeft, vi00, CPLeft
	iand		iIsDown, iPad, iLeft
	ibne		iIsDown, vi00, notleft
	addi.z		fCamRot, fCamRot, i
notleft:
	iaddiu		iRight, vi00, CPRight
	iand		iIsDown, iPad, iRight
	ibne		iIsDown, vi00, notright
	subi.z		fCamRot, fCamRot, i
notright:
	iaddiu		iCross, vi00, CPCross
	iand		iIsDown, iPad, iCross
	ibne		iIsDown, vi00, notcross
	addi.z		CamVel, CamVel, i
notcross:
	iaddiu		iTri, vi00, CPTriangle
	iand		iIsDown, iPad, iTri
	ibne		iIsDown, vi00, nottri
	subi.z		CamVel, CamVel, i
nottri:
	iaddiu		iCircle, vi00, CPCircle
	iand		iIsDown, iPad, iCircle
	ibne		iIsDown, vi00, notcircle
	addi.x		CamVel, CamVel, i
notcircle:
	iaddiu		iSqr, vi00, CPSquare
	iaddiu		iSqr, iSqr, 1
	iand		iIsDown, iPad, iSqr
	ibne		iIsDown, vi00, notsquare
	subi.x		CamVel, CamVel, i
notsquare:
	sq.xz		fCamRot, CameraRot(vi00)
	AngleSinCos fCamRot, sincos	
	mfir.yw		CameraMat[0], vi00
	mfir.w		CameraMat[1], vi00
	mfir.w		CameraMat[2], vi00
	add			CameraMat[3], vf00, vf00[x]
	add.x		CameraMat[0], vf00, sincos[w]	; 11 = cy
	add.x		CameraMat[1], vf00, sincos[x]	; 21 = sx
	add.x		CameraMat[2], vf00, sincos[y]	; 31 = cx
	add.y		CameraMat[1], vf00, sincos[y]	; 22 = cx
	sub.y		CameraMat[2], vf00, sincos[x]	; 32 = -sx
	sub.z		CameraMat[0], vf00, sincos[z]	; 31 = -sy
	add.z		CameraMat[1], vf00, sincos[x]	; 32 = sx
	add.z		CameraMat[2], vf00, sincos[y]	; 33 = cx
	add.x		Mult, vf00, sincos[z]			; sy
	add.z		Mult, vf00, sincos[w]			; cy
	mul.xz		CameraMat[1], CameraMat[1], Mult	
	mul.xz		CameraMat[2], CameraMat[2], Mult
	MatrixMultiplyVertex CamVel, CameraMat, CamVel
	add.xyz		fCamPos, fCamPos, CamVel
	sq.xyz		fCamPos, CameraPos(vi00)
	MatrixTranspose CameraMat, CameraMat
	sub.xyz		fCamPos, vf00, fCamPos
	MatrixMultiplyVertexXYZ1 fCamPos, CameraMat, fCamPos
	add.xyz		CameraMat[3], vf00, fCamPos
.endm

.macro SendSyncGT
	xgkick		vi00
.endm

--enter
--endenter
	fcset		0x000000
	
	ilw.x		iTime, FrameTime(vi00)				; Load the current frame count
	ilw.y		iResetTime, FrameTime(vi00)			; Load the time at which we should reset
	iaddiu		iTime, iTime, 1						; Increment the frame count
	ibne		iTime, iResetTime, dontresettime	; If we have reached the reset count, then reset
	iadd		iTime, vi00, vi00					; Set the current frame to 0
	; Reset the splines
	iaddiu		iSpline, vi00, 0			
	isw.z		iSpline, CamposMarkers(vi00)
	isw.z		iSpline, SplineStuff(vi00)
	ilw.x		iSpline, SplineStuff(vi00)
	isw.w		iSpline, CamposMarkers(vi00)
	ilw.y		iSpline, SplineStuff(vi00)
	isw.w		iSpline, SplineStuff(vi00)			
dontresettime:
	isw.x		iTime, FrameTime(vi00)				; Save the frame count
	
	iaddiu		SplineData, vi00, CamposMarkers
	bal			retaddr, Spline
	add.xyz		fCamEye, fSplineOut, vf00
	
	sq.xyz		fCamEye, CameraPos(vi00)
	
	iaddiu		SplineData, vi00, SplineStuff
	bal			retaddr, Spline
	add.xyz		fCamAt, fSplineOut, vf00
	
	sub.xyz		fCamUp, vf00, vf00
	add.y		fCamUp, fCamUp, vf00[w]
	sub.xyz		CameraMat[2], fCamEye, fCamAt
	VectorNormalize		CameraMat[2], CameraMat[2]
	VectorCrossProduct	CameraMat[0], fCamUp, CameraMat[2]
	VectorCrossProduct	CameraMat[1], CameraMat[2], CameraMat[0]
	add			CameraMat[3], vf00, vf00[x]
	MatrixTranspose CameraMat, CameraMat
	MatrixMultiplyVertexXYZ1  fCamEye, CameraMat, fCamEye
	sub.xyz		CameraMat[3], vf00, fCamEye

	;ManualCamera
	
	MatrixLoad	ProjMat, ProjMatrix, vi00
	lq.xyz		fScales, Scales(vi00)
	VectorLoad	TriCol, LightCol, vi00
	VectorLoad	SpecCol, SpecularCol, vi00
	lq			fLightPos, LightPos(vi00)
	lq.xyz		fCamPos, CameraPos(vi00)
	iaddiu		iOutputBuff, vi00, OutputBuffer
	iaddiu		iTextureGifStuff, vi00, TextureGiftag
	xgkick		iTextureGifStuff
	lq			fAnimRot, CurrRotanim(vi00)
	iaddiu		iGeomCommandPtr, vi00, GeomCommands
	
geomstart:
	ilw.x		iGeomCommand, 0(iGeomCommandPtr)
	ibeq		iGeomCommand, vi00, endgeom
	
ScriptPlane:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptSphere
	
	ilw.y		iNumSegments, 0(iGeomCommandPtr)
	lq.z		fPlaneTex, 0(iGeomCommandPtr)
	ilw.w		iSide, 0(iGeomCommandPtr)
	SetADTex0	fPlaneTex	
	
	lq			fPlaneRot, 1(iGeomCommandPtr)
	QuaternionMultiply   fPlaneRot,fPlaneRot,fAnimRot
	sq			fPlaneRot, 1(iGeomCommandPtr)
	QuaternionToMatrix   fRotMatrix,fPlaneRot
	
	lq			fPlanePretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1 fPlanePretrans, fRotMatrix, fPlanePretrans
	add			fRotMatrix[3], fRotMatrix[3], fPlanePretrans
	lq			fPlanePosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fPlanePosttrans
	
	bal			retaddr, plane
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptSphere:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptCylinder
	
	ilw.y		iNumStacks, 0(iGeomCommandPtr)
	lq.z		fSphereTex, 0(iGeomCommandPtr)
	SetADTex0	fSphereTex
	lq			fSphereRot, 1(iGeomCommandPtr)
	QuaternionMultiply   fSphereRot,fSphereRot,fAnimRot
	sq			fSphereRot, 1(iGeomCommandPtr)
	QuaternionToMatrix   fRotMatrix,fSphereRot
	
	lq			fSpherePretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1 fSpherePretrans, fRotMatrix, fSpherePretrans
	add			fRotMatrix[3], fRotMatrix[3], fSpherePretrans
	lq			fSpherePosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fSpherePosttrans
	
	iaddiu		bHemisphere, vi00, 0
	bal			retaddr, sphere
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptCylinder:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptJump
	ilw.y		iNumStacks, 0(iGeomCommandPtr)
	lq.z		fCylinderTex, 0(iGeomCommandPtr)
	SetADTex0	fCylinderTex
	
	lq			fCylinderRot, 1(iGeomCommandPtr)
	QuaternionMultiply   fCylinderRot,fCylinderRot,fAnimRot
	sq			fCylinderRot, 1(iGeomCommandPtr)
	QuaternionToMatrix   fRotMatrix,fCylinderRot
	
	
	lq			fCylinderPretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1 fCylinderPretrans, fRotMatrix, fCylinderPretrans
	add			fRotMatrix[3], fRotMatrix[3], fCylinderPretrans
	lq			fCylinderPosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fCylinderPosttrans
	
	bal			retaddr, cylinder
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptJump:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptHemiSphere
	ilw.x		iTime, FrameTime(vi00)
	ilw.y		iMin, 0(iGeomCommandPtr)
	ilw.z		iMax, 0(iGeomCommandPtr)
	isub		iDiff, iTime, iMin
	iblez		iDiff, ScriptNoJump
	isub		iDiff, iTime, iMax
	ibgtz		iDiff, ScriptNoJump
	ilw.w		iGeomCommandPtr, 0(iGeomCommandPtr)
	b			geomstart
ScriptNoJump:
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
ScriptHemiSphere:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptSetState
	
	ilw.y		iNumStacks, 0(iGeomCommandPtr)
	lq.z		fSphereTex, 0(iGeomCommandPtr)
	SetADTex0	fSphereTex
	
	lq			fSphereRot, 1(iGeomCommandPtr)
	QuaternionMultiply   fSphereRot,fSphereRot,fAnimRot
	sq			fSphereRot, 1(iGeomCommandPtr)
	QuaternionToMatrix   fRotMatrix,fSphereRot
	
	lq			fSpherePretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1 fSpherePretrans, fRotMatrix, fSpherePretrans
	add			fRotMatrix[3], fRotMatrix[3], fSpherePretrans
	lq			fSpherePosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fSpherePosttrans
	
	iaddiu		bHemisphere, vi00, 1
	bal			retaddr, sphere
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptSetState:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptBox	
	lq.yzw		States, 0(iGeomCommandPtr)
	sq.yzw		States, State(vi00)
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
ScriptBox:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptScale
	lq.z		fPlaneTex, 0(iGeomCommandPtr)
	SetADTex0	fPlaneTex
	lq			fBoxRot, 1(iGeomCommandPtr)
	QuaternionMultiply   fBoxRot,fBoxRot,fAnimRot
	sq			fBoxRot, 1(iGeomCommandPtr)
	QuaternionToMatrix   fRotMatrix,fBoxRot
	lq			fBoxPretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1 fBoxPretrans, fRotMatrix, fBoxPretrans
	add			fRotMatrix[3], fRotMatrix[3], fBoxPretrans
	lq			fBoxPosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fBoxPosttrans
	; For some reason VCL won't let me do this as a loop
	isw.w		vi00,	RepeatCount(vi00)
ScriptBoxLoop:
	; This code is crazy, but its the only way I could get VCL to
	; compile it
	ilw.w		iSide, RepeatCount(vi00)
	iaddiu		iSide, iSide, 1
	iaddiu		iEndLoop, vi00, 7
	isw.w		iSide, RepeatCount(vi00)
	ibeq		iSide, iEndLoop, ScriptBoxVCLKludgeDieKThnxbie
	ilw.w		iSide, RepeatCount(vi00)
	ilw.y		iNumSegments, 0(iGeomCommandPtr)	
	bal			retaddr, plane
	b			ScriptBoxLoop
ScriptBoxVCLKludgeDieKThnxbie:
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptScale:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptPretrans
	lq			fScale, 0(iGeomCommandPtr)
	mr32.xyz	fScale, fScale
	sq.xyz		fScale, CurrScale(vi00)
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
ScriptPretrans:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptPosttrans
	lq			fPretrans, 0(iGeomCommandPtr)
	mr32.xyz	fPretrans, fPretrans
	sq.xyz		fPretrans, CurrPretrans(vi00)
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
ScriptPosttrans:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptAnimquat
	lq			fPosttrans, 0(iGeomCommandPtr)
	mr32.xyz	fPosttrans, fPosttrans
	sq.xyz		fPosttrans, CurrPosttrans(vi00)
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
ScriptAnimquat:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptMultiPlane
	lq			fAnimRot, 1(iGeomCommandPtr)
	sq			fAnimRot, CurrRotanim(vi00)
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptMultiPlane:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, ScriptScreenPoly
	lq.z		fPlaneTex, 0(iGeomCommandPtr)
	SetADTex0	fPlaneTex
	isw.w		vi00, RepeatCount(vi00)
ScriptMPLoop:
	ilw.w		iCount, RepeatCount(vi00)
	iaddiu		iSide, vi00, 0
	iaddiu		iEndLoop, vi00, 7
	iaddiu		iCount, iCount, 1
	isw.w		iCount, RepeatCount(vi00)
	ibeq		iCount, iEndLoop, ExitScriptMPLoop
	ilw.w		iCount, RepeatCount(vi00)
	ilw.y		iNumSegments, 0(iGeomCommandPtr)
	lq			fPlaneRot, 1(iGeomCommandPtr)
	QuaternionMultiply	fPlaneRot, fPlaneRot, fAnimRot
	sq			fPlaneRot, 1(iGeomCommandPtr)
	QuaternionToMatrix	fRotMatrix, fPlaneRot
	lq			fPlanePretrans, CurrPretrans(vi00)
	MatrixMultiplyVertexXYZ1	fPlanePretrans, fRotMatrix, fPlanePretrans
	add			fRotMatrix[3], fRotMatrix[3], fPlanePretrans
	lq			fPlanePosttrans, CurrPosttrans(vi00)
	add			fRotMatrix[3], fRotMatrix[3], fPlanePosttrans
	
	bal			retaddr, plane
	b			ScriptMPLoop
ExitScriptMPLoop:
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 2
	b			geomstart
	
ScriptScreenPoly:
	isubiu		iGeomCommand, iGeomCommand, 1
	ibgtz		iGeomCommand, endgeom
	ilw.y		iFrameStart, 0(iGeomCommandPtr)
	ilw.x		iTime, FrameTime(vi00)
	isub		iPast, iTime, iFrameStart
	mfir		fTime, iPast
	itof0		fTime, fTime
	
	lq.w		fDelta, 0(iGeomCommandPtr)
	mul			fTime, fTime, fDelta[w]
	max			fTime, fTime, vf00[x]
	mini		fTime, fTime, vf00[w]
	loi			128
	mul			fTime, fTime, i
	ftoi0		fTime, fTime
	ilw.z		iCol, 0(iGeomCommandPtr)
	isw.xyz		iCol, SpriteGiftag + 2(vi00)
	sq.w		fTime, SpriteGiftag + 2(vi00)
	iaddiu		iDest, vi00, AlphaAdd
	xgkick		iDest
	iaddiu		iDest, vi00, SpriteGiftag
	xgkick		iDest
	iaddiu		iDest, vi00, AlphaNorm
	xgkick		iDest
	iaddiu		iGeomCommandPtr, iGeomCommandPtr, 1
	b			geomstart
	
endgeom:

el1:
--cont
	b	el1
	
plane:
	mfir.x		fDelta, iNumSegments
	itof0.x		fDelta, fDelta
	ercpr		p, fDelta[x]
	mfp.xy		fDelta, p
	add.xy		fDelta, fDelta, fDelta
	iaddiu		iNLOOP, iNumSegments, 1
	iadd		iNLOOP, iNLOOP, iNLOOP
	InsertGT	OutputBuffer, TriStripGT, iNLOOP
	sub.xy		fRow, vf00, vf00[w]
	iadd		iCurrRow, vi00, vi00
plane_AddRow:
	add.xy		fLastRow, vf00, fRow
	add.y		fRow, fRow, fDelta
	sub.x		fColumn, vf00, vf00[w]
	isubiu		iCurrColumn, vi00, 1
	iaddiu		iOutputBuff, vi00, OutputBuffer+1
plane_AddColumn:
	add.xy		Row, vf00, fRow
	iaddiu		iVertex, vi00, 2
plane_AddVert:
	lq			fTexScale, CurrTexScale(vi00)
	lq			fPlaneScale, CurrScale(vi00)
	mul			fTexScale, fTexScale, fPlaneScale
	iaddiu		iTempSide, iSide, 0
	ibgtz		iTempSide, plane_FRONT
plane_NORMAL:
	add.x		Vert, vf00, fColumn
	add.y		Vert, vf00, Row
	add.zw		Vert, vf00, vf00[x]
	add.xy		Norm, vf00, vf00
	add.z		Norm, vf00, vf00[w]
	mul.xy		STQ, fTexScale, Vert
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_FRONT:
	isubiu		iTempSide, iTempSide, 1
	ibgtz		iTempSide, plane_BACK
	add.x		Vert, vf00, fColumn
	add.y		Vert, vf00, Row
	add.z		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.xy		Norm, vf00, vf00
	add.z		Norm, vf00, vf00[w]
	mul.xy		STQ, fTexScale, Vert
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_BACK:
	isubiu		iTempSide, iTempSide, 1
	ibgtz		iTempSide, plane_RIGHT
	add.x		Vert, vf00, fColumn
	add.y		Vert, vf00, Row				
	sub.z		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.xy		Norm, vf00, vf00
	sub.z		Norm, vf00, vf00[w]
	mul.xy		STQ, fTexScale, Vert
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_RIGHT:
	isubiu		iTempSide, iTempSide, 1
	ibgtz		iTempSide, plane_LEFT
	add.z		Vert, vf00, fColumn[x]
	add.y		Vert, vf00, Row
	add.x		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.yz		Norm, vf00, vf00
	add.x		Norm, vf00, vf00[w]
	
	mul.x		STQ, fTexScale, Vert[z]
	mul.y		STQ, fTexScale, Vert
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_LEFT:
	isubiu		iTempSide, iTempSide, 1
	ibgtz		iTempSide, plane_TOP
	add.z		Vert, vf00, fColumn[x]
	add.y		Vert, vf00, Row
	sub.x		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.yz		Norm, vf00, vf00
	sub.x		Norm, vf00, vf00[w]
	mul.x		STQ, fTexScale, Vert[z]
	mul.y		STQ, fTexScale, Vert
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_TOP:
	isubiu		iTempSide, iTempSide, 1
	ibgtz		iTempSide, plane_BOTTOM
	add.x		Vert, vf00, fColumn[x]
	add.z		Vert, vf00, Row[y]
	add.y		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.xz		Norm, vf00, vf00
	add.y		Norm, vf00, vf00[w]
	mul.x		STQ, fTexScale, Vert
	mul.y		STQ, fTexScale, Vert[z]
	add.z		STQ, vf00, vf00[w]
	b			plane_EndSides
plane_BOTTOM:
	add.x		Vert, vf00, fColumn[x]
	add.z		Vert, vf00, Row[y]
	sub.y		Vert, vf00, vf00[w]
	add.w		Vert, vf00, vf00[x]
	add.xz		Norm, vf00, vf00
	sub.y		Norm, vf00, vf00[w]
	mul.x		STQ, fTexScale, Vert
	mul.y		STQ, fTexScale, Vert[z]
	add.z		STQ, vf00, vf00[w]
plane_EndSides:
	ilw.z		bReverseNormal, ReverseNormals(vi00)
	ibeq		bReverseNormal, vi00, plane_NoReverse
	sub.xyz		Norm, vf00, Norm
plane_NoReverse:
	sub.w		Norm, vf00, vf00
	mul.xyz		Vert, Vert, fPlaneScale
	MatrixMultiplyVertex	Vert, fRotMatrix, Vert
	MatrixMultiplyVertex	Norm, fRotMatrix, Norm
	ilw.y		bSphereMap, SphereMapping(vi00)
	ibeq		bSphereMap, vi00, plane_SkipSM
	add			temp, CameraMat[3], vf00[x]
	add			CameraMat[3], vf00, vf00[x]
	MatrixMultiplyVertexXYZ1 Nprime, CameraMat, Norm
	add			CameraMat[3], temp, vf00[x]
	MatrixMultiplyVertex	View, CameraMat, Vert
	VectorNormalize View, View
	VectorDotProduct	Refl, View, Nprime
	mul.xyz		N, Nprime, Refl
	add.xyz		N, N, N
	sub.xyz		Refl, N, View
	loi			-0.5
	mul.z		STQ, Refl, i
	loi			0.5
	add.z		STQ, STQ, i
	rsqrt		q, vf00[w], STQ[z]
	mul.xyz		STQ, Refl, q
	loi			0.25
	mul.xy		STQ, STQ, i
	loi			0.5
	add.xy		STQ, STQ, i
	add.z		STQ, vf00, vf00[w]
plane_SkipSM:
	bal			retaddr2, ProcessVert
	iaddiu		iOutputBuff, iOutputBuff, 3
	add.xy		Row, vf00, fLastRow
	isubiu		iVertex, iVertex, 1
	ibgtz		iVertex, plane_AddVert
	add.x		fColumn, fColumn, fDelta
	iaddiu		iCurrColumn, iCurrColumn, 1
	ibne		iCurrColumn, iNumSegments, plane_AddColumn
	iaddiu		iGifPacket, vi00, OutputBuffer	
	xgkick		iGifPacket
	iaddiu		iCurrRow, iCurrRow, 1
	ibne		iCurrRow, iNumSegments, plane_AddRow
	jr			retaddr
	
el2:
--cont
	b	el2
	
sphere:
	add.x		fStack, vf00, vf00
	sub.y		fStack, vf00, vf00[w]
	iadd		iNumSlices, iNumStacks, iNumStacks
	mfir		fNumSlices, iNumSlices
	itof0		fNumSlices, fNumSlices
	loi			0x40C90FDB	; 2 * PI
	add			fNumerator, vf00, i
	div			q, fNumerator[x], fNumSlices[x]
	add.xz		fSphereAngles, vf00, q
	AngleSinCos	fSphereAngles, fSphereSinCos
	iaddiu		iNumSlices, iNumSlices, 1	; Sphere
	ibeq		bHemisphere, vi00, NotHemisphere
	iaddiu		iNumSlices, iNumStacks, 1	; Hemisphere	
NotHemisphere:
	add.x		cosnegsin, vf00, fSphereSinCos[y]
	add.y		sincos, vf00, fSphereSinCos[y]
	add.x		sincos, vf00, fSphereSinCos[x]
	sub.y		cosnegsin, vf00, fSphereSinCos[x]	
	iaddiu		iNLOOP, iNumSlices, 0
	iadd		iNLOOP, iNLOOP, iNLOOP
	InsertGT	OutputBuffer, TriStripGT, iNLOOP
	iadd		iCurrStack, vi00, vi00
sphere_AddStack:
	add.xy		fLastStack, vf00, fStack
	mul.xy		dp, fStack, cosnegsin
	mul.xy		dp2, fStack, sincos
	add.x		fStack, dp, dp[y]
	add.y		fStack, dp2, dp2[x]
	add.x		fSlice, vf00, vf00
	add.y		fSlice, vf00, vf00[w]
	iadd		iCurrSlice, vi00, vi00
	iaddiu		iOutputBuff, vi00, OutputBuffer+1
	xgkick		vi00	
sphere_AddSlice:
	add.xy		Stack, vf00, fStack
	iaddiu		iVertex, vi00, 2
sphere_AddVert:
	add.x		Vert, vf00, fSlice
	add.y		Vert, vf00, Stack
	add.z		Vert, vf00, fSlice[y]
	mul.xz		Vert, Vert, Stack[x]
	add.w		Vert, vf00, vf00[x]
	add.xyz		Norm, vf00, Vert
	sub.w		Norm, vf00, vf00
	ilw.z		bReverseNormal, ReverseNormals(vi00)
	ibeq		bReverseNormal, vi00, sphere_NoReverse
	sub.xyz		Norm, vf00, Norm
sphere_NoReverse:
	add.xyz		STQ, vf00, vf00[w]
	ilw.y		bSphereMap, SphereMapping(vi00)
	ibgtz		bSphereMap, sphereSkipTex
	TerribleTerribleArcSin	STQ, Norm
	loi			0x3EA2F983
	mul.xy		STQ, STQ, i
	loi			0.5
	add.xy		STQ, STQ, i	
	add.z		STQ, vf00, vf00[w]
sphereSkipTex:
	lq			fSphereScale, CurrScale(vi00)
	mul.xyz		Vert, Vert, fSphereScale
	MatrixMultiplyVertex	Norm, fRotMatrix, Norm	
	MatrixMultiplyVertex	Vert, fRotMatrix, Vert
	ibeq		bSphereMap, vi00, sphere_SkipSM
	add			temp, CameraMat[3], vf00[x]
	add			CameraMat[3], vf00, vf00[x]
	MatrixMultiplyVertexXYZ1 Nprime, CameraMat, Norm
	add			CameraMat[3], temp, vf00[x]
	MatrixMultiplyVertex	View, CameraMat, Vert
	VectorNormalize View, View
	VectorDotProduct	Refl, View, Nprime
	mul.xyz		N, Nprime, Refl
	add.xyz		N, N, N
	sub.xyz		Refl, N, View
	loi			-0.5
	mul.z		STQ, Refl, i
	loi			0.5
	add.z		STQ, STQ, i
	rsqrt		q, vf00[w], STQ[z]
	mul.xyz		STQ, Refl, q
	loi			0.25
	mul.xy		STQ, STQ, i
	loi			0.5
	add.xy		STQ, STQ, i
	add.z		STQ, vf00, vf00[w]
sphere_SkipSM:
	
	bal			retaddr2, ProcessVert
	
	iaddiu		iOutputBuff, iOutputBuff, 3
	add.xy		Stack, vf00, fLastStack
	isubiu		iVertex, iVertex, 1
	ibgtz		iVertex, sphere_AddVert
	; Rotate the slice
	mul.xy		dp, fSlice, cosnegsin
	mul.xy		dp2, fSlice, sincos
	add.x		fSlice, dp, dp[y]
	add.y		fSlice, dp2, dp2[x]	
	iaddiu		iCurrSlice, iCurrSlice, 1
	ibne		iCurrSlice, iNumSlices, sphere_AddSlice
	iaddiu		iGifPacket, vi00, OutputBuffer	
	xgkick		iGifPacket
	iaddiu		iCurrStack, iCurrStack, 1
	ibne		iCurrStack, iNumStacks, sphere_AddStack
	jr			retaddr
	
el3:
--cont
	b	el3
	
cylinder:
	add.x		fStack, vf00, vf00
	sub.y		fStack, vf00, vf00[w]
	iadd		iNumSlices, iNumStacks, iNumStacks
	mfir		fNumSlices, iNumSlices
	itof0		fNumSlices, fNumSlices
	loi			0x40C90FDB	; 2 * PI
	add			fNumerator, vf00, i
	div			q, fNumerator[x], fNumSlices[x]
	add.xz		fCylinderAngles, vf00, q
	AngleSinCos	fCylinderAngles, fCylinderSinCos
	iaddiu		iNumSlices, iNumSlices, 1
	add.x		cosnegsin, vf00, fCylinderSinCos[y]
	add.y		sincos, vf00, fCylinderSinCos[y]
	add.x		sincos, vf00, fCylinderSinCos[x]
	sub.y		cosnegsin, vf00, fCylinderSinCos[x]	
	iaddiu		iNLOOP, iNumSlices, 0
	iadd		iNLOOP, iNLOOP, iNLOOP
	InsertGT	OutputBuffer, TriStripGT, iNLOOP
	iadd		iCurrStack, vi00, vi00
	ercpr		p, fNumSlices[x]	
	mfp.w		sincos, p			; Store the horizontal texture info in the z,w components
									; Cos we are on the fp register limit
	loi			4.0
	mul.w		sincos, sincos, i
	add.z		sincos, vf00, vf00
cylinder_AddStack:
	add.xy		fLastStack, vf00, fStack
	mul.xy		dp, fStack, cosnegsin
	mul.xy		dp2, fStack, sincos
	add.x		fStack, dp, dp[y]
	add.y		fStack, dp2, dp2[x]
	add.x		fSlice, vf00, vf00
	add.y		fSlice, vf00, vf00[w]
	iadd		iCurrSlice, vi00, vi00
	iaddiu		iOutputBuff, vi00, OutputBuffer+1
	xgkick		vi00	
	add.z		sincos, vf00, vf00
cylinder_AddSlice:
	add.xy		Stack, vf00, fStack
	iaddiu		iVertex, vi00, 2
cylinder_AddVert:
	add.x		Vert, vf00, fSlice
	add.y		Vert, vf00, Stack
	add.z		Vert, vf00, fSlice[y]
	add.w		Vert, vf00, vf00[x]
	add.xz		Norm, vf00, Vert
	sub.yw		Norm, vf00, vf00
	
	ilw.z		bReverseNormal, ReverseNormals(vi00)
	ibeq		bReverseNormal, vi00, cylinder_NoReverse
	sub.xyz		Norm, vf00, Norm
cylinder_NoReverse:
	
	add.x		STQ, vf00, sincos[z]
	add.y		STQ, vf00, Vert	
	add.z		STQ, vf00, vf00[w]
	lq			fCylinderScale, CurrScale(vi00)
	mul.xyz		Vert, Vert, fCylinderScale
	MatrixMultiplyVertex	Vert, fRotMatrix, Vert
	MatrixMultiplyVertex	Norm, fRotMatrix, Norm
	
	ilw.y		bSphereMap, SphereMapping(vi00)
	ibeq		bSphereMap, vi00, cylinder_SkipSM
	add			temp, CameraMat[3], vf00[x]
	add			CameraMat[3], vf00, vf00[x]
	MatrixMultiplyVertexXYZ1 Nprime, CameraMat, Norm
	add			CameraMat[3], temp, vf00[x]
	MatrixMultiplyVertex	View, CameraMat, Vert
	VectorNormalize View, View
	VectorDotProduct	Refl, View, Nprime
	mul.xyz		N, Nprime, Refl
	add.xyz		N, N, N
	sub.xyz		Refl, N, View
	loi			-0.5
	mul.z		STQ, Refl, i
	loi			0.5
	add.z		STQ, STQ, i
	rsqrt		q, vf00[w], STQ[z]
	mul.xyz		STQ, Refl, q
	loi			0.25
	mul.xy		STQ, STQ, i
	loi			0.5
	add.xy		STQ, STQ, i
	add.z		STQ, vf00, vf00[w]
cylinder_SkipSM:
	
	bal			retaddr2, ProcessVert
	iaddiu		iOutputBuff, iOutputBuff, 3
	add.xy		Stack, vf00, fLastStack
	isubiu		iVertex, iVertex, 1
	ibgtz		iVertex, cylinder_AddVert
	; Rotate the slice
	mul.xy		dp, fSlice, cosnegsin
	mul.xy		dp2, fSlice, sincos
	add.x		fSlice, dp, dp[y]
	add.y		fSlice, dp2, dp2[x]
	add.z		sincos, sincos, sincos[w]
	iaddiu		iCurrSlice, iCurrSlice, 1
	ibne		iCurrSlice, iNumSlices, cylinder_AddSlice
	iaddiu		iGifPacket, vi00, OutputBuffer	
	xgkick		iGifPacket
	iaddiu		iCurrStack, iCurrStack, 1
	ibne		iCurrStack, iNumStacks, cylinder_AddStack
	jr			retaddr
	
el4:
--cont
	b	el4
	
ProcessVert:
	sub.xyz		fToLight, fLightPos, Vert
	VectorNormalize fToLight, fToLight
	lq.xyz		fCamPos, CameraPos(vi00)
	sub.xyz		View, fCamPos, Vert
	VectorNormalize View, View
	add.xyz		View, View, fToLight
	VectorNormalize View, View
	VectorDotProduct fSpec, View, Norm
	max.x		fSpec, fSpec, vf00
	mul.x		fSpec, fSpec, fSpec	;2
	mul.x		fSpec, fSpec, fSpec	;4
	mul.x		fSpec, fSpec, fSpec	;8
	mul.x		fSpec, fSpec, fSpec	;16
	mul.x		fSpec, fSpec, fSpec	;32
	mul.x		fSpec, fSpec, fSpec	;64
	mul			iTriSpecular, SpecCol, fSpec[x]

	; Diffuse / Ambient
	VectorDotProduct fDirLight, fToLight, Norm
	max.x		fDirLight, fDirLight, vf00
	loi			0.8
	muli.x		fDirLight, fDirLight, i
	mul			iTriDiffuse, TriCol, fDirLight[x]
	loi			0.2
	mul			iTriAmbient, TriCol, i
	add			iTriCol, iTriAmbient, iTriDiffuse
	add			iTriCol, iTriCol, iTriSpecular
	mini		iTriCol, iTriCol, vf00[w]
	loi			255.0
	muli		iTriCol, iTriCol, i
	loi			128.0
	add.w		iTriCol, vf00, i
	ftoi0		iTriCol, iTriCol
	
	; TRANSFORM
	MatrixMultiplyVertex Vert, CameraMat, Vert
	MatrixMultiplyVertex Vert, ProjMat, Vert
		
	; Sync
	SendSyncGT
	
	; CLIPPING
	clipw.xyz	Vert, Vert
	fcand		vi01, 0x3FFFF
	iaddiu		iADC, vi01, 0x7FFF
	isw.w		iADC, 2(iOutputBuff)
	div         q, vf00[w], Vert[w]
	mulaw.xyz	acc, fScales, Vert
	madd.xyz	Vert, Vert, fScales
	mul.xyz		Vert, Vert, q
	mul.xyz		STQ, STQ, q
	ftoi4.xy	Vert, Vert
	ftoi0.z		Vert, Vert
	sq			iTriCol, 1(iOutputBuff)
	sq.xyz		STQ, 0(iOutputBuff)
	sq.xyz		Vert, 2(iOutputBuff)
	jr			retaddr2
	
el5:
--cont
	b	el5

; Works out a spline position based on the data held at the address "SplineData"
Spline:
	ilw.w		iSplinePtr, 0(SplineData)			; Load the current spline pointer
loadspline:
	ilw.w		iSplinePosCount, 0(iSplinePtr)		; Load how many frames this spline should be used for
	ibgtz		iSplinePosCount, splinefine
	
	; If the spline pos count is zero, try the next spline
	iaddiu		iSplinePtr, iSplinePtr, 1
	b			loadspline
	
splinefine:
	ilw.z		iSplinePC, 0(SplineData)		; Load the current spline count
	iaddiu		iSplinePC, iSplinePC, 1				; Increment the current spline count
	ibne		iSplinePC, iSplinePosCount, samespline	; If we have reached the max spline count, move to the next spline
	iaddiu		iSplinePtr, iSplinePtr, 1			; Move the spline pointer along one
	isw.w		iSplinePtr, 0(SplineData)		; Then save it
	iadd		iSplinePC, vi00, vi00				; Reset the current spline counter to 0
samespline:
	isw.z		iSplinePC, 0(SplineData)		; Save the current spline counter
	mfir.x		fTime, iSplinePC
	itof0.x		fTime, fTime						; Convert the spline counter to floating point
	mfir.x		fSplineTime, iSplinePosCount
	itof0.x		fSplineTime, fSplineTime
	div			q, fTime[x], fSplineTime[x]			; Current spline count / total spline count = num between 0.0 and 1.0
	add			coeff, vf00, q	
	add.w		coeff, vf00, vf00[x]
	mul.y		coeff, coeff, coeff[z]
	mul.x		coeff, coeff, coeff[y]
	MatrixLoad	SplineMat, SplineMatrix, vi00
	MatrixMultiplyVertex	fSplineOut, SplineMat, coeff
	lq			SplinePosMat[0], -1(iSplinePtr)
	lq			SplinePosMat[1], 0(iSplinePtr)
	lq			SplinePosMat[2], 1(iSplinePtr)
	lq			SplinePosMat[3], 2(iSplinePtr)
	MatrixMultiplyVertex	fSplineOut, SplinePosMat, fSplineOut
	jr			retaddr
	
--exit
--endexit