NullGifTag			.equ 0
State				.equ 1
SpriteGiftag		.equ 700
Tex0				.equ 701
SpriteCol			.equ 702
SpriteUV1			.equ 703
SpritePos1			.equ 704
SpriteUV2			.equ 705
SpritePos2			.equ 706
OffsetXYAD			.equ 707
OffsetXY			.equ 708
FloatOffsetXY		.equ 709
SpriteSize			.equ 710
Tex0Offsets			.equ 711
PointGiftag			.equ 712
PointColour			.equ 713
PointPosition		.equ 714
FrameTag			.equ 715
Frame				.equ 716
ColourScale			.equ 717
UV0_0				.equ 718
UV128_128			.equ 719
UnitColour			.equ 720
Tex1Tag				.equ 721
Tex1				.equ 722
FrameConstants		.equ 723
TextureSize			.equ 724
BlurCol				.equ 725
ColourSprite		.equ 726
AlphaGT				.equ 730
AlphaFunc			.equ 731
TexturedPointGT		.equ 732
TexturedPointUV		.equ 733
TexturedPointPos	.equ 734
Tex0ADTag			.equ 735
Tex0AD				.equ 736
RadialConsts		.equ 737
TexFlush			.equ 738
RGtoBARegs			.equ 740
RGtoBAUV0			.equ 747
RGtoBAPOS0			.equ 748
RGtoBAUV1			.equ 749
RGtoBAPOS1			.equ 750
ResetTex0			.equ 751
TexCommands			.equ 752

FreeSpace			.equ 800
HarnessInfo			.equ 1023

CPSelect			.equ H'0001
CPStart				.equ H'0008
CPUp				.equ H'0010
CPRight				.equ H'0020
CPDown				.equ H'0040
CPLeft				.equ H'0080
CPL2				.equ H'0100
CPR2				.equ H'0200
CPL1				.equ H'0400
CPR1				.equ H'0800
CPTriangle			.equ H'1000
CPCircle			.equ H'2000
CPCross				.equ H'4000
CPSquare			.equ H'7FFF

.include "vcl_sml.i"

.init_vf_all
.init_vi_all
.syntax new

.vu

.macro SetSpriteTex0Imm	imm
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	loi			\imm
	muli.y		fTex0Offsets, fTex0Offsets, i
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0(vi00)
.endm

.macro SetSpriteTex0	reg
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	mul.y		fTex0Offsets, fTex0Offsets, \reg[z]
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0(vi00)
.endm

.macro SetADTex0	reg
	lq.xyz		fTex0Offsets, Tex0Offsets(vi00)
	itof0.x		fTex0TBP, fTex0Offsets
	mul.y		fTex0Offsets, fTex0Offsets, \reg[z]
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0AD(vi00)
	iaddiu		iDest, vi00, Tex0ADTag
	xgkick		iDest
.endm

.macro SetFrame reg
	lq.xy		fFrameConsts, FrameConstants(vi00)
	mul.y		fFrameOffset, fFrameConsts, \reg
	add.x		fFrameConsts, fFrameConsts, fFrameOffset[y]
	ftoi0.x		fFrameConsts, fFrameConsts
	sq.x		fFrameConsts, Frame(vi00)
	iaddiu		iDest, vi00, FrameTag
	xgkick		iDest
.endm

--enter
--endenter

START:
; TEXTURE GENERATOR INITIALISATION
	ilw.x		curstate, State(vi00)
	ibne		curstate, vi00, mainloop  ; If we have already initialised then go to the main loop
	iaddiu		iDest, vi00, OffsetXYAD
	xgkick		iDest
	loi			2925896
	addi.x		fRandseed, vf00, i
	rinit		R, fRandseed[x]
	iaddiu		iDest, vi00, Tex1Tag
	xgkick		iDest
; END INIT

; COMMANDS START
	iaddiu		iTexCommandPtr, vi00, TexCommands
	
texgenstart:
	iaddiu		iDest, vi00, TexFlush
	xgkick		iDest
	ilw.x		iTexCommand, 0(iTexCommandPtr)
	ibeq		iTexCommand, vi00, texgenend
	
Noise:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Copy
	lq.y		fDest, 0(iTexCommandPtr)
	lq			fNoiseColour, 1(iTexCommandPtr)
	bal			retaddr, DoNoise
	iaddiu		iTexCommandPtr, iTexCommandPtr, 2
	b			texgenstart
	
Copy:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Blur
	lq.y		fDest, 0(iTexCommandPtr)
	lq.z		fSrc, 0(iTexCommandPtr)
	lq			fCopyColour, 1(iTexCommandPtr)
	lq.xy		fTexOffset, 2(iTexCommandPtr)
	bal			retaddr, DoCopy
	iaddiu		iTexCommandPtr, iTexCommandPtr, 3
	b			texgenstart
	
Blur:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Fill
	lq.y		fDest, 0(iTexCommandPtr)
	lq.z		fSrc, 0(iTexCommandPtr)
	bal			retaddr, DoBlur
	iaddiu		iTexCommandPtr, iTexCommandPtr, 1
	b			texgenstart
	
Fill:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Alpha
	lq.y		fDest, 0(iTexCommandPtr)
	SetFrame	fDest
	lq			fFillColour, 1(iTexCommandPtr)
	xgkick		vi00
	sq			fFillColour, ColourSprite+1(vi00)
	iaddiu		iDest, vi00, ColourSprite
	xgkick		iDest
	iaddiu		iTexCommandPtr, iTexCommandPtr, 2
	b			texgenstart
		
Alpha:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Distort
	lq.yz		fAlpha, 0(iTexCommandPtr)
	mr32.xy		fAlpha, fAlpha
	sq.xy		fAlpha, AlphaFunc(vi00)
	iaddiu		iDest, vi00, AlphaGT
	xgkick		iDest
	iaddiu		iTexCommandPtr, iTexCommandPtr, 1
	b			texgenstart
	
Distort:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Radial
	lq.y		fDest, 0(iTexCommandPtr)
	lq.z		fSrc, 0(iTexCommandPtr)
	lq			fDistParams, 1(iTexCommandPtr)
	bal			retaddr, DoDistort
	iaddiu		iTexCommandPtr, iTexCommandPtr, 2
	b			texgenstart

Radial:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, Plasma
	lq.y		fDest, 0(iTexCommandPtr)
	bal			retaddr, DoRadial
	iaddiu		iTexCommandPtr, iTexCommandPtr, 1
	b			texgenstart
		
Plasma:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, PingPongBlur
	lq.y		fDest, 0(iTexCommandPtr)
	lq			fPlasmaParams, 1(iTexCommandPtr)
	lq			fPlasmaColour, 2(iTexCommandPtr)
	bal			retaddr, DoPlasma
	iaddiu		iTexCommandPtr, iTexCommandPtr, 3
	b			texgenstart
	
PingPongBlur:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, RGtoBA
	lq.y		fDest, 0(iTexCommandPtr)
	lq.z		fSrc, 0(iTexCommandPtr)
	ilw.w		iBlurCount, 0(iTexCommandPtr)
	lq			fCopyColour, UnitColour(vi00)
	add.xy		fTexOffset, vf00, vf00
ppbstart:
	add.y		fTemp, vf00, fSrc[z]
	add.z		fSrc, vf00, fDest[y]
	add.y		fDest, vf00, fTemp
	bal			retaddr, DoCopy
	xgkick		vi00
	add.y		fTemp, vf00, fSrc[z]
	add.z		fSrc, vf00, fDest[y]
	add.y		fDest, vf00, fTemp
	bal			retaddr, DoBlur
	isubiu		iBlurCount, iBlurCount, 1
	ibgtz		iBlurCount, ppbstart
	iaddiu		iTexCommandPtr, iTexCommandPtr, 1
	b			texgenstart
	
RGtoBA:
	isubiu		iTexCommand, iTexCommand, 1
	ibgtz		iTexCommand, texgenend
	lq.y		fDest, 0(iTexCommandPtr)
	lq.z		fSrc, 0(iTexCommandPtr)
	bal			retaddr, DoRGtoBA
	iaddiu		iTexCommandPtr, iTexCommandPtr, 1
	b			texgenstart
		
texgenend:
	iaddiu		curstate, vi00, 1
	isw.x		curstate, State(vi00)
	
; Stop VCL from running into the plane function and dying (thanks Exoticorn)	
eternalloop:
--cont
	b eternalloop

DoNoise:
	SetFrame	fDest
	iaddiu		iDest, vi00, PointGiftag
	iaddiu		iNoiseEnd, vi00, 128
	iaddiu		iNoiseY, vi00, 0
	sub.y		fNoisePos, vf00, vf00
noiseY:
	iaddiu		iNoiseX, vi00, 0
	sub.x		fNoisePos, vf00, vf00
noiseX:
	rnext		vf00, R
	rnext		vf00, R
	rnext		vf00, R
	rnext		fRandVal, R
	sub			fRandVal, fRandVal, vf00[w]
	mul			fColour, fNoiseColour, fRandVal
	loi			128
	add.w		fColour, vf00, i
	ftoi0		fColour, fColour
	xgkick		vi00
	sq			fColour, PointColour(vi00)
	ftoi4.xy	NoisePos, fNoisePos
	sq.xy		NoisePos, PointPosition(vi00)	
	xgkick		iDest
	add.x		fNoisePos, fNoisePos, vf00[w]	
	iaddiu		iNoiseX, iNoiseX, 1
	ibne		iNoiseX, iNoiseEnd, noiseX
	add.y		fNoisePos, fNoisePos, vf00[w]
	iaddiu		iNoiseY, iNoiseY, 1
	ibne		iNoiseY, iNoiseEnd, noiseY
	jr			retaddr
; END NOISE
	
DoCopy:
	SetFrame	fDest
	SetSpriteTex0 fSrc
	xgkick		vi00
	lq.xy		fUV, UV0_0(vi00)
	itof4.xy	fUV, fUV
	add.xy		fUV, fUV, fTexOffset
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV1(vi00)
	lq.xy		fUV, UV128_128(vi00)
	itof4.xy	fUV, fUV
	add.xy		fUV, fUV, fTexOffset
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV2(vi00)
	sq			fCopyColour, SpriteCol(vi00)
	lq.xy		fSpriteSize, TextureSize(vi00)
	add.xy		fSpritePos, vf00, vf00
	ftoi4.xy	SpritePos, fSpritePos
	sq.xy		SpritePos, SpritePos1(vi00)
	ftoi4.xy	SpritePos, fSpriteSize
	sq.xy		SpritePos, SpritePos2(vi00)
	iaddiu		iDest, vi00, SpriteGiftag
	xgkick		iDest
	xgkick		vi00
	jr			retaddr
; END COPY

DoBlur:
	SetFrame	fDest
	SetSpriteTex0 fSrc
	xgkick		vi00
	lq			fBlurColour, BlurCol(vi00)
	sq			fBlurColour, SpriteCol(vi00)
	lq.xy		fSpriteSize, TextureSize(vi00)
	ftoi4.xy	SpritePos, vf00
	sq.xy		SpritePos, SpritePos1(vi00)
	ftoi4.xy	SpritePos, fSpriteSize
	sq.xy		SpritePos, SpritePos2(vi00)
	iaddiu		iDest, vi00, SpriteGiftag
	loi			0x3FAAAAAB
	lq.xy		fUV, UV0_0(vi00)
	itof4.xy	fUV, fUV
	addi.y		fUV, fUV, i
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV1(vi00)
	lq.xy		fUV, UV128_128(vi00)
	itof4.xy	fUV, fUV
	addi.y		fUV, fUV, i
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV2(vi00)
	xgkick		iDest
	xgkick		vi00
	lq.xy		fUV, UV0_0(vi00)
	itof4.xy	fUV, fUV
	addi.x		fUV, fUV, i
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV1(vi00)
	lq.xy		fUV, UV128_128(vi00)
	itof4.xy	fUV, fUV
	addi.x		fUV, fUV, i
	ftoi4.xy	fUV, fUV
	sq.xy		fUV, SpriteUV2(vi00)
	xgkick		iDest
	
	jr			retaddr
; END BLUR

DoDistort:
	SetFrame	fDest
	SetADTex0	fSrc
	iaddiu		iDest, vi00, TexturedPointGT
	iaddiu		iDistEnd, vi00, 128
	iaddiu		iDistY, vi00, 0
	sub			fOffset, vf00, vf00
	sub.y		fDistPos, vf00, vf00
distY:
	iaddiu		iDistX, vi00, 0
	sub.x		fDistPos, vf00, vf00
	sub.x		fOffset, vf00, vf00
distX:
	ftoi4.xy	DistPos, fDistPos
	xgkick		vi00
	sq.xy		DistPos, TexturedPointPos(vi00)
	add.x		fOffset, fOffset, fDistParams
	AngleSinCos	fOffset, fSincos
	mul.x		fSincos, fSincos, fDistParams[y]
	mul.z		fSincos, fSincos, fDistParams[w]
	add.xy		fDistUV, vf00, fDistPos
	add.y		fDistUV, fDistUV, fSincos[x]
	add.x		fDistUV, fDistUV, fSincos[z]
	loi			0.5
	addi.xy		fDistUV, fDistUV, i
	ftoi4.xy	fDistUV, fDistUV
	sq.xy		fDistUV, TexturedPointUV(vi00)
	xgkick		iDest
	add.x		fDistPos, fDistPos, vf00[w]	
	iaddiu		iDistX, iDistX, 1
	ibne		iDistX, iDistEnd, distX
	add.z		fOffset, fOffset, fDistParams
	add.y		fDistPos, fDistPos, vf00[w]
	iaddiu		iDistY, iDistY, 1
	ibne		iDistY, iDistEnd, distY
	jr			retaddr
; END DISTORT

DoRadial:
	SetFrame	fDest
	iaddiu		iDest, vi00, PointGiftag
	iaddiu		iRadialEnd, vi00, 128
	iaddiu		iRadialY, vi00, 0
	sub.y		fRadialPos, vf00, vf00
	lq			fRadialConsts, RadialConsts(vi00)
RadialY:
	iaddiu		iRadialX, vi00, 0
	sub.x		fRadialPos, vf00, vf00
RadialX:
	sub.xy		fDist, fRadialPos, fRadialConsts
	mul.xy      fDist, fDist, fDist
	add.x		fDist, fDist, fDist[y]
	sqrt		q, fDist[x]
	add			fColour, vf00, q
	mul			fColour, fColour, fRadialConsts[z]
	loi			255.0
	addi		fOne, vf00, i
	sub  		fColour, fOne, fColour
	max 		fColour, fColour, vf00
	loi			128
	add.w		fColour, vf00, i
	ftoi0		fColour, fColour
	xgkick		vi00
	sq			fColour, PointColour(vi00)
	ftoi4.xy	RadialPos, fRadialPos
	sq.xy		RadialPos, PointPosition(vi00)	
	xgkick		iDest
	add.x		fRadialPos, fRadialPos, vf00[w]	
	iaddiu		iRadialX, iRadialX, 1
	ibne		iRadialX, iRadialEnd, RadialX
	add.y		fRadialPos, fRadialPos, vf00[w]
	iaddiu		iRadialY, iRadialY, 1
	ibne		iRadialY, iRadialEnd, RadialY
	jr			retaddr
; END RADIAL

DoPlasma:
	SetFrame	fDest
	iaddiu		iDest, vi00, PointGiftag
	iaddiu		iPlasmaEnd, vi00, 128
	iaddiu		iPlasmaY, vi00, 0
	sub.y		fPlasmaPos, vf00, vf00
	sub			fPlasma, vf00, vf00
PlasmaY:
	iaddiu		iPlasmaX, vi00, 0
	sub.x		fPlasmaPos, vf00, vf00
	sub.x		fPlasma, vf00, vf00
PlasmaX:
	ftoi4.xy	PlasmaPos, fPlasmaPos
	xgkick		vi00
	sq.xy		PlasmaPos, PointPosition(vi00)	
	AngleSinCos	fPlasma, fSinCos
	add.x		fSinCos, fSinCos, fSinCos[z] ; -2 to 2
	add.x		fSinCos, fSinCos, vf00[w]
	add.x		fSinCos, fSinCos, vf00[w]	; 0 to 4
	loi			63.7
	muli.x		fSinCos, fSinCos, i
	add			fColour, vf00, fSinCos[x]
	mul			fColour, fColour, fPlasmaColour
	loi			128
	add.w		fColour, vf00, i
	ftoi0		Colour, fColour
	sq			Colour, PointColour(vi00)
	xgkick		vi00
	xgkick		iDest
	add.x		fPlasmaPos, fPlasmaPos, vf00[w]
	add.x		fPlasma, fPlasma, fPlasmaParams[x]
	iaddiu		iPlasmaX, iPlasmaX, 1
	ibne		iPlasmaX, iPlasmaEnd, PlasmaX
	add.y		fPlasmaPos, fPlasmaPos, vf00[w]
	add.z		fPlasma, fPlasma, fPlasmaParams
	iaddiu		iPlasmaY, iPlasmaY, 1
	ibne		iPlasmaY, iPlasmaEnd, PlasmaY
	jr			retaddr
; END PLASMA

DoRGtoBA:
	
	lq.y		fFrameConsts, FrameConstants(vi00)
	mul.y		fFrameOffset, fFrameConsts, fDest
	
	lq.x		fFrameConsts, RGtoBARegs + 1(vi00)	
	itof0.x		fFrameConsts, fFrameConsts
	add.x		fFrameConsts, fFrameConsts, fFrameOffset[y]
	ftoi0.x		fFrameConsts, fFrameConsts
	sq.x		fFrameConsts, RGtoBARegs + 1(vi00)	
	
	iaddiu		iDest, vi00, RGtoBARegs
	xgkick		iDest
	
	lq.yz		fTex0Offsets, Tex0Offsets(vi00)
	lq			fTex0, RGtoBARegs + 2(vi00)
	itof0.x		fTex0TBP, fTex0
	mul.y		fTex0Offsets, fTex0Offsets, fSrc[z]
	add.x		fTex0TBP, fTex0TBP, fTex0Offsets[y]
	ftoi0.x		Tex0TBP, fTex0TBP
	sq.x		Tex0TBP, Tex0(vi00)
	sq.yzw		fTex0, Tex0(vi00)
	
	iaddiu		iVertStrip, vi00, 0
	iaddiu		iVertStrips, vi00, 16
	
	loi			256
	add.x		fOffset, vf00, vf00

VertStrip:
	xgkick		vi00
	lq.xy		fUV, RGtoBAUV0(vi00)
	add.x		fUV, fUV, fOffset
	ftoi0.xy	fUV, fUV
	sq.xy		fUV, SpriteUV1(vi00)
	lq.xy		fUV, RGtoBAUV1(vi00)
	add.x		fUV, fUV, fOffset
	ftoi0.xy	fUV, fUV
	sq.xy		fUV, SpriteUV2(vi00)
	lq			fCopyColour, UnitColour(vi00)
	sq			fCopyColour, SpriteCol(vi00)
	lq.xy		SpritePos, RGtoBAPOS0(vi00)
	add.x		SpritePos, SpritePos, fOffset
	ftoi0.xy	SpritePos, SpritePos
	sq.xy		SpritePos, SpritePos1(vi00)
	lq.xy		SpritePos, RGtoBAPOS1(vi00)
	add.x		SpritePos, SpritePos, fOffset
	ftoi0.xy	SpritePos, SpritePos
	sq.xy		SpritePos, SpritePos2(vi00)
	iaddiu		iDest, vi00, SpriteGiftag
	xgkick		iDest
	
	addi.x		fOffset, fOffset, i
	
	iaddiu		iVertStrip, iVertStrip, 1
	ibne		iVertStrip, iVertStrips, VertStrip
	
	lq			fTex0, ResetTex0(vi00)
	sq			fTex0, Tex0(vi00)
	
	jr			retaddr
; END COPY
	
mainloop:

--exitm
--endexit


