// makedata.C
// Fabian Roth, fin@envoy.ch, 2003

// creates .dat and .i file for bubble.vcl
// change if you dare ;-)
// try the consts and refract qwords for a start - its fun
// also try some other tiles by including another pic/*.h file

#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>

#include "sphere.h"

//#include "pic/tilemuster.h"
#include "pic/tilekachel.h"
//#include "pic/mosaic.h"

void createPerspectiveMatrix(float m[][4]);
void writeTile(ostream &o);

int nfaces;
int nedges;
int nverts;
 




int main() {

  ofstream o("./bubble.dat");
  ofstream inc("./bubble.i");

  cout << "int: " << sizeof(int) << '\n';
  cout << "float: " << sizeof(float) << '\n';
  cout << "double: " << sizeof(double) << '\n';
  cout << "long: " << sizeof(long) << '\n';
  cout << "long long: " << sizeof(long long) << '\n';


  int qwordcounter = 0;

  inc << "; include file for particles.vcl\n";
  inc << "; created by makedata - do not edit!\n";
  inc << '\n';

  inc << "triangGifpacket .assign " << qwordcounter << '\n';
  int giftag[4];

  giftag[0] = 0x00008003;            // EOP = 1, NLOOP = 3 
  //  giftag[1] = 0x2005c000;            // NREG=2, PRIM=triang, PRE=0, gouraud
  //  giftag[1] = 0x2001c000;            // NREG=2, PRIM=triang, PRE=0, flat
  //  giftag[1] = 0x3001c000;            // NREG=3, PRIM=triang, PRE=0, flat
  //  giftag[1] = (3<<28) | (1<<14) | (0xb << 15);
  giftag[1] = (3<<28) | (1<<14) | (0x1b << 15);
  //  giftag[1] = 0x3009c000;
  //  giftag[1] = 0x30004000;
  //  giftag[1] = 0x3003c000;
  //  giftag[2] = 0x00000051;            // REGS={RGBAQ,XYZ2}
  giftag[2] = 0x00000512;            // REGS={ST,RGBAQ,XYZ2}
  giftag[3] = 0x00000000;            // 

  float empty[4] = { .0f, .0f, .0f, .0f};
  //  float color[4] = { 255.0f, 0.0f, 120.0f, 255.0f };
  //  float color[4] = { 150.0f, 100.0f, 120.0f, 255.0f };
  float color[4] = { 255.0f, 255.0f, 255.0f, 48.0f };
  float colorBG[4] = { 0.0f, 20.0f, 120.f, 255.0f };
  float st0[4] = { -6.0f, 12.0f, 1.0f, 0.0f };
  float st1[4] = { 6.0f, 12.0f, 1.0f, 0.0f };
  float st2[4] = { -6.0f, -12.0f, 1.0f, 0.0f };
  float st3[4] = { 6.0f, -12.0f, 1.0f, 0.0f };

  o.write((char *)giftag, sizeof(int)*4);


  o.write((char *)st0, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)st1, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)st2, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);

  qwordcounter += 10;

  inc << "atags  .assign " << qwordcounter << '\n';

  giftag[0] = ((3<<28) | (1<<14) | (0x1b << 15));   // triangle, texturing
  giftag[1] = ((3<<28) | (1<<14) | (0x0a << 15));   // linestrip, flat
  giftag[2] = ((3<<28) | (1<<14) | (0x43 << 15));   // triangle, flat, with alpha
  giftag[3] = ((3<<28) | (1<<14) | (0x42 << 15));   // linestrip, flat, with alpha

  o.write((char *)giftag, sizeof(int)*4);
  qwordcounter++;


  inc << "WallCoords  .assign " << qwordcounter << '\n';

  float coords[4][4] = { { -8.0, 8.0, 4.0, 1.0},
			 { 8.0, 8.0, 4.0, 1.0},
			 { -8.0, -8.0, 4.0, 1.0},
			 { 8.0, -8.0, 4.0, 1.0}};
//   float coords[4][4] = { { -0.0, 2.0, -5.0, 1.0},
// 			 { 0.0, 2.0, -5.0, 1.0},
// 			 { -.1, -2.0, 5.0, 1.0},
// 			 { .1, -2.0, 5.0, 1.0}};
//   float coords[4][4] = { { -2.0, 1.0, -2.0, 1.0},
// 			 { 2.0, 1.0, -2.0, 1.0},
// 			 { -2.0, -1.0, 2.0, 1.0},
// 			 { 2.0, -1.0, 2.0, 1.0}};

  o.write((char *)coords[0], sizeof(float)*4);
  o.write((char *)coords[1], sizeof(float)*4);
  o.write((char *)coords[2], sizeof(float)*4);
  o.write((char *)coords[3], sizeof(float)*4);

  qwordcounter += 4;

  inc << "WallTexCoords  .assign " << qwordcounter << '\n';
  o.write((char *)st0, sizeof(float)*4);
  o.write((char *)st1, sizeof(float)*4);
  o.write((char *)st2, sizeof(float)*4);
  o.write((char *)st3, sizeof(float)*4);
  
  qwordcounter +=4;

  inc << "BackWall  .assign " << qwordcounter << '\n';

//    giftag[0] = 0x00008004;            // EOP = 1, NLOOP = 2
//    giftag[1] = (3<<28) | (1<<14) | (0x16 << 15); // 3 regs, prim=1, TEXTURE MAPPING ON, tristrip
//    giftag[2] = 0x00000512;            // REGS={ST,RGBAQ,XYZ2}
//    giftag[3] = 0x00000000;            // 

//   o.write((char *)giftag, sizeof(int)*4);

//   o.write((char *)st0, sizeof(float)*4);
//   o.write((char *)color, sizeof(float)*4);
//   o.write((char *)empty, sizeof(float)*4);
//   o.write((char *)st3, sizeof(float)*4);
//   o.write((char *)color, sizeof(float)*4);
//   o.write((char *)empty, sizeof(float)*4);

//   qwordcounter +=7;


  giftag[0] = 0x00008004;            // EOP = 1, NLOOP = 4 
  giftag[1] = (3<<28) | (1<<14) | (0x14 << 15); // 3 regs, prim=1, TEXTURE MAPPING ON, tristrip
  giftag[2] = 0x00000512;            // REGS={ST,RGBAQ,XYZ2}
  giftag[3] = 0x00000000;            // 

  o.write((char *)giftag, sizeof(int)*4);

  o.write((char *)st0, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)st1, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)st2, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)st3, sizeof(float)*4);
  o.write((char *)color, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);

  qwordcounter += 13;
  

  inc << "ZBufTag  .assign " << qwordcounter << '\n';
  // gs_init stuff:
  giftag[0] = 0x00008002;             // EOP=1,NLOOP = 2
  giftag[1] = 0x10000000;             // NREG=1 (A+D)
  giftag[2] = 0x0000000e;             // REGS=A+D
  giftag[3] = 0x00000000;

 o.write((char *)giftag, sizeof(int)*4);
  
  int data[4];
  data[0] = 140;                      // address of Zbuffer
  data[1] = 0x00000000;
  data[2] = 0x0000004e;               // ZBUF_1
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(int)*4);

  data[0] = 5<<16;                  // ztst = GEQUAL, ZTE=ON
  data[1] = 0x00000000;
  data[2] = 0x00000047;               // TEST_1
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(int)*4);

  qwordcounter += 3;

  inc << "ClrTag  .assign " << qwordcounter << " ; sprite prim\n";
  data[0]=0x00008001;                 // EOP=1, NLOOP=1
  //  data[1]= 0x30034000;
  data[1] = (3<<28) | (6<<15) | (1 <<14 ); // NREG=3, PRIM=sprite, PRE=1
  data[2] = 0x0000551;            // REGS={RGBAQ, XYZ2, XYZ2}
  data[3] = 0x0000000;
  o.write((char *)data, sizeof(int)*4);
  
  // write colorBG to RGBAQ
  o.write((char *)colorBG, sizeof(float)*4);
  // 2* empty. these values will be added at runtime
  o.write((char *)empty, sizeof(float)*4);
  o.write((char *)empty, sizeof(float)*4);
  qwordcounter+= 4;

  inc << "NopTag  .assign " << qwordcounter << '\n';
  data[0] = 0x00008001;               //
  data[1] = (1<<28) ;
  data[2] = 0x0000000f;
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);
  qwordcounter+=1;

  

  inc << "aconsts  .assign " << qwordcounter << '\n';

  float consts[4];
  // octa 2*divide
//   consts[0] = .02;  // tau
//   consts[1] = 10; // spring const
//   consts[2] = .3; // beta
//   consts[3] = .6; // pressure
  consts[0] = .05;  // tau
  consts[1] = 4; // spring const
  consts[2] = .19; // beta
  consts[3] = .4; // pressure
//   consts[0] = .05;  // tau
//   consts[1] = 6; // spring const
//   consts[2] = .2; // beta
//   consts[3] = .6; // pressure

  o.write((char *)consts, sizeof(float)*4);
  qwordcounter++;

  inc << "acamconsts  .assign " << qwordcounter << '\n';
  // camera stuff
  consts[0] = .1;  // tau
  consts[1] = .7;   // spring
  consts[2] = .5;   // beta
  consts[3] = .1;   // attractor
    
  o.write((char *)consts, sizeof(float)*4);
  qwordcounter++;

  inc << "acol  .assign " << qwordcounter << '\n';


  o.write((char *)color, sizeof(float)*4);
  qwordcounter++;

  inc << "alight  .assign " << qwordcounter << '\n';

  
//   float lx = 1.0/sqrt(5);
//   float lz = 1.0/sqrt(3.0/5.0);
  float lx = 1.0/sqrt(4.0);
  float lz = 1.0/sqrt(2.0);
  float light[4] = { lx, lx, -lz, .0f };
  //  float light[4] = { .5f, .5f, -.5f, .0f };
  //  float light[4] = { .8f, .8f, .8f, .0f };
  o.write((char *)light, sizeof(float)*4);
  qwordcounter++;

  inc << "aangles  .assign " << qwordcounter << '\n';
  
  float angles[4] = { .0f, .0f, .0f, .0f };
  o.write((char *)angles, sizeof(float)*4);
  qwordcounter++;

  inc << "arefract  .assign " << qwordcounter << '\n';
  float refract[4];
  refract[0] = .6f;    // diam
  refract[1] = 4.0f;    // dist to map
  refract[2] = 0.0f;
  refract[3] = 1.33f;   // refraction coefficient
//  refract[3] = .7f;   // refraction coefficient

  o.write((char *)refract, sizeof(float)*4);
  qwordcounter++;

  inc << "ascrmat  .assign " << qwordcounter << '\n';


  float cam_scr[4][4] = { 
    0.0f, 0.0f, 0.0f, 0.0f,
    0.0f, 0.0f, 0.0f, 0.0f,
    0.0f, 0.0f, 0.0f, 0.0f,
    0.0f, 0.0f, 0.0f, 0.0f
  };

  createPerspectiveMatrix(cam_scr);

  o.write((char *)cam_scr, 16*sizeof(float));
  qwordcounter += 4;

  inc << "startgeom  .assign " << qwordcounter << '\n';

  //  initOctahedron();
  //  initTetrahedron();
  initIcosahedron();
  Face::doDivision();
  //  Face::doDivision();

  nfaces = Face::all.size();
  nedges = Edge::all.size();
  nverts = Vertex::all.size();

  inc << "nsurfs .assign " << nfaces << '\n';
  inc << "nedges .assign " << nedges << '\n';
  inc << "nverts .assign " << nverts << '\n';

  Face::dumpAll(o);
  Face::printAll(cout);
  cout << "; facenormals, empty for now("<<nfaces<<")\n";
  for (int i=0;i<nfaces;i++) {
    cout << ".int 0,0,0,0\n";
    o.write((char *)empty,4*sizeof(float));
  }
  Edge::printAll(cout);
  Edge::dumpAll(o);
  Vertex::printAll(cout);
  Vertex::dumpAll(o);
  // these just to fill space for normals, vels and forces
  Vertex::spaceAll(o);
  Vertex::spaceAll(o);
  Vertex::spaceAll(o);

  cout << "last qword before geom: " << qwordcounter << endl;
  cout << "after faces " << (qwordcounter+=nfaces) << endl;
  cout << "after facenormals " << (qwordcounter+=nfaces) << endl;
  cout << "after edges " << (qwordcounter+=nedges) << endl;
  cout << "after vertices " << (qwordcounter+=nverts) << endl;
  cout << "after vertexnormals " << (qwordcounter+=nverts) << endl;
  cout << "after vertexvels " << (qwordcounter+=nverts) << endl;
  cout << "after vertexforces " << (qwordcounter+=nverts) << endl;


  int npixels = height*width;
  int pixel64 = npixels/64;

  inc << "SetTexTag  .assign " << qwordcounter << '\n';
  giftag[0] = 0x00008005;             // EOP=1,NLOOP = 4
  giftag[1] = 0x10000000;             // NREG=1 (A+D)
  giftag[2] = 0x0000000e;             // REGS=A+D
  giftag[3] = 0x00000000;
  o.write((char *)giftag, sizeof(int)*4);

  data[0] = 0x00000081;               // Alpha: A=Cs, B=Cd, C=As, D=0
  data[1] = 0x00000000;
  data[2] = 0x00000042;               // ALPHA_1
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = 0x00000000;             
  data[1] = 0x00000000;             
  data[2] = 0x0000003f;               // TEXFLUSH
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = 0x00000080;               // TA0 = 0x80, NORMAL
  data[1] = 0x00000080;               // TA1 = 0x80
  data[2] = 0x0000003b;               // TEXA
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  
  // 16x16 texture
  //  data[0] = (280*32) | (1<<14) | (0<<20) | (4<<26) | (0<<30);  // TBP0=0x118, psmct32, tw 3 th 3
  //  data[1] = 1 | 4<<3;                     // TFX: DECAL no colormap
  data[0] = (280*32) | (1<<14) | (0<<20) | (6<<26) | (1<<30);  // TBP0=0x118, psmct32, tw 3 th 3
  data[1] = 1 | 3<<3;                     // TFX: DECAL no colormap
  data[2] = 0x00000006;               // TEX0_1
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = 1 | (1<<5) | (1<<6) ;          // NEAREST 
  data[1] = 0x00000000;
  data[2] = 0x00000014;               // TEX1_1
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  qwordcounter +=6;



  inc << "TexInitTag  .assign " << qwordcounter << '\n';
  giftag[0] = 0x00000004;             // EOP=0,NLOOP = 4
  giftag[1] = 0x10000000;             // NREG=1 (A+D)
  giftag[2] = 0x0000000e;             // REGS=A+D
  giftag[3] = 0x00000000;
  o.write((char *)giftag, sizeof(int)*4);

  data[0] = (width<64?64:width);                    // source width = 64 pixels, PSMCT32
  data[1] = (280*32) | ((width<64?64:width)<<16);             // dest width =64 pixels, dest add = 0x118*32
  data[2] = 0x00000050;               // BITBLTBUF
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = 0x00000000;               // trxpos 0 0 
  data[1] = 0x00000000;
  data[2] = 0x00000051;               // TRXPOS
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = (width<64?64:width);
  data[1] = height;
  data[2] = 0x00000052;               // TRXREG
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  data[0] = 0x00000000;               // host->local 
  data[1] = 0x00000000;
  data[2] = 0x00000053;               // TRXDIR
  data[3] = 0x00000000;
  o.write((char *)data, sizeof(float)*4);

  qwordcounter +=5;



  inc << "TexImage  .assign " << qwordcounter << '\n';
  giftag[0] = npixels/4 | (1<<15);              // NLOOP=64 EOP=1
  giftag[1] = 2<<26;                   // IMAGE mode
  giftag[2] = 0x00000000;              // NREGS=0
  giftag[3] = 0x00000000;              // REGS={}
  o.write((char *)giftag, sizeof(int)*4);
  qwordcounter +=1;

  writeTile(o);
  qwordcounter += npixels/4;
  

  cout << "last qword: " << qwordcounter << endl;

}

// this routine is copied from Jon Rocatis' Tree demo
// i'm still having troubles understanding the direction of the z-axis of this projection ;(
void createPerspectiveMatrix(float m[][4])
{
  float fScrWdth = 640.0f;
  float fScrHgt = 224.0f;
  float fFov = M_PI/12.0f;

  float xAspect = 4;
  float yAspect = 3;

  float fInvTan = (float)(1.0 / tan(fFov));
  float ax = (0.5f * fScrWdth) * fInvTan;
  float ay = ((-0.5f * fScrHgt * xAspect) * fInvTan) / yAspect;

  float scrz = 1.0f;
  float cx = 2048.0f;
  float cy = 2048.0f;
  float zmin = 1.0f;
  float zmax = (float)((1 << 24) - 1);
  
  float nearz = 1.0f;
  float farz = 100.0f;
  
  float cz = (-zmax * nearz + zmin * farz) / (-nearz + farz);
  float az = farz * nearz * (-zmin + zmax) / (-nearz + farz);
  
  m[0][0] = ax*scrz;
  m[0][1] = 0;
  m[0][2] = 0;
  m[0][3] = 0;
  
  m[1][0] = 0;
  m[1][1] = ay*scrz;
  m[1][2] = 0;
  m[1][3] = 0;
  
  m[2][0] = cx;
  m[2][1] = cy;
  m[2][2] = cz * (1.0f / 16.0f);		// So we can use FTOI4 on everything
  m[2][3] = 1;
  
  m[3][0] = 0;
  m[3][1] = 0;
  m[3][2] = az * (1.0f / 16.0f);		// So we can use FTOI4 on everything;
  m[3][3] = 0;
  
}


void writeTile(ostream &o) {

  char *data = header_data;
  char pixel[4];

  pixel[3]= 0xff;
  
  for (int h=0;h<height;h++)
    for (int w=0;w<width;w++) {
      HEADER_PIXEL(data,pixel);
      o.write(&pixel[0],1);
      o.write(&pixel[1],1);
      o.write(&pixel[2],1);
      o.write(&pixel[3],1);
      //      o.write(pixel, sizeof(char) *4);
    }
}
