; rays.i
; Fabian Roth, fin@envoy.ch, 2003
; entry for VU2 coding contest 2003 ps2linux
; 
; helper macros, calculating stuff related to light rays

; refract
; calculates refracted vector based of incident hitting a surface
; facing normal. refraction index: ratio[w]
; 
	.macro	refract refr,inc, norm, rat
	; cosI = -incident*normal
	mul.xyz		cosI, \inc, \norm
	sub.x		cosI,vf00,cosI
	sub.x		cosI, cosI, cosI[y]
	sub.x		cosI, cosI, cosI[z]
	mul.x		cosI2, cosI, cosI

	max		V1111,vf00,vf00[w]
	sub.x		sinI2,V1111,cosI2
	mul.w		tmp,\rat,\rat
	mul.x		tmp,sinI2,tmp[w]	
	sub.x		cosT2,V1111,tmp

	mul.xyz		tmp2,\inc,\rat[w]
	mul.x		tmp3,cosI,\rat[w]
	sqrt		q,cosT2[x]
	subq.x		tmp4,tmp3,q
	mul.xyz		tmp5,\norm,tmp4[x]
	add.xyz		\refr,tmp2,tmp5
	.endm
	
; map
; calculates texture coordinate s,q of ray leaving bubble at ext
; and continuing in direction view until wall is hit at distance refrc[y]
;

	.macro	map tex, ext, view, refrc
	div		q, \refrc[y], \view[z]
	mul.xyz		\tex,\view,q
	add.xyz		\tex,\ext,\tex
	add.y		\tex,\tex,\tex			; tiles are half height
	.endm

; shadow
; calculates shadow coordinates x,y,z
; shad will contain xyz of shadow cast from coord in direction
; light with distance dist to a plain orthogonal to the z-axis
;
	.macro	shadow shad, coord, light, dist
	sub.z		tmp, \dist, \coord
;	add.z		tmp, \coord, \dist
	div		q, tmp[z], \light[z]
	mul.xyz		\shad,\light, q
	add.xyz		\shad,  \shad, \coord
;	sub.xyz		\shad,  \shad, \coord
	.endm

