.init_vf_all
.init_vi_all
.syntax new

.include "vcl_sml.i"
;.include "buttons.i"
.include "sauce_defs.i"
.include "sauce_macros.i"
.include "sauce_noise.i"
.include "sauce_sphere.i"
.include "sauce_init.i"
.include "sauce_texture.i"
.include "sauce_cube.i"

--enter
--endenter
	Initialize

	BranchUnlessState kStateFadingFromNoise, lDoneFadingFromNoise
	ilw.y iAlpha, kSTATE(vi00)
	iaddi iAlpha, iAlpha, -1
	isw.y iAlpha, kSTATE(vi00)
	ibne iAlpha, vi00, lStillFadingFromNoise

	ClearState kStateFadingFromNoise
	b lDoneFadingFromNoise

lStillFadingFromNoise:
	SetAlphaFadeOne iAlpha
	DrawNoise 0, 0, 640, 224, 1
	SetAlphaFadeTwo iAlpha

lDoneFadingFromNoise:
	BranchIfState kStateSphereRotateX, lSphereRotateX
	BranchIfState kStateSphereRotateY, lSphereRotateY
	BranchIfState kStateSphereRotateZ, lSphereRotateZ
	BranchUnlessState kStateFadingFromNoise, lDoneSphereFadingFromNoise
	iaddiu iSegments, vi00, 4 * 16
	isw.z iSegments, kSTATE(vi00)

lDoneSphereFadingFromNoise:
	ilw.z iSegments, kSTATE(vi00)
	iaddi iSegments, iSegments, 2

	iaddiu iMax, vi00, 512
	ibne iSegments, iMax, lStillSphereLOD

	ClearState kStateSphereLOD
	DisableAlphaBlending

	SetState kStateSphereRotateX
	isw.y vi00, kSTATE(vi00)
	b lPrepareAndDrawSphere

lStillSphereLOD:
	isw.z iSegments, kSTATE(vi00)
	b lPrepareAndDrawSphere

lSphereRotateX:
	ilw.y iAngle, kSTATE(vi00)
	iaddiu iAngle, iAngle, 3
	isw.y iAngle, kSTATE(vi00)

	MatrixLoad mTransform, kTRANSFORM_MATRIX, vi00
	sub fXRotation, vf00, vf00
	loi 3 * 3.1415926535/180
	add.xyz fXRotation, fXRotation, i
	MatrixXRotation mRotation, fXRotation
	MatrixMultiply mNewTransform, mTransform, mRotation
	MatrixSave mNewTransform, kTRANSFORM_MATRIX, vi00

	iaddiu iThreeSixty, vi00, 360
	ibne iAngle, iThreeSixty, lXNotDone

	ClearState kStateSphereRotateX
	SetState kStateSphereRotateY
	isw.y vi00, kSTATE(vi00)

lXNotDone:

	b lPrepareAndDrawSphere

lSphereRotateY:
	ilw.y iAngle, kSTATE(vi00)
	iaddiu iAngle, iAngle, 3
	isw.y iAngle, kSTATE(vi00)

	MatrixLoad mTransform, kTRANSFORM_MATRIX, vi00
	sub fYRotation, vf00, vf00
	loi 3 * 3.1415926535/180
	add.xyz fYRotation, fYRotation, i
	MatrixYRotation mRotation, fYRotation
	MatrixMultiply mNewTransform, mTransform, mRotation
	MatrixSave mNewTransform, kTRANSFORM_MATRIX, vi00

	iaddiu iThreeSixty, vi00, 360
	ibne iAngle, iThreeSixty, lYNotDone

	ClearState kStateSphereRotateY
	SetState kStateSphereRotateZ
	isw.y vi00, kSTATE(vi00)

lYNotDone:

	b lPrepareAndDrawSphere

lSphereRotateZ:
	ilw.y iAngle, kSTATE(vi00)
	iaddiu iAngle, iAngle, 3
	isw.y iAngle, kSTATE(vi00)

	MatrixLoad mTransform, kTRANSFORM_MATRIX, vi00
	sub fZRotation, vf00, vf00
	loi 3 * 3.1415926535/180
	add.xyz fZRotation, fZRotation, i
	MatrixZRotation mRotation, fZRotation
	MatrixMultiply mNewTransform, mTransform, mRotation
	MatrixSave mNewTransform, kTRANSFORM_MATRIX, vi00

	iaddiu iThreeSixty, vi00, 360
	ibne iAngle, iThreeSixty, lZNotDone

	ClearState kStateSphereRotateZ

	BranchIfState kStateSphereFour, lDidFourSided
	SetState kStateSphereFour
	SetState kStateSphereRotateX
	isw.y vi00, kSTATE(vi00)
	b lZNotDone

lDidFourSided:
	BranchIfState kStateTexturedTriangle, lDidTriangle
	SetState kStateTexturedTriangle
	SetState kStateSphereRotateX
	isw.y vi00, kSTATE(vi00)
	b lZNotDone

lDidTriangle:
	ClearState kStateInitialized
	isw.y vi00, kSTATE(vi00)
	iaddiu iNewAlpha, vi00, 127
	isw.y iNewAlpha, kSTATE(vi00)
	ClearState kStateInitialized

lZNotDone:
	b lPrepareAndDrawSphere



lPrepareAndDrawSphere:
	BranchUnlessState kStateSphereFour, lNotFourSidedSphere

	iaddiu iSegments, vi00, 4 * 16
	isw.z iSegments, kSTATE(vi00)
;	iaddi iAlpha, vi00, 0
;	SetAlphaFadeTwo iAlpha

lNotFourSidedSphere:
	loi 2048
	mul fCenter, vf00, vf00
	add.xyz fCenter, fCenter, i

	ilw.z iSegments, kSTATE(vi00)
	; Strip off last four bits.
	mfir.x fSegments, iSegments
	itof4.x fSegments, fSegments
	ftoi0.x fSegments, fSegments
	mtir iSegments, fSegments[x]

	mul fRadius, vf00, vf00
	loi 50
	add.xy fRadius, fRadius, i
	sub.z fRadius, fRadius, i

	BranchIfState kStateTexturedTriangle, lDrawTriangle
	DrawSphere fCenter, fRadius, iSegments, 1
	b lDone

lDrawTriangle:
	UploadTextureRandom 1
	loi 50
	move fSize, vf00
	add.xy fSize, vf00, i
	loi 2048
	mul fCenter, vf00, vf00
	add.xyz fCenter, fCenter, i
	DrawCube fCenter, fSize, 1
	b lDone

lDone:
	iaddiu vi00, vi00, 0

--exit
--endexit
