;.include "sauce_defs.i"
;.include "sauce_macros.i"
;.include "vcl_sml.i"


.macro DrawSphere fCenter, fRadius, iSegments, iUseNumber
; Draw a sphere
  loi 127
  mul.w _SSfColor, vf00, i

; Load up loop increment angle
; Round segments
  iadd _SSiAdjustedSegments, \iSegments, vi00
  iaddiu _SSiOne, vi00, 3
  iand _SSiEvenChecker, _SSiAdjustedSegments, _SSiOne
  iblez _SSiEvenChecker, _SSlDrawSphereEvenSegments\iUseNumber

  isub _SSiAdjustedSegments, _SSiAdjustedSegments, _SSiEvenChecker

_SSlDrawSphereEvenSegments\iUseNumber:
  mfir.y _SSfSegments, _SSiAdjustedSegments
  itof0.y _SSfSegments, _SSfSegments

  loi 3.1415926535 * 2
  add.y _SSfPI, vf00, i
  div q, _SSfPI[y], _SSfSegments[y]

  move _SSfIncrement, vf00
  add.xz _SSfIncrement, vf00, q

; iPacketStart = where packet will be drawn
  iaddiu _SSiPacketStart, vi00, k256_QWORDS

; Output the tag
  lq _SSfTag, kGIF_TAG_COLOR_TRISTRIP(vi00)
  sq _SSfTag, 0(_SSiPacketStart)

; Nloop = 2 * segments (one for RGBA, one for XYZ)
  ilw.x _SSiTagNLoop, 0(_SSiPacketStart)
  iadd _SSiTagNLoop, _SSiTagNLoop, _SSiAdjustedSegments
  iadd _SSiTagNLoop, _SSiTagNLoop, _SSiAdjustedSegments
  iadd _SSiTagNLoop, _SSiTagNLoop, _SSiAdjustedSegments
  iadd _SSiTagNLoop, _SSiTagNLoop, _SSiAdjustedSegments
  isw.x _SSiTagNLoop, 0(_SSiPacketStart)

; Load up 3d radius
  move _SSf3DRadius, vf00
  add.xyz _SSf3DRadius, _SSf3DRadius, \fRadius
;  mr32 _SSfRadiusTemp, \fRadius
;  mr32 _SSfRadiusTemp, _SSfRadiusTemp
;  add.z _SSf3DRadius, _SSf3DRadius, _SSfRadiusTemp
;  mr32 _SSfRadiusTemp, _SSfRadiusTemp
;  add.y _SSf3DRadius, _SSf3DRadius, _SSfRadiusTemp

  mfir.x _SSfSegmentTemp, _SSiAdjustedSegments
  loi 0.5
  itof0.x _SSfSegmentTemp, _SSfSegmentTemp
  mul.x _SSfSegmentTemp, _SSfSegmentTemp, i
  ftoi0.x _SSfSegmentTemp, _SSfSegmentTemp
  mtir _SSiNewAdjustedSegments, _SSfSegmentTemp[x]

  MatrixLoad _SSmTransformation, kTRANSFORM_MATRIX, vi00
  MatrixCorrectAspect _SSmTransformation, _SSmTransformation
  MatrixLoad _SSmLight1, kLIGHT_1_MATRIX, vi00
  MatrixLoad _SSmLight2, kLIGHT_2_MATRIX, vi00
  MatrixLoad _SSmLight3, kLIGHT_3_MATRIX, vi00
  lq _SSfAmbientLight, kLIGHT_AMBIENT(vi00)
  loi 255
  sub _SSfMaxLight, vf00, vf00
  add.xyz _SSfMaxLight, _SSfMaxLight, i

; Prepare Z loop
  iaddiu _SSiZLooper, vi00, 0

  sub _SSfZAngle, vf00, vf00
  loi 3.1415926535
  sub.xz _SSfZAngle, _SSfZAngle, i
  add.z _SSfZAngle, _SSfZAngle, _SSfIncrement
  
; Z Loop
_SSlDrawSphereZ\iUseNumber:
  move _SSfFirstZRing, vf00
  move _SSfSecondZRing, vf00

  AngleSinCos _SSfZAngle, _SSfSinCos

  add.y _SSfFirstZRing, _SSfFirstZRing, _SSfSinCos
  add.z _SSfSecondZRing, _SSfSecondZRing, _SSfSinCos

  mr32 _SSfSinCos, _SSfSinCos
  add.x _SSfFirstZRing, _SSfFirstZRing, _SSfSinCos

  mr32 _SSfSinCos, _SSfSinCos
  add.y _SSfSecondZRing, _SSfSecondZRing, _SSfSinCos
  add.z _SSfFirstZRing, _SSfFirstZRing, _SSfSinCos

  mr32 _SSfSinCos, _SSfSinCos
  add.x _SSfSecondZRing, _SSfSecondZRing, _SSfSinCos  


  ; Start building packet from beginning
  iaddiu _SSiPacket, _SSiPacketStart, 1

; Prepare XY loop
  iaddiu _SSiXYLooper, vi00, 0
  sub _SSfXYAngle, vf00, vf00
  loi 3.1415926535
  sub.xz _SSfXYAngle, _SSfXYAngle, i
  add.z _SSfXYAngle, _SSfXYAngle, _SSfIncrement

;  GIF_NOP

; X-Y loop
_SSlDrawSphereXY\iUseNumber:

;; First set of points
  move _SSfNormal1, _SSfFirstZRing
  move _SSfNormal2, _SSfSecondZRing

  AngleSinCos _SSfXYAngle, _SSfSinCos
  mul.xy _SSfNormal1, _SSfFirstZRing, _SSfSinCos
  mul.xy _SSfNormal2, _SSfSecondZRing, _SSfSinCos

; Shift over to other sin & cos
  mr32 _SSfSinCos, _SSfSinCos
  mr32 _SSfSinCos, _SSfSinCos

;; Second set of points
  move _SSfNormal3, _SSfFirstZRing
  move _SSfNormal4, _SSfSecondZRing

  mul.xy _SSfNormal3, _SSfFirstZRing, _SSfSinCos
  mul.xy _SSfNormal4, _SSfSecondZRing, _SSfSinCos

; Add to draw packet
  ComputeLights _SSfColor, _SSfAmbientLight, _SSmLight1, _SSmLight2, _SSmLight3, _SSfNormal1, vf00, _SSfMaxLight
  ftoi0 _SSfColor, _SSfColor
  sqi _SSfColor, (_SSiPacket++)

  mul _SSfPoint, _SSfNormal1, _SSf3DRadius
  MatrixMultiplyVector _SSfTransformed, _SSmTransformation, _SSfPoint
  add.xyz _SSfTransformed, _SSfTransformed, \fCenter
  ftoi4 _SSfTransformed, _SSfTransformed
  sqi _SSfTransformed, (_SSiPacket++)

  ComputeLights _SSfColor, _SSfAmbientLight, _SSmLight1, _SSmLight2, _SSmLight3, _SSfNormal2, vf00, _SSfMaxLight
  ftoi0 _SSfColor, _SSfColor
  sqi _SSfColor, (_SSiPacket++)

  mul _SSfPoint, _SSfNormal2, _SSf3DRadius
  MatrixMultiplyVector _SSfTransformed, _SSmTransformation, _SSfPoint
  add.xyz _SSfTransformed, _SSfTransformed, \fCenter
  ftoi4 _SSfTransformed, _SSfTransformed
  sqi _SSfTransformed, (_SSiPacket++)

  ComputeLights _SSfColor, _SSfAmbientLight, _SSmLight1, _SSmLight2, _SSmLight3, _SSfNormal3, vf00, _SSfMaxLight
  ftoi0 _SSfColor, _SSfColor
  sqi _SSfColor, (_SSiPacket++)

  mul _SSfPoint, _SSfNormal3, _SSf3DRadius
  MatrixMultiplyVector _SSfTransformed, _SSmTransformation, _SSfPoint
  add.xyz _SSfTransformed, _SSfTransformed, \fCenter
  ftoi4 _SSfTransformed, _SSfTransformed
  sqi _SSfTransformed, (_SSiPacket++)
 
  ComputeLights _SSfColor, _SSfAmbientLight, _SSmLight1, _SSmLight2, _SSmLight3, _SSfNormal4, vf00, _SSfMaxLight
  ftoi0 _SSfColor, _SSfColor
  sqi _SSfColor, (_SSiPacket++)

  mul _SSfPoint, _SSfNormal4, _SSf3DRadius
  MatrixMultiplyVector _SSfTransformed, _SSmTransformation, _SSfPoint
  add.xyz _SSfTransformed, _SSfTransformed, \fCenter
  ftoi4 _SSfTransformed, _SSfTransformed
  sqi _SSfTransformed, (_SSiPacket++)

; Check X-Y loop
  add.xz _SSfXYAngle, _SSfXYAngle, _SSfIncrement
  iaddiu _SSiXYLooper, _SSiXYLooper, 1
  isub _SSiCheck, _SSiXYLooper, _SSiAdjustedSegments
  ibltz _SSiCheck, _SSlDrawSphereXY\iUseNumber

  xgkick _SSiPacketStart
; Make sure drawing completes
  GIF_NOP

; Check Z loop
  add.xz _SSfZAngle, _SSfZAngle, _SSfIncrement
  add.xz _SSfZAngle, _SSfZAngle, _SSfIncrement
  iaddiu _SSiZLooper, _SSiZLooper, 2
  isub _SSiCheck, _SSiZLooper, _SSiAdjustedSegments
  ibltz _SSiCheck, _SSlDrawSphereZ\iUseNumber

.endm
