
// Write the dat file that contains the GifTag and data to draw
// demo:
//  QW0000    GifTag for wall
//  QW0001-40 Wall Data
//  QW0041    GifTag Ball
//  QW0042-61 Ball Data
//  QW0062-71 Ball Direction

//  QW1020    NbBallTot, NbBallCurrent :
//  QW1021    Data Status :
//              1 - From the gen_data file
//              2 - Random in First Wall
//              3 - Random in the two Wall
//  QW1022    MeanSpeed (xy)

#include <stdio.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include "packet.h"

int TicknessX = 6;
int TicknessY = 3;
int NbPts = 320;
//int maxX = 200;
//int maxY = 70;
int TopWall1 = -100;
int BottomWall1 = 100;
int LeftWall1 = -300;
int RightWall1 = -TicknessX;
int TopWall2 = -100;
int BottomWall2 = 100;
int LeftWall2 = TicknessX;
int RightWall2 = 300;
int maxSpeedX = 9;
int maxSpeedY = 4;
int minSpeed = 1;
int Opening = 0; //  Hole is equal to 2*Opening
int posOpening = static_cast<int>((BottomWall1-TopWall1)/2.0);
int main(int argc, char **argv)
{
	FILE *output;
	int bytes=0;
	int prim=0;
	qword_t color;
	qword_t vertex;

	u_long128 packet_data[1024];

	gifpacket_t gifpacket;

	if (argc!=2)
	{
		fprintf(stderr, "Usage: gen_data output_file\n");
		return -1;
	}

  gifpacket_init(&gifpacket, packet_data);

  int GifSize = gifpacket_size(&gifpacket);
  std::cout<<GifSize<<std::endl;

  prim=GS_SET_PRIM(GS_PRIM_SPRITE, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), ALPHA(0), AA(0), CTXT(0), FIX(0));
  gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(20), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
  gifpacket_addgsdata(&gifpacket, 0x51);

//Top Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall1)<<4;
  vertex.ui32[1]=(2048+TopWall1)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1)<<4;
  vertex.ui32[1]=(2048+TopWall1-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Right Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1)<<4;
  vertex.ui32[1]=(2048+TopWall1-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1+TicknessX)<<4;
  vertex.ui32[1]=(2048+TopWall1+posOpening-Opening)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1)<<4;
  vertex.ui32[1]=(2048+TopWall1+posOpening+Opening)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1+TicknessX)<<4;
  vertex.ui32[1]=(2048+BottomWall1+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Top Bottom
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall1)<<4;
  vertex.ui32[1]=(2048+BottomWall1+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall1)<<4;
  vertex.ui32[1]=(2048+BottomWall1)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Top Left
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall1)<<4;
  vertex.ui32[1]=(2048+BottomWall1+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall1-TicknessX)<<4;
  vertex.ui32[1]=(2048+TopWall1-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//*****************
//  Wall2
//*****************
//Top Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2)<<4;
  vertex.ui32[1]=(2048+TopWall2)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall2)<<4;
  vertex.ui32[1]=(2048+TopWall2-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Right Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall2)<<4;
  vertex.ui32[1]=(2048+TopWall2-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall2+TicknessX)<<4;
  vertex.ui32[1]=(2048+BottomWall2+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Bottom Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+RightWall2)<<4;
  vertex.ui32[1]=(2048+BottomWall2+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2)<<4;
  vertex.ui32[1]=(2048+BottomWall2)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//Left Wall
  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2)<<4;
  vertex.ui32[1]=(2048+BottomWall2+TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2-TicknessX)<<4;
  vertex.ui32[1]=(2048+TopWall2+posOpening+Opening)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2)<<4;
  vertex.ui32[1]=(2048+TopWall2+posOpening-Opening)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  color.ui32[0]=0xFF;
  color.ui32[1]=0x0;
  color.ui32[2]=0x0;
  color.ui32[3]=0x0;
  gifpacket_addgspacked(&gifpacket, color.ul128);

  vertex.ui32[0]=(2048+LeftWall2-TicknessX)<<4;
  vertex.ui32[1]=(2048+TopWall2-TicknessY)<<4;
  vertex.ui32[2]=1;
  vertex.ui32[3]=1;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  clock_t tl = clock();
  srand(tl);

  float DirX[NbPts];
  float DirY[NbPts];
  float MeanSpeed = 0.0;
  float Factor = 255.0/sqrt((maxSpeedX*maxSpeedX) + (maxSpeedY*maxSpeedY));

  std::cout<<Factor<<std::endl;
  GifSize = gifpacket_size(&gifpacket);
  std::cout<<GifSize<<std::endl;

  prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), ALPHA(0), AA(0), CTXT(0), FIX(0));
  gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(NbPts), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
  gifpacket_addgsdata(&gifpacket, 0x51);
  for(int i=0; i<NbPts; i++)
  {
    DirX[i] = ((double(rand())/RAND_MAX))*(maxSpeedX-1);
    DirY[i] = ((double(rand())/RAND_MAX))*(maxSpeedY-1);
    DirX[i] += 1.0;
    DirY[i] += 1.0;

    float Speed = sqrt((DirX[i]*DirX[i]) + (DirY[i]*DirY[i]));
    MeanSpeed += Speed;

    Speed *= Factor;

    int cRed = static_cast<int>(Speed);
    int cBlue = 255 - cRed;

    color.ui32[0]= cRed;
    color.ui32[1]= 0x0;
    color.ui32[2]= cBlue;
    color.ui32[3]= 0x0;
    gifpacket_addgspacked(&gifpacket, color.ul128);

    float maxX = (RightWall1 - LeftWall1);
    int XCenter = int((double(rand())/RAND_MAX)*maxX);
    XCenter+=LeftWall1;

    float maxY = (BottomWall1 - TopWall1);
    int YCenter = int((double(rand())/RAND_MAX)*maxY);
    YCenter+=TopWall1;

    vertex.ui32[0]=(2048+(XCenter))<<4;
    vertex.ui32[1]=(2048+(YCenter))<<4;
    vertex.ui32[2]=0;
    vertex.ui32[3]=1;
    gifpacket_addgspacked(&gifpacket, vertex.ul128);
  }

  GifSize = gifpacket_size(&gifpacket);
  std::cout<<GifSize<<std::endl;
  for(int i=0; i<NbPts; i++)
  {
    vertex.f32[0]=DirX[i];
    vertex.f32[1]=DirY[i];
    vertex.f32[2]=0;
    vertex.ui32[3]=1;
    gifpacket_addgspacked(&gifpacket, vertex.ul128);
  }
//  MeanSpeed /= NbPts;
  std::cout<<MeanSpeed<<std::endl;

  GifSize = gifpacket_size(&gifpacket);
  std::cout<<GifSize<<std::endl;

  for(int i=GifSize+1; i<1021; i++)
  {
    vertex.ui32[0]=0;
    vertex.ui32[1]=0;
    vertex.ui32[2]=0;
    vertex.ui32[3]=0;
    gifpacket_addgspacked(&gifpacket, vertex.ul128);
  }

//  QW1020    NbBallTot, NbBallCurrent :
  vertex.ui32[0] = NbPts;
  vertex.ui32[1] = NbPts;
  vertex.ui32[2] = 0;
  vertex.ui32[3] = 0;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//  QW1021    Data Status :
//              1 - From the gen_data file
//              2 - Random in First Wall
//              3 - Random in the two Wall
  vertex.ui32[0] = 1;
  vertex.ui32[1] = 0;
  vertex.ui32[2] = 0;
  vertex.ui32[3] = 0;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

//  QW1022
//  MeanSpeed *= NbPts;

  float cRed = 255.0/MeanSpeed;

  vertex.f32[0] = 255.0; //  Wall1 Mean Speed
  vertex.f32[1] = 0.0;  //  Wall2 Mean Speed
  vertex.f32[2] = cRed;
  vertex.f32[3] = 0.0;
  gifpacket_addgspacked(&gifpacket, vertex.ul128);

  GifSize = gifpacket_size(&gifpacket);
  std::cout<<GifSize<<std::endl;

  gifpacket_terminate(&gifpacket);

	output=fopen(argv[1], "wb");

	if (output==NULL)
	{
		fprintf(stderr, "Could not open file \"%s\"\n", argv[1]);
		return -1;
	}

	fwrite(packet_data, sizeof(packet_data)/sizeof(qword_t), sizeof(qword_t), output);

	bytes=ftell(output);
	fclose(output);

	printf("Written %d bytes to \"%s\"\n", bytes, argv[1]);

	return 0;
}

