;*****************************************
; maxdemon.vcl
; by Hendrix "drix[Qc]" Demers
;*****************************************

;*****************************************
; Define constante
;*****************************************
;-----------------------------------------
; Number of Ball
;-----------------------------------------
kNbBallPtr .assign 1020
;kNbBall .assign 10

;-----------------------------------------
; GifTag
;-----------------------------------------
kGifWallPtr .assign 0
kGifBallPtr .assign 41

;-----------------------------------------
; Ball Speed Data
;-----------------------------------------
kMaxSpeedX .assign 9
kMaxSpeedY .assign 4
kFactor .assign 25.8913
;kBallSpeedMax .assign 5
;kBallSpeedMin .assign 1

;-----------------------------------------
; Screen Limit
;-----------------------------------------
kScreenTop .assign -112
kScreenBottom .assign 112
kScreenLeft .assign -320
kScreenRight .assign 320

;-----------------------------------------
; Wall Limit
;-----------------------------------------
kNbWallTotal .assign 20
kNbWall .assign 10

kWallTicknessX .assign 6
kWallTicknessY .assign 3

kWall1TopPtr .assign kGifWallPtr+2
kWall1LeftPtr .assign kGifWallPtr+2
kWall1RightPtr .assign kGifWallPtr+4
kWall1BottomPtr .assign kGifWallPtr+16

kWall2TopPtr .assign kGifWallPtr+22
kWall2LeftPtr .assign kGifWallPtr+22
kWall2RightPtr .assign kGifWallPtr+24
kWall2BottomPtr .assign kGifWallPtr+32

kWallCenterDownPtr .assign kGifWallPtr+8
kWallCenterUpPtr .assign kGifWallPtr+10

kWallMeanSpeed .assign 1022
;-----------------------------------------
; Pad constante
;-----------------------------------------
kSquare .assign H'7FFF
kCross .assign H'4000
kTriangle .assign H'1000
kCircle .assign H'2000
kR1 .assign H'0800
kR2 .assign H'0200
kStart .assign H'0008
kLeft .assign H'0080
kDown .assign H'0040
kUp .assign H'0010
kRight .assign H'0020

;-----------------------------------------
; System Status
;-----------------------------------------
kSystemModePtr .assign 1021

;*****************************************

.init_vf_all
.init_vi_all
.syntax new

.vu

--enter
--endenter

;*****************************************
; Program Part:
;
; - Get Limit
; - Get Status Flag
; - Init Stuff
; - Get Pad Info
; - Move Wall and Set color
; - Get Wall Limit
; - Move Ball
; - Finish Calculation
; - Render
;*****************************************

START:
  b GET_LIMIT:
;*****************************************
; Get Limit
;*****************************************
GET_LIMIT:
;-----------------------------------------
; Wall 1 limit
;-----------------------------------------
  lq.y fWall1Top, kWall1TopPtr(vi00)
  itof4.y fWall1Top, fWall1Top

  lq.x fWall1Left, kWall1LeftPtr(vi00)
  itof4.x fWall1Left, fWall1Left

  lq.x fWall1Right, kWall1RightPtr(vi00)
  itof4.x fWall1Right, fWall1Right

  lq.y fWall1Bottom, kWall1BottomPtr(vi00)
  itof4.y fWall1Bottom, fWall1Bottom

  lq.y fWallCenterDown, kWallCenterDownPtr(vi00)
  itof4.y fWallCenterDown, fWallCenterDown

  lq.y fWallCenterUp, kWallCenterUpPtr(vi00)
  itof4.y fWallCenterUp, fWallCenterUp

  loi 2048
  sub.y fWall1Top, fWall1Top, i
  sub.x fWall1Left, fWall1Left, i
  sub.x fWall1Right, fWall1Right, i
  sub.y fWall1Bottom, fWall1Bottom, i

  sub.y fWallCenterDown, fWallCenterDown, i
  sub.y fWallCenterUp, fWallCenterUp, i

  ftoi0.y ftmp, fWall1Top
  mtir iWall1Top, ftmp[y]

  ftoi0.x ftmp, fWall1Left
  mtir iWall1Left, ftmp[x]

  ftoi0.x ftmp, fWall1Right
  mtir iWall1Right, ftmp[x]

  ftoi0.y ftmp, fWall1Bottom
  mtir iWall1Bottom, ftmp[y]

;-----------------------------------------
; Wall 2 limit
;-----------------------------------------
  lq.y fWall2Top, kWall2TopPtr(vi00)
  itof4.y fWall2Top, fWall2Top

  lq.x fWall2Left, kWall2LeftPtr(vi00)
  itof4.x fWall2Left, fWall2Left

  lq.x fWall2Right, kWall2RightPtr(vi00)
  itof4.x fWall2Right, fWall2Right

  lq.y fWall2Bottom, kWall2BottomPtr(vi00)
  itof4.y fWall2Bottom, fWall2Bottom

  sub.y fWall2Top, fWall2Top, i
  sub.x fWall2Left, fWall2Left, i
  sub.x fWall2Right, fWall2Right, i
  sub.y fWall2Bottom, fWall2Bottom, i

  ftoi0.y ftmp, fWall2Top
  mtir iWall2Top, ftmp[y]

  ftoi0.x ftmp, fWall2Left
  mtir iWall2Left, ftmp[x]

  ftoi0.x ftmp, fWall2Right
  mtir iWall2Right, ftmp[x]

  ftoi0.y ftmp, fWall2Bottom
  mtir iWall2Bottom, ftmp[y]

  b GET_STATUS_FLAG:
;*****************************************
; Get Status Flag
;*****************************************
GET_STATUS_FLAG:
  ilw.x iFlagMode, kSystemModePtr(vi00)
  ilw.y iFlagInit, kSystemModePtr(vi00)

  ilw.x iNbBallTot, kNbBallPtr(vi00)
  ilw.y iNbBall, kNbBallPtr(vi00)

  iaddiu, iBallSpeedPtr0, vi00, kGifBallPtr+1
  iadd, iBallSpeedPtr0, iBallSpeedPtr0, iNbBallTot
  iadd, iBallSpeedPtr0, iBallSpeedPtr0, iNbBallTot

  ibeq iFlagInit, vi00, GET_PAD_INFO:
  b INIT_STATUS:
;*****************************************
; Init Stuff
;*****************************************
INIT_STATUS:
  b GET_PAD_INFO:
;*****************************************
; Get Pad Info
;*****************************************
GET_PAD_INFO:
  ilw.w iPad, 1023(vi00)

;-----------------------------------------
; Check if DPad button is press
;-----------------------------------------
; UP
;---------
  loi 0.0
  add.x fDX, vf00, i
  add.y fDY, vf00, i

  iaddiu iFlagDX, vi00, 0
  iaddiu iFlagDY, vi00, 0

  iaddiu iMask, vi00, kUp
  iand iCheck, iPad, iMask
  ibeq iCheck, vi00, UP_PRESSED:
  b UP_NOT_PRESSED:

UP_PRESSED:
  loi -1.0
  add.y fDY, vf00, i
  iaddiu iFlagDY, vi00, 1
  b UP_NOT_PRESSED:

UP_NOT_PRESSED:
;---------
; DOWN
;---------
  iaddiu iMask, vi00, kDown
  iand iCheck, iPad, iMask
  ibeq iCheck, vi00, DOWN_PRESSED:
  b DOWN_NOT_PRESSED:

DOWN_PRESSED:
  loi 1.0
  add.y fDY, vf00, i
  iaddiu iFlagDY, vi00, 1
  b DOWN_NOT_PRESSED:

DOWN_NOT_PRESSED:
;---------
; LEFT
;---------
    iaddiu iMask, vi00, kLeft
    iand iCheck, iPad, iMask
    ibeq iCheck, vi00, LEFT_PRESSED:
    b LEFT_NOT_PRESSED:

LEFT_PRESSED:
    loi -1.0
    add.x fDX, vf00, i
    iaddiu iFlagDX, vi00, 1
    b LEFT_NOT_PRESSED:

LEFT_NOT_PRESSED:
;---------
; RIGHT
;---------
    iaddiu iMask, vi00, kRight
    iand iCheck, iPad, iMask
    ibeq iCheck, vi00, RIGHT_PRESSED:
    b RIGHT_NOT_PRESSED:

RIGHT_PRESSED:
    loi 1.0
    add.x fDX, vf00, i
    iaddiu iFlagDX, vi00, 1
    b RIGHT_NOT_PRESSED:

RIGHT_NOT_PRESSED:
;-----------------------------------------
; Check if Square is pressed
;-----------------------------------------
  iaddiu iMask, vi00, kSquare
  iaddiu iMask, iMask, 1
  iand iCheck, iPad, iMask
  ibeq iCheck, vi00, KICK:

  b MOVE_WALL:

;*****************************************
; Move Wall and Set color
;*****************************************
MOVE_WALL:
;-----------------------------------------
;Loop on all Wall 1 for color
;-----------------------------------------
  lq.xy fWallColor, kWallMeanSpeed(vi00)
  add.x fColor, vf00, fWallColor[y]
  loi 255
  add.z fBlue, vf00, i
  sub.z fBlue, fBlue, fWallColor[x]
  ftoi0.z fBlue, fBlue
  ftoi0.x fWallColor, fWallColor

  iaddiu iWallPtr, vi00, kGifWallPtr+1
  iaddiu iWallMax, vi00, kNbWall

  iaddiu iWallCounter, vi00, 0

LOOPWALL1:
  sq.x fWallColor, 0(iWallPtr)
  sq.z fBlue, 0(iWallPtr)

  iaddiu iWallPtr, iWallPtr, 2
  iaddiu iWallCounter, iWallCounter, 1
  ibne iWallCounter, iWallMax, LOOPWALL1:

;-----------------------------------------
;Loop on all Wall 2 for color
;-----------------------------------------
  loi 255
  add.z fBlue, vf00, i
  sub.z fBlue, fBlue, fColor[x]
  ftoi0.z fBlue, fBlue
  ftoi0.x fColor, fColor

  iaddiu iWallCounter, vi00, 0

LOOPWALL2:
  sq.x fColor, 0(iWallPtr)
  sq.z fBlue, 0(iWallPtr)

  iaddiu iWallPtr, iWallPtr, 2
  iaddiu iWallCounter, iWallCounter, 1
  ibne iWallCounter, iWallMax, LOOPWALL2:

;-----------------------------------------
;Check if the central Wall move
;-----------------------------------------
  ibne iFlagDX, vi00, MOVE_WALLX:
  b CHECK_HOLE_WALL:

;-----------------------------------------
;Central Wall move
;-----------------------------------------
MOVE_WALLX:

;--------------------
;Check Limit at Left
;--------------------
  loi 10
  add.x ftmp1, fWall1Left, i
  add.x ftmp2, fWall1Right, fDX
  sub.x ftmp1, ftmp1, ftmp2
  ftoi0.x ftmp1, ftmp1
  mtir iCheck, ftmp1[x]
  ibltz iCheck, CHECK_WALL_LIMIT_RIGHT:
  b CHECK_HOLE_WALL:

;--------------------
; Check Limit at right
;--------------------
CHECK_WALL_LIMIT_RIGHT:
  add.x ftmp1, fWall2Left, fDX
  loi 10
  sub.x ftmp2, fWall2Right, i
  sub.x ftmp1, ftmp1, ftmp2
  ftoi0.x ftmp1, ftmp1
  mtir iCheck, ftmp1[x]
  ibltz iCheck, ADD_WALL_DX:
  b CHECK_HOLE_WALL:

;--------------------
; Ok add DX to the center vertice
;--------------------
ADD_WALL_DX:
  iaddiu iWallPtr, vi00, kGifWallPtr+4
  iaddiu iWallMax, vi00, 6

;--------------------
; Loop on some point on wall 1
;--------------------
  iaddiu iWallCounter, vi00, 0
LOOPWALL1DX:
  lq.x fWallX, 0(iWallPtr)
  itof4.x fWallX, fWallX

  loi 2048
  sub.x fWallX, fWallX, i

  add.x fWallX, fWallX, fDX
  loi 2048
  add.x fWallX, fWallX, i

  ftoi4.x fWallX, fWallX
  sq.x fWallX, 0(iWallPtr)

  iaddiu iWallPtr, iWallPtr, 2
  iaddiu iWallCounter, iWallCounter, 1
  ibne iWallCounter, iWallMax, LOOPWALL1DX:

;--------------------
; Loop on some point on wall 2
;--------------------
  iaddiu iWallPtr, vi00, 40
  iaddiu iWallCounter, vi00, 0
  iaddiu iWallMax, vi00, 5
LOOPWALL2DX:
  lq.x fWallX, 0(iWallPtr)
  itof4.x fWallX, fWallX

  loi 2048
  sub.x fWallX, fWallX, i

  add.x fWallX, fWallX, fDX
  loi 2048
  add.x fWallX, fWallX, i

  ftoi4.x fWallX, fWallX
  sq.x fWallX, 0(iWallPtr)

  isubiu iWallPtr, iWallPtr, 2
  iaddiu iWallCounter, iWallCounter, 1
  ibne iWallCounter, iWallMax, LOOPWALL2DX:

;--------------------
; Last point on wall 2
;--------------------
  iaddiu iWallPtr, vi00, 22
  lq.x fWallX, 0(iWallPtr)
  itof4.x fWallX, fWallX

  loi 2048
  sub.x fWallX, fWallX, i

  add.x fWallX, fWallX, fDX
  loi 2048
  add.x fWallX, fWallX, i

  ftoi4.x fWallX, fWallX
  sq.x fWallX, 0(iWallPtr)

  b CHECK_HOLE_WALL:
;-----------------------------------------
;Check if the hole in the Wall change
;-----------------------------------------
CHECK_HOLE_WALL:
  ibne iFlagDY, vi00, CHANGE_HOLE_WALL:
  b END_MOVE_WALL:

;-----------------------------------------
;hole in the Wall change
;-----------------------------------------
CHANGE_HOLE_WALL:
;--------------------
;Check Limit at Top
;--------------------
  loi 10
  add.y ftmp1, fWall1Top, i
  add.y ftmp2, fWallCenterDown, fDY
  sub.y ftmp1, ftmp1, ftmp2
  ftoi0.y ftmp1, ftmp1
  mtir iCheck, ftmp1[y]
  ibltz iCheck, CHECK_HOLE_LIMIT_CENTER:
  b END_MOVE_WALL:

;--------------------
; Check Limit at center
;--------------------
CHECK_HOLE_LIMIT_CENTER:
  add.y ftmp1, fWallCenterDown, fDY
  sub.y ftmp2, fWallCenterUp, fDY
  sub.y ftmp1, ftmp2, ftmp1
  ftoi0.y ftmp1, ftmp1
  mtir iCheck, ftmp1[y]
  ibgez iCheck, ADD_WALL_DY:
  b END_MOVE_WALL:

;--------------------
; Ok add DY to the center vertice
;--------------------
ADD_WALL_DY:
;Pts 1
  iaddiu iWallPtr, vi00, 8
  lq.y fWallY, 0(iWallPtr)
  itof4.y fWallY, fWallY

  loi 2048
  sub.y fWallY, fWallY, i

  add.y fWallY, fWallY, fDY
  loi 2048
  add.y fWallY, fWallY, i

  ftoi4.y fWallY, fWallY
  sq.y fWallY, 0(iWallPtr)

;Pts 2
  iaddiu iWallPtr, vi00, 10
  lq.y fWallY, 0(iWallPtr)
  itof4.y fWallY, fWallY

  loi 2048
  sub.y fWallY, fWallY, i

  sub.y fWallY, fWallY, fDY
  loi 2048
  add.y fWallY, fWallY, i

  ftoi4.y fWallY, fWallY
  sq.y fWallY, 0(iWallPtr)

;Pts 3
  iaddiu iWallPtr, vi00, 36
  lq.y fWallY, 0(iWallPtr)
  itof4.y fWallY, fWallY

  loi 2048
  sub.y fWallY, fWallY, i

  sub.y fWallY, fWallY, fDY
  loi 2048
  add.y fWallY, fWallY, i

  ftoi4.y fWallY, fWallY
  sq.y fWallY, 0(iWallPtr)

;Pts 4
  iaddiu iWallPtr, vi00, 38
  lq.y fWallY, 0(iWallPtr)
  itof4.y fWallY, fWallY

  loi 2048
  sub.y fWallY, fWallY, i

  add.y fWallY, fWallY, fDY
  loi 2048
  add.y fWallY, fWallY, i

  ftoi4.y fWallY, fWallY
  sq.y fWallY, 0(iWallPtr)

  b END_MOVE_WALL:

END_MOVE_WALL:
  b GET_WALL_LIMIT:
;*****************************************
; Get Wall Limit
;*****************************************
GET_WALL_LIMIT:
  lq.y fWall1Top, kWall1TopPtr(vi00)
  itof4.y fWall1Top, fWall1Top

  lq.x fWall1Left, kWall1LeftPtr(vi00)
  itof4.x fWall1Left, fWall1Left

  lq.x fWall1Right, kWall1RightPtr(vi00)
  itof4.x fWall1Right, fWall1Right

  lq.y fWall1Bottom, kWall1BottomPtr(vi00)
  itof4.y fWall1Bottom, fWall1Bottom

  lq.y fWallCenterDown, kWallCenterDownPtr(vi00)
  itof4.y fWallCenterDown, fWallCenterDown

  lq.y fWallCenterUp, kWallCenterUpPtr(vi00)
  itof4.y fWallCenterUp, fWallCenterUp

  loi 2048
  sub.y fWall1Top, fWall1Top, i
  sub.x fWall1Left, fWall1Left, i
  sub.x fWall1Right, fWall1Right, i
  sub.y fWall1Bottom, fWall1Bottom, i

  sub.y fWallCenterDown, fWallCenterDown, i
  sub.y fWallCenterUp, fWallCenterUp, i

  ftoi0.y ftmp, fWall1Top
  mtir iWall1Top, ftmp[y]

  ftoi0.x ftmp, fWall1Left
  mtir iWall1Left, ftmp[x]

  ftoi0.x ftmp, fWall1Right
  mtir iWall1Right, ftmp[x]

  ftoi0.y ftmp, fWall1Bottom
  mtir iWall1Bottom, ftmp[y]

;-----------------------------------------
; Wall 2 limit
;-----------------------------------------
  lq.y fWall2Top, kWall2TopPtr(vi00)
  itof4.y fWall2Top, fWall2Top

  lq.x fWall2Left, kWall2LeftPtr(vi00)
  itof4.x fWall2Left, fWall2Left

  lq.x fWall2Right, kWall2RightPtr(vi00)
  itof4.x fWall2Right, fWall2Right

  lq.y fWall2Bottom, kWall2BottomPtr(vi00)
  itof4.y fWall2Bottom, fWall2Bottom

  sub.y fWall2Top, fWall2Top, i
  sub.x fWall2Left, fWall2Left, i
  sub.x fWall2Right, fWall2Right, i
  sub.y fWall2Bottom, fWall2Bottom, i

  ftoi0.y ftmp, fWall2Top
  mtir iWall2Top, ftmp[y]

  ftoi0.x ftmp, fWall2Left
  mtir iWall2Left, ftmp[x]

  ftoi0.x ftmp, fWall2Right
  mtir iWall2Right, ftmp[x]

  ftoi0.y ftmp, fWall2Bottom
  mtir iWall2Bottom, ftmp[y]

  b MOVE_BALL:
;*****************************************
; Move Ball
;*****************************************
MOVE_BALL:
;-----------------------------------------
; Init MeanSpeed
;-----------------------------------------
  add.x fMeanSpeed1, vf00, vf00
  add.y fMeanSpeed2, vf00, vf00

;-----------------------------------------
; Init Ball Counter and Ptr
;-----------------------------------------
  ilw.y iBallMax, kNbBallPtr(vi00)
  iaddiu, iBallPtr, vi00, kGifBallPtr+1
  iadd, iBallSpeedPtr, vi00, iBallSpeedPtr0
  iaddiu, iCountBall, vi00, 0

;-----------------------------------------
; Loop on all ball
;-----------------------------------------
LOOPBALLS:
  iaddiu, iCountBall, iCountBall, 1
;-----------------------------------------
; Load Ball position
;-----------------------------------------
  add.xy fBallPos, vf00, vf00
  lq.xy fBallPos, 1(iBallPtr)
  itof4.xy fBallPos, fBallPos

  loi 2048
  sub.xy fBallPos, fBallPos, i

;-----------------------------------------
; Load Ball Direction
;-----------------------------------------
  lq.xyz fBallSpeed, 0(iBallSpeedPtr)

  ilw.w iRegion, 0(iBallSpeedPtr)

/*
  loi 3.5
  add.w fBallDir, vf00, i ; 1+3.5=4.5
  fcset 0
  abs.xyz ftmp, fBallDir
  clipw.xyz ftmp, fBallDir[w]

  loi 0.12
  add.w fBallDir, vf00, i ; 1+0.12=1.12
  clipw.xyz ftmp, fBallDir[w]

  fcget iCheck
  iaddiu iMask, vi00, 0x0001
  isw.w iCheck, 0(iPtrBallDir)
  iand iCheckX, iCheck, iMask
  ibeq iCheckX, vi00, CHANGESPEEDX:
  b NOTCHANGESPEEDX:
CHANGESPEEDX:
  mul.x fBallDir, fBallDir, fDeltaSpeed
  loi 1.0
  add.x fDeltaSpeed, vf00, i

NOTCHANGESPEEDX:
  iaddiu iMask, vi00, 0x0004
  iand iCheckY, iCheck, iMask
  ibeq iMask, iCheckY, CHANGESPEEDY:
  b NOTCHANGESPEEDY:
CHANGESPEEDY:
  mul.y fBallDir, fBallDir, fDeltaSpeed
  loi 1.0
  add.y fDeltaSpeed, vf00, i

NOTCHANGESPEEDY:
*/

  eleng p, fBallSpeed  ;  Scalar speed
;-----------------------------------------
; Calculate new position for this frame
;-----------------------------------------
  add.xy fBallPos, fBallPos, fBallSpeed

CHECK_REGION:
  iaddiu iCheckRegion, vi00, 2
  ibeq iRegion, iCheckRegion, REGION_2:
  b REGION_1:

REGION_1:

;-----------------------------------------
; Check Left Wall 1
;-----------------------------------------
CHECK1_BALL_LEFT:
  sub.x ftmp, fWall1Left, fBallPos
  ftoi0.x ftmpi, ftmp
  mtir itmp, ftmpi[x]

  iblez itmp, CHECK1_BALL_RIGHT:
  loi -1.0
  mul.x fBallSpeed, fBallSpeed, i
  abs.x ftmp, ftmp
  add.x fBallPos, ftmp, fWall1Left
  b CHECK1_BALL_RIGHT:

;-----------------------------------------
; Check Right Wall 1
;-----------------------------------------
CHECK1_BALL_RIGHT:
  sub.x ftmp, fBallPos, fWall1Right
  ftoi0.x ftmpi, ftmp
  mtir itmp, ftmpi[x]

  iblez itmp, CHECK1_BALL_TOP:

  sub.y ftmp, fBallPos, fWallCenterDown
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BOUNCE1_BALL_RIGHT:

  sub.y ftmp, fWallCenterUp, fBallPos
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BOUNCE1_BALL_RIGHT:
  iaddiu iRegion, vi00, 2
  isw.w iRegion, 0(iBallSpeedPtr)
  loi kWallTicknessX
  add.x fBallPos, fBallPos, i
  add.x fBallPos, fBallPos, i
  b REGION_2:

BOUNCE1_BALL_RIGHT:
  loi -1
  mul.x fBallSpeed, fBallSpeed, i
  abs.x ftmp, ftmp
  sub.x fBallPos, fWall1Right, ftmp
  b CHECK_REGION:

;-----------------------------------------
; Check Top Wall
;-----------------------------------------
CHECK1_BALL_TOP:
  sub.y ftmp, fWall1Top, fBallPos
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, CHECK1_BALL_BOTTOM:
  loi -1.0
  mul.y fBallSpeed, fBallSpeed, i
  abs.y ftmp, ftmp
  add.y fBallPos, ftmp, fWall1Top
  b REGION_1:

;-----------------------------------------
; Check Bottom Wall
;-----------------------------------------
CHECK1_BALL_BOTTOM:
  sub.y ftmp, fBallPos, fWall1Bottom
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BALLDONE:
  loi -1.0
  mul.y fBallSpeed, fBallSpeed, i
  abs.y ftmp, ftmp
  sub.y fBallPos, fWall1Bottom, ftmp
  b CHECK_REGION:

REGION_2:
  b CHECK2_BALL_LEFT:
;-----------------------------------------
; Check Left Wall 2
;-----------------------------------------
CHECK2_BALL_LEFT:
  sub.x ftmp, fWall2Left, fBallPos
  ftoi0.x ftmpi, ftmp
  mtir itmp, ftmpi[x]

  iblez itmp, CHECK2_BALL_RIGHT:

  sub.y ftmp, fBallPos, fWallCenterDown
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BOUNCE2_BALL_LEFT:

  sub.y ftmp, fWallCenterUp, fBallPos
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BOUNCE2_BALL_LEFT:
  iaddiu iCheckRegion, vi00, 1
  isw.w iCheckRegion, 0(iBallSpeedPtr)
  loi kWallTicknessX
  sub.x fBallPos, fBallPos, i
  sub.x fBallPos, fBallPos, i
  b BALLDONE:

BOUNCE2_BALL_LEFT:
  loi -1.0
  mul.x fBallSpeed, fBallSpeed, i
  abs.x ftmp, ftmp
  add.x fBallPos, ftmp, fWall2Left
  b CHECK2_BALL_RIGHT:

;-----------------------------------------
; Check Right Wall 2
;-----------------------------------------
CHECK2_BALL_RIGHT:
  sub.x ftmp, fBallPos, fWall2Right
  ftoi0.x ftmpi, ftmp
  mtir itmp, ftmpi[x]

  iblez itmp, CHECK2_BALL_TOP:
  loi -1
  mul.x fBallSpeed, fBallSpeed, i
  abs.x ftmp, ftmp
  sub.x fBallPos, fWall2Right, ftmp
  b REGION_2:

;-----------------------------------------
; Check Top Wall
;-----------------------------------------
CHECK2_BALL_TOP:
  sub.y ftmp, fWall2Top, fBallPos
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, CHECK2_BALL_BOTTOM:
  loi -1.0
  mul.y fBallSpeed, fBallSpeed, i
  abs.y ftmp, ftmp
  add.y fBallPos, ftmp, fWall2Top
  b REGION_2:

;-----------------------------------------
; Check Bottom Wall 2
;-----------------------------------------
CHECK2_BALL_BOTTOM:
  sub.y ftmp, fBallPos, fWall2Bottom
  ftoi0.y ftmpi, ftmp
  mtir itmp, ftmpi[y]

  iblez itmp, BALLDONE:
  loi -1.0
  mul.y fBallSpeed, fBallSpeed, i
  abs.y ftmp, ftmp
  sub.y fBallPos, fWall2Bottom, ftmp
  b REGION_2:

BALLDONE:
  sq.xy fBallSpeed, 0(iBallSpeedPtr)

  loi 2048
  add.xy fBallPos, fBallPos, i

  ftoi4.xy fBallPos, fBallPos
  sq.xy fBallPos, 1(iBallPtr)

  iaddiu, iBallPtr, iBallPtr, 2
  iaddiu, iBallSpeedPtr, iBallSpeedPtr, 1

  mfp.x ftmp, p

  iaddiu iCheckRegion, vi00, 2
  ibeq iRegion, iCheckRegion, ADD_MEANSPEED2:
  add.x fMeanSpeed1, fMeanSpeed1, ftmp
  b NO_ADD_MEANSPEED2:
ADD_MEANSPEED2:
  add.y fMeanSpeed2, fMeanSpeed2, ftmp[x]
NO_ADD_MEANSPEED2:
  ibne iCountBall, iBallMax, LOOPBALLS:
;*****************************************
;End Loop on all Ball
;*****************************************

  lq.z fFactor, kWallMeanSpeed(vi00)

  mul.x fMeanSpeed1, fMeanSpeed1, fFactor[z]
  sq.x fMeanSpeed1, kWallMeanSpeed(vi00)

  mul.y fMeanSpeed2, fMeanSpeed2, fFactor[z]
  sq.y fMeanSpeed2, kWallMeanSpeed(vi00)

  b FINISH_CALCULATION:
;*****************************************
; Finish Calculation
;*****************************************
FINISH_CALCULATION:

  b KICK:
;*****************************************
; Render
;*****************************************
KICK:

  iaddiu iKick, vi00, kGifWallPtr
  xgkick iKick

  iaddiu iKick, vi00, kGifBallPtr
  xgkick iKick

  b END:


;*****************************************
;End of the program
;*****************************************
END:
--exit
--endexit
