#include <stdio.h>
#include <math.h>
#include "defines.h"
#include "packet.h"
#include "geommath.h"
#include "texture.h"
#include "smiley.h"
#include "smiley2.h"

#define NUM_VERTS 36

Vec4 texts[NUM_VERTS] = {	Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),

				Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),

				Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),

				Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),

				Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),

				Vec3(0.0f,0.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,1.0f,1.0f),
				Vec3(0.0f,1.0f,1.0f),
				Vec3(1.0f,0.0f,1.0f)	};

Vec4 verts[NUM_VERTS] = {	Vec3(-0.5f,-0.5f, 0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),
				Vec3(-0.5f, 0.5f, 0.5f),
				Vec3( 0.5f, 0.5f, 0.5f),
				Vec3(-0.5f, 0.5f, 0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),

				Vec3(-0.5f,-0.5f,-0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),
				Vec3( 0.5f,-0.5f,-0.5f),
				Vec3( 0.5f, 0.5f,-0.5f),
				Vec3( 0.5f,-0.5f,-0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),

				Vec3(-0.5f,-0.5f,-0.5f),
				Vec3(-0.5f,-0.5f, 0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),
				Vec3(-0.5f, 0.5f, 0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),
				Vec3(-0.5f,-0.5f, 0.5f),

				Vec3( 0.5f,-0.5f,-0.5f),
				Vec3( 0.5f, 0.5f,-0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),
				Vec3( 0.5f, 0.5f, 0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),
				Vec3( 0.5f, 0.5f,-0.5f),

				Vec3(-0.5f, 0.5f, 0.5f),
				Vec3( 0.5f, 0.5f, 0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),
				Vec3( 0.5f, 0.5f,-0.5f),
				Vec3(-0.5f, 0.5f,-0.5f),
				Vec3( 0.5f, 0.5f, 0.5f),

				Vec3(-0.5f,-0.5f, 0.5f),
				Vec3(-0.5f,-0.5f,-0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),
				Vec3( 0.5f,-0.5f,-0.5f),
				Vec3( 0.5f,-0.5f, 0.5f),
				Vec3(-0.5f,-0.5f,-0.5f)	};

Mat44 makePerspectiveMatrix()
{
	Mat44 perspective;

	float n = 0.1f;
	float f = 1000.0f;
	float l = -0.06f * (2048.0f / (640.0f * 0.5f));
	float r =  0.06f * (2048.0f / (640.0f * 0.5f));
	float t =  0.06f * (2048.0f / (350.0f * 0.5f));
	float b = -0.06f * (2048.0f / (350.0f * 0.5f));

	LoadIdentity(&perspective);
	SetRow(&perspective,0,Vec4((2*n) / (r-l)	, 0.0f				, 0.0f				, 0.0f));
	SetRow(&perspective,1,Vec4(0.0f				, -(2*n) / (t-b)	, 0.0f				, 0.0f));
	SetRow(&perspective,2,Vec4(((r+l) / (r-l))	, ((t+b) / (t-b))	, ((f+n) / (f-n))	, -1.0f));
	SetRow(&perspective,3,Vec4(0.0f				, 0.0f				, ((2*f*n) / (f-n))	, 0.0f));
	return (perspective);
}

int main(int argc, char **argv)
{
	FILE *output;
	int bytes=0;
	int prim=0;
	qword_t colour;
	qword_t vertex;
	qword_t scales;
	qword_t reg;

	int i,j;
	int loop;

	u_long128 packet_data[1024];

	gifpacket_t gifpacket;

	for (i=0; i<1024; i++)
	{
		packet_data[i] = 0;
	}

	if (argc!=2)
	{
		fprintf(stderr, "Usage: gen_data output_file\n");
		return -1;
	}

	gifpacket_init(&gifpacket, packet_data);

	/* ship */
	prim=GS_SET_PRIM(GS_PRIM_TRI, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(6), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
	gifpacket_addgsdata(&gifpacket, 0x51);

	colour.ui32[0]=0xFF; colour.ui32[1]=0x0; colour.ui32[2]=0x0; colour.ui32[3]=0x80;
	gifpacket_addgspacked(&gifpacket, colour.ul128);
	
	vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(12)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);
	
	colour.ui32[0]=0x0; colour.ui32[1]=0xFF; colour.ui32[2]=0x0; colour.ui32[3]=0x80;
	gifpacket_addgspacked(&gifpacket, colour.ul128);
	
	vertex.ui32[0]=(-8)<<4; vertex.ui32[1]=(-12)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);
	
	colour.ui32[0]=0x0; colour.ui32[1]=0x0; colour.ui32[2]=0xFF; colour.ui32[3]=0x80;
	gifpacket_addgspacked(&gifpacket, colour.ul128);
	
	vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-6)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x0; colour.ui32[2]=0x0; colour.ui32[3]=0x80;
        gifpacket_addgspacked(&gifpacket, colour.ul128);
                                                       
        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(12)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0x0; colour.ui32[1]=0xFF; colour.ui32[2]=0x0; colour.ui32[3]=0x80;
        gifpacket_addgspacked(&gifpacket, colour.ul128);                             

        vertex.ui32[0]=(8)<<4; vertex.ui32[1]=(-12)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0x0; colour.ui32[1]=0x0; colour.ui32[2]=0xFF; colour.ui32[3]=0x80;
        gifpacket_addgspacked(&gifpacket, colour.ul128);                                                                         
                                                      
        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-6)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);                                   

	/* shot */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(2), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* big asteroid */
	prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xC8; colour.ui32[1]=0xC8; colour.ui32[2]=0xC8; colour.ui32[3]=0xFF;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        for (loop = 0; loop < 13; ++loop)
        {

                colour.ui32[0]=0x18; colour.ui32[1]=0x18; colour.ui32[2]=0x18; colour.ui32[3]=0x00;
                gifpacket_addgspacked(&gifpacket, colour.ul128);

                vertex.ui32[0]=((int)(30 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(30 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
                gifpacket_addgspacked(&gifpacket, vertex.ul128);
        }

	/* med asteroid */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xC8; colour.ui32[1]=0xC8; colour.ui32[2]=0xC8; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        for (loop = 0; loop < 13; ++loop)
        {

                colour.ui32[0]=0x18; colour.ui32[1]=0x18; colour.ui32[2]=0x18; colour.ui32[3]=0x00;
                gifpacket_addgspacked(&gifpacket, colour.ul128);

                vertex.ui32[0]=((int)(18 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(18 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
                gifpacket_addgspacked(&gifpacket, vertex.ul128);
        }

        /* small asteroid */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);  

        colour.ui32[0]=0xC8; colour.ui32[1]=0xC8; colour.ui32[2]=0xC8; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	for (loop = 0; loop < 13; ++loop)
	{

	        colour.ui32[0]=0x18; colour.ui32[1]=0x18; colour.ui32[2]=0x18; colour.ui32[3]=0x00;
		gifpacket_addgspacked(&gifpacket, colour.ul128);

		vertex.ui32[0]=((int)(8 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(8 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
		gifpacket_addgspacked(&gifpacket, vertex.ul128);
	}

        /* plasma unit */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(8), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1724)<<4; vertex.ui32[1]=(1934)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1729)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1730)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1731)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1728)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1729)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1730)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1731)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* effect particle */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(1), AA(0), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(1), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xD0; colour.ui32[1]=0xD0; colour.ui32[2]=0xD0; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* explosion sprites */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(18), EOP(0), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-4)<<4; vertex.ui32[1]=(-9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-14)<<4; vertex.ui32[1]=(-14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-9)<<4; vertex.ui32[1]=(-4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-20)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-9)<<4; vertex.ui32[1]=(4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-14)<<4; vertex.ui32[1]=(14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-4)<<4; vertex.ui32[1]=(9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(4)<<4; vertex.ui32[1]=(9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(14)<<4; vertex.ui32[1]=(14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(9)<<4; vertex.ui32[1]=(4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(20)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(9)<<4; vertex.ui32[1]=(-4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(14)<<4; vertex.ui32[1]=(-14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(4)<<4; vertex.ui32[1]=(-9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0x00; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(1), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(18), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-2)<<4; vertex.ui32[1]=(-5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-7)<<4; vertex.ui32[1]=(-7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-5)<<4; vertex.ui32[1]=(-2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-10)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-5)<<4; vertex.ui32[1]=(2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-7)<<4; vertex.ui32[1]=(7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(-2)<<4; vertex.ui32[1]=(5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(2)<<4; vertex.ui32[1]=(5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(7)<<4; vertex.ui32[1]=(7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(5)<<4; vertex.ui32[1]=(2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(10)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(5)<<4; vertex.ui32[1]=(-2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(7)<<4; vertex.ui32[1]=(-7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(2)<<4; vertex.ui32[1]=(-5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0x00; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* dummy giftag */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(0), EOP(1), PRE(1), prim, GIF_PACKED, NREG(0)));
        gifpacket_addgsdata(&gifpacket, 0x51);

	/* ship giftag (ABE=1 AA=0) */
	prim=GS_SET_PRIM(GS_PRIM_TRI, GOURAUD(1), TEXTURED(0), FOG(0), ABE(1), AA(0), ALPHA(0), CTXT(0), FIX(0));
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(6), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
	gifpacket_addgsdata(&gifpacket, 0x51);

	/* digit font data */
	vertex.ui32[0]=(10574); vertex.ui32[1]=(229); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(4292); vertex.ui32[1]=(226); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14606); vertex.ui32[1]=(225); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14606); vertex.ui32[1]=(228); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14666); vertex.ui32[1]=(132); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14414); vertex.ui32[1]=(228); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14414); vertex.ui32[1]=(229); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(8462); vertex.ui32[1]=(132); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14670); vertex.ui32[1]=(229); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	vertex.ui32[0]=(14670); vertex.ui32[1]=(228); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* a */
	vertex.ui32[0]=(14670); vertex.ui32[1]=(165); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* e */
	vertex.ui32[0]=(14414); vertex.ui32[1]=(225); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* g */
	vertex.ui32[0]=(10318); vertex.ui32[1]=(229); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* m */
	vertex.ui32[0]=(14794); vertex.ui32[1]=(165); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* p */
	vertex.ui32[0]=(14670); vertex.ui32[1]=(33); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* r */
	vertex.ui32[0]=(6478); vertex.ui32[1]=(165); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* s */
	vertex.ui32[0]=(14414); vertex.ui32[1]=(228); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* t */
	vertex.ui32[0]=(4238); vertex.ui32[1]=(66); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* v */
	vertex.ui32[0]=(10570); vertex.ui32[1]=(69); vertex.ui32[2]=0; vertex.ui32[3]=0;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* score primitive */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), ALPHA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(2), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=268435456; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        colour.ui32[0]=0xFF; colour.ui32[1]=0xFF; colour.ui32[2]=0xFF; colour.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, colour.ul128);

        vertex.ui32[0]=(1)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=268435456; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* cube model data */
	for (i=0; i<NUM_VERTS; i++)
	{
		gifpacket_addgsvec4(&gifpacket, &(texts[i]));
		gifpacket_addgsvec4(&gifpacket, &(verts[i]));
	}

	/* cube primitive */
	prim=GS_SET_PRIM(GS_PRIM_TRI, GOURAUD(1), TEXTURED(1), FOG(0), ABE(1), ALPHA(0), AA(0), CTXT(0), FIX(0));
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(NUM_VERTS), EOP(1), PRE(1), prim, GIF_PACKED, NREG(3)));
	gifpacket_addgsdata(&gifpacket, 0x512);

	/* cube colour data */
	for (i=0; i<NUM_VERTS; i++)
	{
		colour.ui32[0] = 115;
		colour.ui32[1] = 115;
		colour.ui32[2] = 115;
		colour.ui32[3] = 0x80;
		gifpacket_addgspacked(&gifpacket, 0);
		gifpacket_addgspacked(&gifpacket, colour.ul128);
		gifpacket_addgspacked(&gifpacket, 0);
	}

	/* object->world matrix */
	Mat44 objectToWorld;
	LoadIdentity(&objectToWorld);
	gifpacket_addgsmat44(&gifpacket, &objectToWorld);

	/* world->camera matrix */
	Mat44 worldToCamera;
	LoadIdentity(&worldToCamera);
	SetRow(&worldToCamera, 3, Vec4(0,0,-150.0f,1));
	gifpacket_addgsmat44(&gifpacket, &worldToCamera);

	/* projection matrix */
	Mat44 cameraToScreen = makePerspectiveMatrix();
	gifpacket_addgsmat44(&gifpacket, &cameraToScreen);

	/* default cube rotation matrix */
	Mat44 rotate;
	LoadRotation(&rotate, 0.01f, 0.01f, 0.0f);
	gifpacket_addgsmat44(&gifpacket, &rotate);

	/* up cube rotation matrix */
	LoadRotation(&rotate, 0.02f, 0.0f, 0.0f);
	gifpacket_addgsmat44(&gifpacket, &rotate);

	/* down cube rotation matrix */
	LoadRotation(&rotate, -0.02f, 0.0f, 0.0f);
	gifpacket_addgsmat44(&gifpacket, &rotate);

	/* left cube rotation matrix */
	LoadRotation(&rotate, 0.00f, 0.02f, 0.0f);
	gifpacket_addgsmat44(&gifpacket, &rotate);

	/* right cube rotation matrix */
	LoadRotation(&rotate, 0.00f, -0.02f, 0.0f);
	gifpacket_addgsmat44(&gifpacket, &rotate);

	/* scaling vector */
	scales.f32[0] = 2048.0f;
	scales.f32[1] = 2048.0f;
	scales.f32[2] = (float)((2<<24)-1)/2;
	scales.f32[3] = 1.0f;
	gifpacket_addgspacked(&gifpacket,scales.ul128);

	/* texture 1 data info */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(1), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* access the TEXFLUSH register */
	reg.ul64[0] = GS_SET_TEXFLUSH();
	reg.ul64[1] = TEXFLUSH_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set TEXA, TEX1, TEX0, MIPTBP1, MIPTBP2 */
	reg.ul64[0] = GS_SET_TEXA(0x80, 0, 0x80);
	reg.ul64[1] = TEXA_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX1(1,0,1,0,0,0,0);
	reg.ul64[1] = TEX1_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX0(0x118<<5, 1, PSMCT16, 5, 5, 0, 0, 0, 0, 0, 0, 0);
	reg.ul64[1] = TEX0_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* texture 2 data info */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(1), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* access the TEXFLUSH register */
	reg.ul64[0] = GS_SET_TEXFLUSH();
	reg.ul64[1] = TEXFLUSH_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set TEXA, TEX1, TEX0, MIPTBP1, MIPTBP2 */
	reg.ul64[0] = GS_SET_TEXA(0x80, 0, 0x80);
	reg.ul64[1] = TEXA_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX1(1,0,0,0,0,0,0);
	reg.ul64[1] = TEX1_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX0(0x198<<5, 1, PSMCT16, 3, 3, 0, 0, 0, 0, 0, 0, 0);
	reg.ul64[1] = TEX0_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* texture 3 data info */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(1), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* access the TEXFLUSH register */
	reg.ul64[0] = GS_SET_TEXFLUSH();
	reg.ul64[1] = TEXFLUSH_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set TEXA, TEX1, TEX0, MIPTBP1, MIPTBP2 */
	reg.ul64[0] = GS_SET_TEXA(0x80, 0, 0x80);
	reg.ul64[1] = TEXA_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX1(1,0,0,0,0,0,0);
	reg.ul64[1] = TEX1_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	reg.ul64[0] = GS_SET_TEX0(0x19F<<5, 1, PSMCT16, 3, 3, 0, 0, 0, 0, 0, 0, 0);
	reg.ul64[1] = TEX0_1_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* texture upload info */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(0), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* set destination buffer in BITBLTBUF */
	reg.ul64[0] = GS_SET_BITBLTBUF(0,1,PSMCT16,0x118<<5,1,PSMCT16);
	reg.ul64[1] = BITBLTBUF_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination position in TRXPOS */
	reg.ul64[0] = GS_SET_TRXPOS(0,0,0,0,0);
	reg.ul64[1] = TRXPOS_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination transmission area in TRXREG */
	reg.ul64[0] = GS_SET_TRXREG(32,32);
	reg.ul64[1] = TRXREG_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* kick off transfer with TRXDIR */
	reg.ul64[0] = GS_SET_TRXDIR(TRXDIR_TO_GS);
	reg.ul64[1] = TRXDIR_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* IMAGE mode giftag for texture transfer */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(128), EOP(0), PRE(0), 0, GIF_IMAGE, NREG(0)));
	gifpacket_addgsdata(&gifpacket, 0x0);

	/* convert texture to 16-bit colour and save */
	for (i=0, j=0; i<(NUM_TEX_BYTES/24); i++)
	{
		int b0 = ((tex[j++]) >> 3) << 10;
		int g0 = ((tex[j++]) >> 3) << 5;
		int r0 = ((tex[j++]) >> 3);
		int a0 = 0 << 15;
		int b1 = ((tex[j++]) >> 3) << 26;
		int g1 = ((tex[j++]) >> 3) << 21;
		int r1 = ((tex[j++]) >> 3) << 16;
		int a1 = 0 << 31;
		int b2 = ((tex[j++]) >> 3) << 10;
		int g2 = ((tex[j++]) >> 3) << 5;
		int r2 = ((tex[j++]) >> 3);
		int a2 = 0 << 15;
		int b3 = ((tex[j++]) >> 3) << 26;
		int g3 = ((tex[j++]) >> 3) << 21;
		int r3 = ((tex[j++]) >> 3) << 16;
		int a3 = 0 << 31;
		int b4 = ((tex[j++]) >> 3) << 10;
		int g4 = ((tex[j++]) >> 3) << 5;
		int r4 = ((tex[j++]) >> 3);
		int a4 = 0 << 15;
		int b5 = ((tex[j++]) >> 3) << 26;
		int g5 = ((tex[j++]) >> 3) << 21;
		int r5 = ((tex[j++]) >> 3) << 16;
		int a5 = 0 << 31;
		int b6 = ((tex[j++]) >> 3) << 10;
		int g6 = ((tex[j++]) >> 3) << 5;
		int r6 = ((tex[j++]) >> 3);
		int a6 = 0 << 15;
		int b7 = ((tex[j++]) >> 3) << 26;
		int g7 = ((tex[j++]) >> 3) << 21;
		int r7 = ((tex[j++]) >> 3) << 16;
		int a7 = 0 << 31;

		colour.ui32[0] = r0 | g0 | b0 | a0 | r1 | g1 | b1 | a1;
		colour.ui32[1] = r2 | g2 | b2 | a2 | r3 | g3 | b3 | a3;
		colour.ui32[2] = r4 | g4 | b4 | a4 | r5 | g5 | b5 | a5;
		colour.ui32[3] = r6 | g6 | b6 | a6 | r7 | g7 | b7 | a7;

		gifpacket_addgspacked(&gifpacket, colour.ul128);
	}

	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(0), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* set destination buffer in BITBLTBUF */
	reg.ul64[0] = GS_SET_BITBLTBUF(0,1,PSMCT16,0x198<<5,1,PSMCT16);
	reg.ul64[1] = BITBLTBUF_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination position in TRXPOS */
	reg.ul64[0] = GS_SET_TRXPOS(0,0,0,0,0);
	reg.ul64[1] = TRXPOS_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination transmission area in TRXREG */
	reg.ul64[0] = GS_SET_TRXREG(8,8);
	reg.ul64[1] = TRXREG_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* kick off transfer with TRXDIR */
	reg.ul64[0] = GS_SET_TRXDIR(TRXDIR_TO_GS);
	reg.ul64[1] = TRXDIR_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* IMAGE mode giftag for texture transfer */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(8), EOP(0), PRE(0), 0, GIF_IMAGE, NREG(0)));
	gifpacket_addgsdata(&gifpacket, 0x0);

	/* convert texture to 16-bit colour and save */
	for (i=0, j=0; i<(NUM_TEX2_BYTES/24); i++)
	{
		int b0 = ((tex2[j++]) >> 3) << 10;
		int g0 = ((tex2[j++]) >> 3) << 5;
		int r0 = ((tex2[j++]) >> 3);
		int a0 = 0 << 15;
		int b1 = ((tex2[j++]) >> 3) << 26;
		int g1 = ((tex2[j++]) >> 3) << 21;
		int r1 = ((tex2[j++]) >> 3) << 16;
		int a1 = 0 << 31;
		int b2 = ((tex2[j++]) >> 3) << 10;
		int g2 = ((tex2[j++]) >> 3) << 5;
		int r2 = ((tex2[j++]) >> 3);
		int a2 = 0 << 15;
		int b3 = ((tex2[j++]) >> 3) << 26;
		int g3 = ((tex2[j++]) >> 3) << 21;
		int r3 = ((tex2[j++]) >> 3) << 16;
		int a3 = 0 << 31;
		int b4 = ((tex2[j++]) >> 3) << 10;
		int g4 = ((tex2[j++]) >> 3) << 5;
		int r4 = ((tex2[j++]) >> 3);
		int a4 = 0 << 15;
		int b5 = ((tex2[j++]) >> 3) << 26;
		int g5 = ((tex2[j++]) >> 3) << 21;
		int r5 = ((tex2[j++]) >> 3) << 16;
		int a5 = 0 << 31;
		int b6 = ((tex2[j++]) >> 3) << 10;
		int g6 = ((tex2[j++]) >> 3) << 5;
		int r6 = ((tex2[j++]) >> 3);
		int a6 = 0 << 15;
		int b7 = ((tex2[j++]) >> 3) << 26;
		int g7 = ((tex2[j++]) >> 3) << 21;
		int r7 = ((tex2[j++]) >> 3) << 16;
		int a7 = 0 << 31;

		colour.ui32[0] = r0 | g0 | b0 | a0 | r1 | g1 | b1 | a1;
		colour.ui32[1] = r2 | g2 | b2 | a2 | r3 | g3 | b3 | a3;
		colour.ui32[2] = r4 | g4 | b4 | a4 | r5 | g5 | b5 | a5;
		colour.ui32[3] = r6 | g6 | b6 | a6 | r7 | g7 | b7 | a7;

		gifpacket_addgspacked(&gifpacket, colour.ul128);
	}

	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(4), EOP(0), PRE(0), 0, GIF_PACKED, NREG(1)));
	gifpacket_addgsdata(&gifpacket, 0x0e);

	/* set destination buffer in BITBLTBUF */
	reg.ul64[0] = GS_SET_BITBLTBUF(0,1,PSMCT16,0x19F<<5,1,PSMCT16);
	reg.ul64[1] = BITBLTBUF_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination position in TRXPOS */
	reg.ul64[0] = GS_SET_TRXPOS(0,0,0,0,0);
	reg.ul64[1] = TRXPOS_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* set destination transmission area in TRXREG */
	reg.ul64[0] = GS_SET_TRXREG(8,8);
	reg.ul64[1] = TRXREG_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* kick off transfer with TRXDIR */
	reg.ul64[0] = GS_SET_TRXDIR(TRXDIR_TO_GS);
	reg.ul64[1] = TRXDIR_REG;
	gifpacket_addgspacked(&gifpacket, reg.ul128);

	/* IMAGE mode giftag for texture transfer */
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(8), EOP(1), PRE(0), 0, GIF_IMAGE, NREG(0)));
	gifpacket_addgsdata(&gifpacket, 0x0);

	/* convert texture to 16-bit colour and save */
	for (i=0, j=0; i<(NUM_TEX3_BYTES/24); i++)
	{
		int b0 = ((tex3[j++]) >> 3) << 10;
		int g0 = ((tex3[j++]) >> 3) << 5;
		int r0 = ((tex3[j++]) >> 3);
		int a0 = 0 << 15;
		int b1 = ((tex3[j++]) >> 3) << 26;
		int g1 = ((tex3[j++]) >> 3) << 21;
		int r1 = ((tex3[j++]) >> 3) << 16;
		int a1 = 0 << 31;
		int b2 = ((tex3[j++]) >> 3) << 10;
		int g2 = ((tex3[j++]) >> 3) << 5;
		int r2 = ((tex3[j++]) >> 3);
		int a2 = 0 << 15;
		int b3 = ((tex3[j++]) >> 3) << 26;
		int g3 = ((tex3[j++]) >> 3) << 21;
		int r3 = ((tex3[j++]) >> 3) << 16;
		int a3 = 0 << 31;
		int b4 = ((tex3[j++]) >> 3) << 10;
		int g4 = ((tex3[j++]) >> 3) << 5;
		int r4 = ((tex3[j++]) >> 3);
		int a4 = 0 << 15;
		int b5 = ((tex3[j++]) >> 3) << 26;
		int g5 = ((tex3[j++]) >> 3) << 21;
		int r5 = ((tex3[j++]) >> 3) << 16;
		int a5 = 0 << 31;
		int b6 = ((tex3[j++]) >> 3) << 10;
		int g6 = ((tex3[j++]) >> 3) << 5;
		int r6 = ((tex3[j++]) >> 3);
		int a6 = 0 << 15;
		int b7 = ((tex3[j++]) >> 3) << 26;
		int g7 = ((tex3[j++]) >> 3) << 21;
		int r7 = ((tex3[j++]) >> 3) << 16;
		int a7 = 0 << 31;

		colour.ui32[0] = r0 | g0 | b0 | a0 | r1 | g1 | b1 | a1;
		colour.ui32[1] = r2 | g2 | b2 | a2 | r3 | g3 | b3 | a3;
		colour.ui32[2] = r4 | g4 | b4 | a4 | r5 | g5 | b5 | a5;
		colour.ui32[3] = r6 | g6 | b6 | a6 | r7 | g7 | b7 | a7;

		gifpacket_addgspacked(&gifpacket, colour.ul128);
	}

	gifpacket_terminate(&gifpacket);

	output=fopen(argv[1], "wb");
	
	if (output==NULL)
	{
		fprintf(stderr, "Could not open file \"%s\"\n", argv[1]);
		return -1;
	}

	fwrite(packet_data, sizeof(packet_data)/sizeof(qword_t), sizeof(qword_t), output);

	bytes=ftell(output);
	fclose(output);

	printf("Written %d bytes to \"%s\"\n", bytes, argv[1]);

	return 0;
}
