;
; Plasmaroids2 - VU1 demo
;
; Copyright 2003 Ben Tayler
; bjt@users.playstation2-linux.com
;

.init_vf_all
.init_vi_all

.syntax new

.vu
.include "vcl_sml.i"

PAD_square	.equ	H'7FFF	; 15 bit immediate limit
PAD_cross	.equ	H'4000
PAD_circle	.equ	H'2000
PAD_triangle	.equ	H'1000

PAD_start	.equ	H'0008
PAD_select	.equ	H'0001

PAD_R1		.equ	H'0800
PAD_R2		.equ	H'0200
PAD_L1		.equ	H'0400
PAD_L2		.equ	H'0100

PAD_left	.equ	H'0080
PAD_right	.equ	H'0020
PAD_up		.equ	H'0010
PAD_down	.equ	H'0040

partinfoaddr	.equ	455
maxpartinfoaddr	.equ	590	; maximum 90 particles on screen

flagareaaddr	.equ	590	; setup (x) game (y) dead (z) lives (w)
flagarea2addr	.equ	591	; fire (x) teleport (y) tele frames (z)
plasmatimeraddr	.equ	592
plasmaflagaddr	.equ	593
parttimeraddr	.equ	594
randomseedaddr	.equ	595
flagarea3addr	.equ	596	; hide flag (x) tele timer (y)
				; score (z) screen score (w)
flagarea4addr	.equ	597	; spawn timer (x) cube trans (y) fade flag(z)
				; text timer (w)
wavetimeraddr	.equ	598
astnumberaddr	.equ	599
padaddr		.equ	1023

shipposaddr	.equ	600
shipveladdr	.equ	601
shiprotaddr	.equ	602
shotinfoaddr	.equ	603
maxshotinfoaddr	.equ	615	; maximum 4 shots on screen
astinfoaddr	.equ	615
maxastinfoaddr	.equ	695	; maximum 15 asteroids on screen
plasmainfoaddr	.equ	695
explosioninfo	.equ	700
maxexplosion	.equ	722
banginfoaddr	.equ	750
maxbanginfoaddr	.equ	760	; max 5 bangs on screen

shipvertaddr	.equ	800
bigastvertaddr	.equ	806
medastvertaddr	.equ	820
smlastvertaddr	.equ	834
bangvertaddr	.equ	848
bang2vertaddr	.equ	866

shipprimaddr	.equ	0
shipstartaddr	.equ	2
shipmaxaddr	.equ	14	; 6 verts for ship

shotprimaddr	.equ	13
shotvertaddr	.equ	15	; 1 vert per shot

bigastprimaddr	.equ	18
bigaststartaddr	.equ	20
bigastmaxaddr	.equ	48	; 14 verts per asteroid

medastprimaddr	.equ	47
medaststartaddr	.equ	49
medastmaxaddr	.equ	77

smlastprimaddr	.equ	76
smlaststartaddr	.equ	78
smlastmaxaddr	.equ	106

plasmaprimaddr	.equ	105
plasmacoladdr	.equ	106
plasmavertaddr	.equ	107

partprimaddr	.equ	122
partcoladdr	.equ	123
partvertaddr	.equ	124

bangprimaddr	.equ	125
bangstartaddr	.equ	127
bangmaxaddr	.equ	163

bang2startaddr	.equ	164
bang2maxaddr	.equ	200

dummyprimaddr	.equ	199
ship2primaddr	.equ	200

digitinfoaddr	.equ	201
digitprimaddr	.equ	220
digitstartaddr	.equ	222
digitstart2addr	.equ	224

kModelStart	.equ	225
kModelEnd	.equ	296
kCubeTag	.equ	297
kCubeStart	.equ	298
kCubeEnd	.equ	405
kObjectToWorld	.equ	406
kWorldToCamera	.equ	410
kCameraToScreen	.equ	414
kRotate		.equ	418
kScales		.equ	438
kTex1DataTag	.equ	439
kTex2DataTag	.equ	444
kTex3DataTag	.equ	449
kTexUploadTag	.equ	454

maxshotframes	.equ	60
maxpartframes	.equ	80
maxparttimer	.equ	1
maxbangframes	.equ	15
maxspawntimer	.equ	120
maxwavetimer	.equ	180
maxnumlives	.equ	3
maxteleframes	.equ	60
maxteletimer	.equ	30

--enter
--endenter

; ----------------------------------------------------------------------------
; initialise data memory
; ----------------------------------------------------------------------------

	; things to be done every frame

	ilw.w		pad, padaddr(vi00)	; read pad

	ilw.x		setupflag, flagareaaddr(vi00)	; get setup flag
	ibgtz		setupflag, simulation	; branch if setup done

	; things to be done once only

	; upload cube textures to gs

	iaddiu		primaddr, vi00, kTexUploadTag	; set primitive
	xgkick		primaddr		; transfer texture

	iaddiu		primaddr, vi00, dummyprimaddr	; set dummy prim
	xgkick		primaddr		; cause a stall

	; zero data memory work area

	iaddiu		curraddr, vi00, partinfoaddr	; set start addr
	iaddiu		maxaddr, vi00, 1023	; set loop escape

	mini		temp, vf00, vf00[x]	; get all zeros

clearaddr:

	VectorSave	temp, 0, curraddr	; save zeros

	iaddiu		curraddr, curraddr, 1	; increment loop counter
	ibne		curraddr, maxaddr, clearaddr	; escape

	; set initial cube transparency

	iaddiu		temp, vi00, 0x80	; set cube transparency
	isw.y		temp, flagarea4addr(vi00)	; save cube trans

	; read vertex info into vu data mem

	iaddiu		curraddr, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr, vi00, shipmaxaddr	; set loop escape
	iaddiu		curraddr2, vi00, shipvertaddr	; set store address

	bal		temp, readvert	; store current pc and branch

	iaddiu		curraddr, vi00, bigaststartaddr
	iaddiu		maxaddr, vi00, bigastmaxaddr
	iaddiu		curraddr2, vi00, bigastvertaddr

	bal		temp, readvert

        iaddiu          curraddr, vi00, medaststartaddr
        iaddiu          maxaddr, vi00, medastmaxaddr   
        iaddiu          curraddr2, vi00, medastvertaddr

        bal             temp, readvert

        iaddiu          curraddr, vi00, smlaststartaddr                      
        iaddiu          maxaddr, vi00, smlastmaxaddr                         
        iaddiu          curraddr2, vi00, smlastvertaddr

        bal             temp, readvert

	iaddiu		curraddr, vi00, bangstartaddr
	iaddiu		maxaddr, vi00,	bangmaxaddr
	iaddiu		curraddr2, vi00, bangvertaddr

	bal		temp, readvert

	iaddiu		curraddr, vi00, bang2startaddr
	iaddiu		maxaddr, vi00, bang2maxaddr
	iaddiu		curraddr2, vi00, bang2vertaddr

	bal		temp, readvert

	b		storedone		; break out

readvert:

	VectorLoad	vert, 0, curraddr	; load ship vertex
	itof4.xy	vert, vert		; convert xy to float
	itof0.z		vert, vert		; convert z to float

	VectorSave	vert, 0, curraddr2	; store ship vertex
	iaddiu		curraddr2, curraddr2, 1	; increment store address

	iaddiu		curraddr, curraddr, 2	; next vertex
	ibne		curraddr, maxaddr, readvert	; loop

	jr		temp			; return

storedone:

	; read plasma information

	VectorLoad	vert, plasmavertaddr, vi00	; load plasma vertex
	itof4.xy	vert, vert		; convert to float
	VectorSave	vert, plasmainfoaddr, vi00	; save plasma vertex

	; set sine scale to 1.0

	iaddiu		curraddr, vi00, plasmainfoaddr	; load address
	max		temp, vf00, vf00[w]		; set to all ones
	VectorSave	temp, 4, curraddr		; save sine scale

	; set random seed

	loi		505.23245		; set initial seed
	add		temp, vf00, I

	rinit		r, temp[x]		; initialise generator
	rnext		temp, r			; get random number

	VectorSave	temp, randomseedaddr, vi00	; save seed

	; precalculate explosion velocity vectors

	loi		-10.0			; starting velocity

	add.xy		temp, vf00, I		; add velocity
	mul.y		temp2, temp, temp	; calculate radius squared

	iaddiu		curraddr, vi00, explosioninfo	; set start addr
	iaddiu		maxaddr, vi00, maxexplosion	; set loop escape

nextpart:

	add.y		temp, vf00, temp[x]	; move velocity to y

	mul.y		temp, temp, temp	; square
	sub.y		temp, temp2, temp	; subtract from radius squared

	sqrt		q, temp[y]		; calculate root
	add.y		temp, vf00, q		; set y velocity

	VectorSave	temp, 0, curraddr	; save velocity vector

	loi		-1.0
	mul.y		temp, temp, I		; mirror y coordinate

	VectorSave	temp, 1, curraddr	; save velocity vector

	loi		2.0
	add.x		temp, temp, I		; increment x velocity

	iaddiu		curraddr, curraddr, 2	; increment loop counter
	ibne		curraddr, maxaddr, nextpart	; branch if not done

	; save setup flag

	iaddiu		setupflag, vi00, 1	; set setup as done
	isw.x		setupflag, flagareaaddr(vi00)	; store setup flag

simulation:

; ----------------------------------------------------------------------------
; initialise registers
; ----------------------------------------------------------------------------

	move		astpos, vf00		; init asteroid position
	move		astvel, vf00		; init asteroid velocity
	move		astrot, vf00		; init asteroid rotation speed

; ----------------------------------------------------------------------------
; initialise random number generator
; ----------------------------------------------------------------------------

	VectorLoad	temp, randomseedaddr, vi00	; load seed
	rinit		r, temp[x]		; initialise generator

	rnext		temp, r			; get random number
	VectorSave	temp, randomseedaddr, vi00	; save seed

; ----------------------------------------------------------------------------
; update particle timer
; ----------------------------------------------------------------------------

	ilw.x		parttimer, parttimeraddr(vi00)	; load timer
	ibeq		parttimer, vi00, timerzero	; branch if zero

	isubiu		parttimer, parttimer, 1	; decrement timer
	isw.x		parttimer, parttimeraddr(vi00)	; save timer

timerzero:

; ----------------------------------------------------------------------------
; update respawn timer
; ----------------------------------------------------------------------------

	ilw.x		temp, flagarea4addr(vi00)	; load timer
	ibeq		temp, vi00, timerzero2	; branch if zero

	isubiu		temp, temp, 1		; decrement timer
	isw.x		temp, flagarea4addr(vi00)	; save timer

timerzero2:

; ----------------------------------------------------------------------------
; update wave timer
; ----------------------------------------------------------------------------

	ilw.x		temp, wavetimeraddr(vi00)	; load timer
	ibeq		temp, vi00, timerzero3	; branch if zero

	isubiu		temp, temp, 1		; decrement timer
	isw.x		temp, wavetimeraddr(vi00)	; save timer

timerzero3:

; ----------------------------------------------------------------------------
; update teleport frames
; ----------------------------------------------------------------------------

	ilw.z		temp, flagarea2addr(vi00)	; load frames
	ibeq		temp, vi00, timerzero4	; branch if zero

	isubiu		temp, temp, 1		; decrement frames
	isw.z		temp, flagarea2addr(vi00)	; save teleport frames

timerzero4:

; ----------------------------------------------------------------------------
; update teleport timer
; ----------------------------------------------------------------------------

	ilw.y		temp, flagarea3addr(vi00)	; load timer
	ibeq		temp, vi00, timerzero5	; branch if zero

	isubiu		temp, temp, 1		; decrement timer
	isw.y		temp, flagarea3addr(vi00)	; save timer

timerzero5:

; ----------------------------------------------------------------------------
; update screen score
; ----------------------------------------------------------------------------

	lq.zw		score,	flagarea3addr(vi00)	; load scores
	sub.z		temp, score, score[w]	; find score difference

	iaddiu		test, vi00, H'0002	; set test mask
	fmand		test, test		; check for matching scores

	ibgtz		test, match		; branch if scores match
	loi		2.0		; step size

	add.w		score, score, I		; increment screen score
	sq.w		score, flagarea3addr(vi00)	; save screen score

match:

; ----------------------------------------------------------------------------
; update cube zoom
; ----------------------------------------------------------------------------

	lq.z		fCameraZoom, (kWorldToCamera+3)(vi00)	; load zoom

	ilw.y		gameflag, flagareaaddr(vi00)	; read game flag
	ibne		gameflag, vi00, dontzoom	; branch if started

	loi		3.0		; maximum zoom
	add.z		temp, fCameraZoom, I	; add to current zoom

	iaddiu		test, vi00, H'0020	; set test bitmask
	fmand		test, test

	ibeq		test, vi00, dontzoom	; branch if zero
	loi		2.0		; zoom step size

	add.z		fCameraZoom, fCameraZoom, i	; increment zoom
	sq.z		fCameraZoom, (kWorldToCamera+3)(vi00)	; save zoom

dontzoom:

; ----------------------------------------------------------------------------
; copy and clear asteroid collision flags
; ----------------------------------------------------------------------------

	iaddiu		curraddr, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

clearflag:

	ilw.y		temp, 0(curraddr)	; load collision flag
	isw.z		temp, 0(curraddr)	; save previous collision flag

	ibeq		temp, vi00, nextflag	; branch if unset

	isw.y		vi00, 0(curraddr)	; unset collision flag

nextflag:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, clearflag	; loop

; ----------------------------------------------------------------------------
; draw plasma background
; ----------------------------------------------------------------------------

	; set up plasma registers

	iaddiu		curraddr, vi00, plasmainfoaddr	; load info address

	VectorLoad	plasmavert, 0, curraddr	; load vert
	move		vert, plasmavert	; copy to vert

	VectorLoad	toadd, 1, curraddr	; load plasma variable
	loi		0.1e-1			; plasma cycle speed

	add.xz		toadd, toadd, I		; increment plasma variable
	VectorSave	toadd, 1, curraddr	; save plasma variable

	ilw.x		plasmaint, 2(curraddr)	; load hue integer
	iaddiu		plasmaint, plasmaint, 2	; increment hue integer

	VectorLoad	plasmahue, 3, curraddr	; load hue float

	loi		0.2e-2			; hue change
	add.x		plasmahue, plasmahue, I	; increment plasma hue

	isubiu		temp, plasmaint, 6000	; check for max hue
	ibltz		temp, nohuewrap		; branch if not at max hue

	iaddiu		plasmaint, vi00, 0	; zero plasma integer
	move.x		plasmahue, vf00		; zero plasma hue

nohuewrap:

	isw.x		plasmaint, 2(curraddr)	; save hue integer
	VectorSave	plasmahue, 3, curraddr	; save hue float

	; check plasma timer and update flags

	ilw.x		plasmaflags, plasmaflagaddr(vi00)	; load flags
	ilw.x		temp, plasmatimeraddr(vi00)	; load plasma timer

	isubiu		temp, temp, 1			; decrement timer
	ibgtz		temp, nottimerzero		; branch

	iaddiu		temp, vi00, 300			; reset timer

	isubiu		plasmaflags, plasmaflags, 1	; decrement flags
	ibgtz		plasmaflags, notflagszero	; branch

	iaddiu		plasmaflags, vi00, 15		; reset flags

notflagszero:

nottimerzero:

	isw.x		plasmaflags, plasmaflagaddr(vi00)	; save flags
	isw.x		temp, plasmatimeraddr(vi00)	; save plasma timer

	; update sine scales

	VectorLoad	plasmascale, 4, curraddr	; load sine scales
	loi		0.5e-2			; scale rate

	iaddiu		test, vi00, H'0001	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosineone	; branch if flag not set
	add.x		plasmascale, plasmascale, I	; inc scale

	b		yessineone		; break out

nosineone:

	sub.x		plasmascale, plasmascale, I	; dec scale

yessineone:

	iaddiu		test, vi00, H'0002	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinetwo	; branch if flag not set
	add.y		plasmascale, plasmascale, I	; inc scale

	b		yessinetwo

nosinetwo:

	sub.y		plasmascale, plasmascale, I	; dec scale

yessinetwo:

	iaddiu		test, vi00, H'0004	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinethree ; branch if flag not set
	add.z		plasmascale, plasmascale, I	; inc scale

	b		yessinethree

nosinethree:

	sub.z		plasmascale, plasmascale, I	; dec scale

yessinethree:

	iaddiu		test, vi00, H'0008	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinefour	; branch if flag not set
	add.w		plasmascale, plasmascale, I	; inc scale

	b		yessinefour

nosinefour:

	sub.w		plasmascale, plasmascale, I	; dec scale

yessinefour:

	max		plasmascale, plasmascale, vf00[x]	; clamp to 0.0
	mini		plasmascale, plasmascale, vf00[w]	; clamp to 1.0

	VectorSave	plasmascale, 4, curraddr	; save sine scales

	; convert hsv to rgb

	move		plasmamod, vf00		; init plasma modifier

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector0	; branch if not sector 0

	; hue is in sector 0

	loi		1.0
	add.x		plasmamod, vf00, I	; put v in r field

	add.y		plasmamod, vf00, plasmahue[x]	; put t in g field

	b		foundhue		; break out

notsector0:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector1	; branch if not sector 1

	; hue is in sector 1

	loi		1.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.x		plasmamod, vf00, plasmahue	; q in r field
	add.y		plasmamod, vf00, I	; v in g field

	b		foundhue		; break out

notsector1:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector2	; branch if not sector 2

	; hue is in sector 2

	loi		2.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		1.0
	add.y		plasmamod, vf00, I	; v in g field

	add.z		plasmamod, vf00, plasmahue[x]	; t in b field

	b		foundhue		; break out

notsector2:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector3	; branch if not sector 3

	; hue is in sector 3

	loi		3.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.y		plasmamod, vf00, plasmahue[x]	; q in g field
	add.z		plasmamod, vf00, I	; v in b field

	b		foundhue		; break out

notsector3:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector4	; branch if not sector 4

	; hue is in sector 4

	loi		4.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	add.x		plasmamod, vf00, plasmahue	; t in r field

	loi		1.0
	add.z		plasmamod, vf00, I	; v in b field

	b		foundhue		; break out

notsector4:

	; hue is in sector 5

	loi		5.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		1.0
	add.x		plasmamod, vf00, I	; v in r field

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.z		plasmamod, vf00, plasmahue[x]	; q in b field

foundhue:

	iaddiu		xloopcount, vi00, 0	; init x loop counter
	iaddiu		yloopcount, vi00, 0	; init y loop counter

	iaddiu		primaddr, vi00, plasmaprimaddr ; set primitive address

xloop:

	isubiu		temp, xloopcount, 640	; plasma width
	ibeq		temp, vi00, xloopdone	; branch if at max x

	loi		4.0			; x pixel interval
	add.x		vert, vert, I

	loi		0.1e-1			; x scale factor
	mul.xy		temp2, vert, I

	move		temp, vf00		; clear temp

	loi		4.0			; x variable
	mul.x		temp, temp2, I
	add.xz		temp, temp, toadd

	mul.z		temp, temp, I
	add.z		temp, temp, temp2[x]

	AngleSinCos	temp, temp		; calculate sines

	loi		50.0			; x variable
	mul.x		temp, temp, I
	mul.x		xanswer, temp, plasmascale	; scale and add x sine

	mul.z		temp, temp, I
	mul.z		temp, temp, plasmascale[y]	; scale x sine
	add.x		xanswer, xanswer, temp[z]	; add x sine

yloop:

	isubiu		temp, yloopcount, 224	; plasma height
	ibeq		temp, vi00, yloopdone	; branch if at max y

	loi		2.0			; y pixel interval
	add.y		vert, vert, I

	; write verts for plasma block

	iaddiu		curraddr, vi00, plasmavertaddr	; load address

	move		temp, vert		; copy vert
	move		out, vert		; init out register

	ftoi4.xy	out, temp		; convert to fixed
	VectorSave	out, 0, curraddr	; save plasma vert

	add.x		temp, temp, vf00[w]	; increment x coordinate
	ftoi4.xy	out, temp		; convert to fixed
	VectorSave	out, 2, curraddr	; write first vert

	add.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 4, curraddr

	add.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 6, curraddr

	add.y		temp, temp, vf00[w]	; increment y coordinate
	ftoi4.xy	out, temp
	VectorSave	out, 8, curraddr

	sub.x		temp, temp, vf00[w]	; decrement x coordinate
	ftoi4.xy	out, temp
	VectorSave	out, 10, curraddr

	sub.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 12, curraddr

	sub.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 14, curraddr	; write last vert

	loi		0.1e-1			; y scale factor
	mul.xy		temp2, vert, I

	loi		6.0			; y variable
	mul.y		temp, temp2, I
	add.x		temp, toadd, temp[y]

	mul.z		temp, toadd, I
	add.z		temp, temp, temp2[y]

	AngleSinCos	temp, temp		; calculate sines

	loi		75.0			; y variable
	mul.xz		temp, temp, I

	move.x		out, xanswer

	mul.x		temp, temp, plasmascale[z]	; scale y sine
	add.x		out, out, temp		; add y sine

	mul.z		temp, temp, plasmascale[w]	; scale y sine
	add.x		out, out, temp[z]	; add y sine

	abs		out, out		; make sure v is positive
	mul.xyz		out, plasmamod, out[x]	; multiply to get rgb

	ftoi0		out, out		; convert to fixed
	iaddiu		curraddr, vi00, plasmacoladdr	; load address

	VectorSave	out, 0, curraddr		; save vertex colours
	VectorSave	out, 2, curraddr
	VectorSave	out, 4, curraddr
	VectorSave	out, 6, curraddr
        VectorSave      out, 8, curraddr
        VectorSave      out, 10, curraddr
        VectorSave      out, 12, curraddr
        VectorSave      out, 14, curraddr

	xgkick		primaddr		; kick plasma unit

	iaddiu		yloopcount, yloopcount, 2	; inc y loop
	b		yloop			; loop

yloopdone:

	iaddiu		yloopcount, vi00, 0	; reset y loop
	move.y		vert, plasmavert	; reset y coord

	iaddiu		xloopcount, xloopcount, 4	; inc x loop
	b		xloop			; loop

xloopdone:

; ----------------------------------------------------------------------------
; check for cube fade
; ----------------------------------------------------------------------------

	ilw.z		fadeflag, flagarea4addr(vi00)	; load fade flag
	ibgtz		fadeflag, notstart	; branch if set

	ibne		gameflag, vi00, notstart	; branch if in game

	iaddiu		test, vi00, PAD_start	; load test bitmask
	iand		test, test, pad		; check for start button

	ibgtz		test, notstart		; branch if not pressed

	; wait for zoom to finish

	loi		3.0		; maximum zoom
	add.z		temp, fCameraZoom, I	; add to current zoom

	iaddiu		test, vi00, H'0020	; set test bitmask
	fmand		test, test

	ibgtz		test, notstart	; branch if set

	iaddiu		fadeflag, vi00, 1	; set flag
	isw.z		fadeflag, flagarea4addr(vi00)	; save flag

notstart:

	ilw.y		cubetrans, flagarea4addr(vi00)	; load cube trans

	iaddiu		temp, cubetrans, 128	; start delay
	ibeq		temp, vi00, dontfade	; branch if zero

	ibeq		fadeflag, vi00, dontfade	; branch if not set

	isubiu		cubetrans, cubetrans, 4	; decrement cube trans
	isw.y		cubetrans, flagarea4addr(vi00) ; save cube trans

dontfade:

; ----------------------------------------------------------------------------
; check for game start
; ----------------------------------------------------------------------------

	ibne		gameflag, vi00, gamestarted	; branch if started

	iaddiu		temp, cubetrans, 128	; start delay
	ibne		temp, vi00, dontstart	; branch if not zero

	; set up game variables

	iaddiu		temp, vi00, maxnumlives	; set number of lives
	isw.w		temp, flagareaaddr(vi00)	; save number of lives

	; set wavetimer to spawn at start

	iaddiu		temp, vi00, 1		; set timer
	isw.x		temp, wavetimeraddr(vi00)	; save timer

	; set starting asteroid number

	iaddiu		temp, vi00, 3		; set asteroid number
	isw.x		temp, astnumberaddr(vi00)	; save number

	; reset score counter

	mini.zw		score, vf00, vf00[x]	; clear scores
	sq.zw		score, flagarea3addr(vi00)	; save score counter

	; reset cube zoom

	loi		-150.0			; minimum zoom
	add.z		fCameraZoom, vf00, I

	sq.z		fCameraZoom, (kWorldToCamera+3)(vi00)	; save zoom

	; reset cube transparency and fade flag

	iaddiu		temp, vi00, 0x80	; set cube transparency
	isw.y		temp, flagarea4addr(vi00)	; save cube trans

	isw.z		vi00, flagarea4addr(vi00)	; unset fade flag

	; set game, dead and shiphide flags

	iaddiu		hideflag, vi00, 0	; unset shiphide flag
	iaddiu		deadflag, vi00, 0	; unset dead flag
	iaddiu		gameflag, vi00, 1	; set game flag

	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag
	isw.z		deadflag, flagareaaddr(vi00)	; save dead flag
	isw.y		gameflag, flagareaaddr(vi00)	; save game flag

	b		gamestarted		; jump out

dontstart:

	iaddiu		hideflag, vi00, 1	; set shiphide flag
	iaddiu		deadflag, vi00, 1	; set dead flag

	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag
	isw.z		deadflag, flagareaaddr(vi00)	; save dead flag

gamestarted:

; ----------------------------------------------------------------------------
; kick texture info tag
; ----------------------------------------------------------------------------

	ibgtz		gameflag, noinfo	; branch if not at title

	iaddiu		primaddr, vi00, kTex1DataTag
	xgkick		primaddr		; kick default tag

	iaddiu		test, vi00, PAD_R1	; load test bitmask
	iand		test, test, pad		; check for button

	ibgtz		test, notr1		; branch if not pressed

	iaddiu		primaddr, vi00, kTex2DataTag
	xgkick		primaddr		; kick texture 2 info

	b		noinfo

notr1:

	iaddiu		test, vi00, PAD_R2	; load test bitmask
	iand		test, test, pad		; check for button

	ibgtz		test, notr2		; branch if not pressed

	iaddiu		primaddr, vi00, kTex3DataTag
	xgkick		primaddr		; kick texture 3 info

notr2:

noinfo:

; ----------------------------------------------------------------------------
; draw cube title
; ----------------------------------------------------------------------------

	ibgtz		gameflag, nocube	; branch if not at title
	ibltz		cubetrans, nocube	; branch if less than zero

	VectorLoad	fScales, kScales, vi00	; load scaling vector

	MatrixLoad	mObjectToWorld, kObjectToWorld, vi00	; load matrix
	MatrixLoad	mWorldToCamera, kWorldToCamera, vi00	; load matrix
	MatrixLoad	mCameraToScreen, kCameraToScreen, vi00	; load matrix

	MatrixLoad	mRotate, kRotate, vi00	; load default rotation matrix

	; check for pad input

	iaddiu		test, vi00, PAD_up	; set test bitmask
	iaddiu		test, test, PAD_down
	iaddiu		test, test, PAD_left
	iaddiu		test, test, PAD_right

	iand		test, test, pad		; check for input
	ibeq		test, vi00, gotinput	; branch if no input

	; check for up

	iaddiu		test, vi00, PAD_up
	iand		test, test, pad

	ibgtz		test, notup		; branch if not up
	MatrixLoad	mRotate, (kRotate+4), vi00	; load up rotation

	b		gotinput		; break

notup:

	; check for down

	iaddiu		test, vi00, PAD_down
	iand		test, test, pad

	ibgtz		test, notdown		; branch if not down
	MatrixLoad	mRotate, (kRotate+8), vi00	; load down rotation

	b		gotinput		; break

notdown:

	; check for left

	iaddiu		test, vi00, PAD_left
	iand		test, test, pad

	ibgtz		test, notleft2		; branch if not left
	MatrixLoad	mRotate, (kRotate+12), vi00	; load left rotation

	b		gotinput		; break

notleft2:

	; check for right

	iaddiu		test, vi00, PAD_right
	iand		test, test, pad

	ibgtz		test, notright2		; branch if not right
	MatrixLoad	mRotate, (kRotate+16), vi00	; load right rotation

notright2:

gotinput:

	; generate composite transformation matrix

	MatrixMultiply	mObjectToScreen, mObjectToWorld, mWorldToCamera
	MatrixMultiply	mObjectToScreen, mObjectToScreen, mCameraToScreen

	iaddiu		iVertPointer, vi00, kModelStart	; start of model data
	iaddiu		iVertEnd, vi00, kModelEnd + 1	; loop escape
	iaddiu		iStoreTo, vi00, kCubeStart	; output model data

transform:

	VertexLoad	vST, 0, iVertPointer	; load STQ
	VertexLoad	vVert, 1, iVertPointer	; load vertex

	MatrixMultiplyVertex	vVert, mRotate, vVert	; rotate in-place
	VertexSave	vVert, 1, iVertPointer	; save vertex

	MatrixMultiplyVertex	vVert, mObjectToScreen, vVert	; transform

	; perspective correction

	div		q, vf00[w], vVert[w]
	mul.xyz		acc, fScales, vVert[w]
	madd.xyz	vVert, vVert, fScales
	mul.xyz		vVert, vVert, q
	mul.xyz		vST, vST, q

	VertexFptoGsXYZ2	vVert, vVert	; convert to fixed point
	VertexSave	vST, 0, iStoreTo	; save STQ

	mfir.w		cubetrans, cubetrans	; move to float register
	sq.w		cubetrans, 1(iStoreTo)	; save cube transparency

	VertexSave	vVert, 2, iStoreTo	; save vertex
	iaddiu		iVertPointer, iVertPointer, 2	; increment pointer
	iaddiu		iStoreTo, iStoreTo, 3	; increment store address
	ibne		iVertPointer, iVertEnd, transform	; loop

	iaddiu		iCubeTag, vi00, kCubeTag	; set prim addr
	xgkick		iCubeTag		; kick cube

nocube:

; ----------------------------------------------------------------------------
; draw number of lives remaining
; ----------------------------------------------------------------------------

	ilw.y		teleportflag, flagarea2addr(vi00)	; load flag

	ilw.w		numlives, flagareaaddr(vi00)	; load number of lives
	ibeq		gameflag, vi00, nodrawlives	; branch if at title

	; draw an inverted ship for each life

	ibeq		numlives, vi00, nodrawlives	; branch if no lives
	iaddiu		temp, vi00, vi00	; zero loop counter

	loi		-270.0			; x position
	add.x		temp3, vf00, I		; set x position

	loi		180.0			; y position
	add.y		temp3, vf00, I		; set y position

nextlife:

	iaddiu		curraddr, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr, vi00, shipmaxaddr	; set loop escape
	iaddiu		curraddr2, vi00, shipvertaddr	; set load address

nextvertex:

	VectorLoad	vert, 0, curraddr2	; load ship vert
	iaddiu		curraddr2, curraddr2, 1	; increment load address

	move		temp2, vert		; fill in out fields
	add.xy		temp2, temp2, temp3	; add offsets

	loi		-0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr	; save vertex

	iaddiu		curraddr, curraddr, 2	; next vertex
	ibne		curraddr, maxaddr, nextvertex	; loop

	; swap giftags if teleporting

	ibeq		teleportflag, vi00, noswap	; swap if set

	VectorLoad	temp, shipprimaddr, vi00	; load ship giftag
	VectorLoad	temp2, ship2primaddr, vi00	; load ship2 giftag

	VectorSave	temp, ship2primaddr, vi00	; save ship giftag
	VectorSave	temp2, shipprimaddr, vi00	; save ship2 giftag

noswap:

	; kick life icon

	iaddiu		primaddr, vi00, shipprimaddr
	xgkick		primaddr		; display ship

	; swap giftags back

	ibeq		teleportflag, vi00, noswap2	; swap if set

	VectorLoad	temp, shipprimaddr, vi00	; load ship giftag
	VectorLoad	temp2, ship2primaddr, vi00	; load ship2 giftag

	VectorSave	temp, ship2primaddr, vi00	; save ship giftag
	VectorSave	temp2, shipprimaddr, vi00	; save ship2 giftag

noswap2:

	loi		25.0			; x offset between lives
	add.x		temp3, temp3, I		; add x offset

	iaddiu		primaddr, vi00, dummyprimaddr	; set dummy prim
	xgkick		primaddr		; cause a stall

	iaddiu		temp, temp, 1		; increment loop counter
	ibne		temp, numlives, nextlife	; draw next life

nodrawlives:

; ----------------------------------------------------------------------------
; draw current score
; ----------------------------------------------------------------------------

	loi		200.0			; x score offset
	add.x		digitpos2, vf00, I	; add x score offset

	loi		-94.0			; y score offset
	add.y		digitpos2, vf00, I	; add y score offset

	loi		0.5
	add.w		score, score, I		; add fractional part

	move.xy		digitpos, digitpos2	; fill in digit position

	loi		0.1e-3
	mul.w		temp4, score, I		; find tens of thousands

	ftoi0.w		temp4, temp4		; convert to fixed point
	mtir		digit, temp4[w]		; move to integer register

	bal		calladdr, displaydigit	; display digit
	itof0.w		temp4, temp4		; convert to floating point

	loi		1.0e4
	mul.w		temp4, temp4, I		; convert back

	sub.w		score, score, temp4	; find score remaining

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2

	loi		0.1e-2
	mul.w		temp4, score, I		; find thousands

	ftoi0.w		temp4, temp4
	mtir		digit, temp4[w]

	bal		calladdr, displaydigit
	itof0.w		temp4, temp4

	loi		1.0e3
	mul.w		temp4, temp4, I

	sub.w		score, score, temp4

	loi		20.0
	add.x		digitpos2, digitpos2, I

	move.xy		digitpos, digitpos2

	loi		0.1e-1
	mul.w		temp4, score, I		; find hundreds

	ftoi0.w		temp4, temp4
	mtir		digit, temp4[w]

	bal		calladdr, displaydigit
	itof0.w		temp4, temp4

	loi		1.0e2
	mul.w		temp4, temp4, I

	sub.w		score, score, temp4

	loi		20.0
	add.x		digitpos2, digitpos2, I

	move.xy		digitpos, digitpos2

	loi		0.1
	mul.w		temp4, score, I		; find tens

	ftoi0.w		temp4, temp4
	mtir		digit, temp4[w]

	bal		calladdr, displaydigit
	itof0.w		temp4, temp4

	loi		1.0e1
	mul.w		temp4, temp4, I

	sub.w		score, score, temp4

	loi		20.0
	add.x		digitpos2, digitpos2, I

	move.xy		digitpos, digitpos2

	move.w		temp4, score		; move remaining units

	ftoi0.w		temp4, temp4
	mtir		digit, temp4[w]

	bal		calladdr, displaydigit

; ----------------------------------------------------------------------------
; draw "press start"
; ----------------------------------------------------------------------------

	ibgtz		gameflag, notext	; branch if not at title
	ibgtz		fadeflag, notext	; branch if fading cube

	ilw.w		temp, flagarea4addr(vi00)	; load text timer
	ibgtz		temp, dontreset		; branch if more than zero

	iaddiu		temp, vi00, 60		; reset text timer

dontreset:

	isubiu		temp, temp, 1		; decrement text timer
	isw.w		temp, flagarea4addr(vi00)	; save text timer

	isubiu		temp, temp, 30		; center around zero
	ibltz		temp, notext		; branch if less than zero

	loi		-110.0			; x score offset
	add.x		digitpos2, vf00, I	; add x score offset

	loi		80.0			; y score offset
	add.y		digitpos2, vf00, I	; add y score offset

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 14
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 15
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 11
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 16
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 16
	bal		calladdr, displaydigit	; display digit

	loi		40.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 16
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 17
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 10
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 15
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 17
	bal		calladdr, displaydigit	; display digit

notext:

; ----------------------------------------------------------------------------
; draw "game over"
; ----------------------------------------------------------------------------

	ilw.z		temp, flagareaaddr(vi00)	; read dead flag
	ibeq		temp, vi00, notext2	; branch if not dead

	ibeq		gameflag, vi00, notext2	; branch if at title
	ibgtz		numlives, notext2	; branch if lives left

	loi		-90.0			; x score offset
	add.x		digitpos2, vf00, I	; add x score offset

	loi		-5.0			; y score offset
	add.y		digitpos2, vf00, I	; add y score offset

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 12
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 10
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 13
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 11
	bal		calladdr, displaydigit	; display digit

	loi		40.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 0
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 18
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 11
	bal		calladdr, displaydigit	; display digit

	loi		20.0
	add.x		digitpos2, digitpos2, I	; set position for next digit

	move.xy		digitpos, digitpos2	; fill in digit position

	iaddiu		digit, vi00, 15
	bal		calladdr, displaydigit	; display digit

notext2:

; ----------------------------------------------------------------------------
; perform ship simulation
; ----------------------------------------------------------------------------

	; update ship rotation

	VectorLoad	shiprot, shiprotaddr, vi00	; load ship rotation
	loi		0.8e-1			; rotation speed

	ilw.x		hideflag, flagarea3addr(vi00)	; read shiphide flag
	ibne		hideflag, vi00, notright	; branch if hidden

	iaddiu		test, vi00, PAD_left
	iand		test, test, pad		; check for left rotation

	ibgtz		test, notleft		; branch if not left
	sub.x		shiprot, shiprot, I	; dec ship rotation

notleft:

	iaddiu		test, vi00, PAD_right
	iand		test, test, pad		; check for right rotation

	ibgtz		test, notright		; branch if not right
	add.x		shiprot, shiprot, I	; inc ship rotation

notright:

	VectorSave	shiprot, shiprotaddr, vi00	; save ship rotation
	VectorLoad	shippos, shipposaddr, vi00	; load ship pos

	; update ship velocity

	AngleSinCos	shiprot, trigtable	; calc trig table

	add.x		trigtable2, vf00, trigtable[y]
	add.y		trigtable2, vf00, trigtable[x]	; swap sin and cos

	VectorLoad	shipvel, shipveladdr, vi00	; load ship velocity
	add		acc, vf00, shipvel	; put ship velocity in acc

	ibne		hideflag, vi00, noaccel	; branch if hidden

	iaddiu		test, vi00, PAD_cross	; load test bitmask
	iand		test, test, pad		; check against pad

	ibgtz		test, noaccel		; don't accel

	loi		0.1			; ship acceleration
	move		temp2, shipvel		; backup ship velocity

	msub.x		shipvel, trigtable, I	; update x shipvel
	madd.y		shipvel, trigtable, I	; update y shipvel

	; clamp ship velocity

	abs		temp, shipvel

	loi		9.0			; max ship velocity
	sub.xy		temp, temp, I

	iaddiu		test, vi00, H'0080
	fmand		test, test		; check for max x vel

	ibgtz		test, nomaxvelx		; branch if not at max
	move.x		shipvel, temp2

nomaxvelx:

	iaddiu		test, vi00, H'0040
	fmand		test, test		; check for max y vel

	ibgtz		test, nomaxvely		; branch if not at max
	move.y		shipvel, temp2

nomaxvely:

	; add exhaust particle

	ibgtz		parttimer, noaccel	; branch if more than zero
	iaddiu		partframes, vi00, maxpartframes	; set particle life

	move		partpos, shippos	; fill in particle position
	loi		5.0			; exhaust velocity

	move		partvel, shipvel	; fill in partvel fields
	add		acc, vf00, shipvel	; put shipvel in acc

	madd.x		partvel, trigtable, I
	msub.y		partvel, trigtable, I

	rget		random, r		; get random number

	loi		1.5
	sub		random, random, I	; normalise range

	loi		3.0
	mul		random, random, I	; scale random number

	mul.x		random, random, trigtable[y]
	mul.y		random, random, trigtable[x]	; scale with rotation

	add.xy		partvel, partvel, random	; add to velocity
	bal		calladdr, addpart	; add particle

	iaddiu		parttimer, vi00, maxparttimer	; set particle timer
	isw.x		parttimer, parttimeraddr(vi00)	; save timer

noaccel:

	VectorSave	shipvel, shipveladdr, vi00	; save ship velocity

	; update ship position

	VectorAdd	shippos, shippos, shipvel	; update ship pos

	; wrap at screen edges

	abs		temp, shippos

	loi		320.0			; max x coord
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080

	fmand		test, test		; check for max x pos
	ibgtz		test, nowrapx		; branch if not at max

	loi		-0.996875		; try to avoid getting stuck
	mul.x		shippos, shippos, I	; wrap x pos

nowrapx:

	loi		224.0			; max y coord
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040

	fmand		test, test		; check for max y pos
	ibgtz		test, nowrapy		; branch if not at max

	loi		-0.99553571		; try to avoid getting stuck
	mul.y		shippos, shippos, I	; wrap y pos

nowrapy:

	VectorSave	shippos, shipposaddr, vi00	; save ship pos

; ----------------------------------------------------------------------------
; check for teleport
; ----------------------------------------------------------------------------

	ilw.z		temp, flagareaaddr(vi00)	; read dead flag
	ibne		temp, vi00, noteleport		; branch if dead

	ilw.y		temp, flagarea3addr(vi00)	; read teleport timer
	ibne		temp, vi00, noteleport		; branch if not zero

	ibne		teleportflag, vi00, teleporting	; branch if set

	iaddiu		test, vi00, PAD_triangle
	iand		test, test, pad		; check against pad

	ibne		test, vi00, noteleport	; if not pressed

	iaddiu		teleportflag, vi00, 1	; set teleport flag
	iaddiu		hideflag, vi00, 1	; set shiphide flag

	isw.y		teleportflag, flagarea2addr(vi00)	; save flag
	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag

	; find random destination

	rnext.x		random, r		; get random number
	rnext.y		random, r		; get random number

	loi		1.5
	sub.xy		random, random, I	; normalise range

	loi		2.0
	mul.xy		random, random, I	; scale to 1.0

	loi		320.0			; max x position
	mul.x		temp, random, I

	loi		224.0			; max y position
	mul.y		temp, random, I

	; calculate and save velocity vector

	VectorSub	temp, temp, shippos	; calculate vector

	loi		0.16666667e-1		; teleport speed
	mul.xy		shipvel, temp, I	; calculate per-frame vector

	VectorSave	shipvel, shipveladdr, vi00	; save ship velocity

	; set teleport duration

	iaddiu		temp, vi00, maxteleframes	; set teleport frames
	isw.z		temp, flagarea2addr(vi00)	; save teleport frames

	; swap ship giftags

	VectorLoad	temp, shipprimaddr, vi00	; load ship giftag
	VectorLoad	temp2, ship2primaddr, vi00	; load ship2 giftag

	VectorSave	temp, ship2primaddr, vi00	; save ship giftag
	VectorSave	temp2, shipprimaddr, vi00	; save ship2 giftag

teleporting:

	; increment ship rotation

	loi		0.20600608		; angle per frame
	add.x		shiprot, shiprot, I	; set angle per frame
	VectorSave	shiprot, shiprotaddr, vi00	; save rotation

	; check for end of teleport

	ilw.z		temp, flagarea2addr(vi00)	; load teleport frames
	ibne		temp, vi00, noteleport		; branch if not zero

	iaddiu		teleportflag, vi00, 0	; unset teleport flag
	iaddiu		hideflag, vi00, 0	; unset shiphide flag

	isw.y		teleportflag, flagarea2addr(vi00)	; save flag
	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag

	move		shipvel, vf00		; zero ship velocity
	VectorSave	shipvel, shipveladdr, vi00	; save ship velocity

	; reset teleport timer

	iaddiu		temp, vi00, maxteletimer	; set teleport timer
	isw.y		temp, flagarea3addr(vi00)	; save teleport timer

	; swap ship giftags

	VectorLoad	temp, shipprimaddr, vi00	; load ship giftag
	VectorLoad	temp2, ship2primaddr, vi00	; load ship2 giftag

	VectorSave	temp, ship2primaddr, vi00	; save ship giftag
	VectorSave	temp2, shipprimaddr, vi00	; save ship2 giftag

noteleport:

; ----------------------------------------------------------------------------
; update shot info and kick to gs
; ----------------------------------------------------------------------------

	; add shot if there are not too many onscreen

	ibne		hideflag, vi00, nofirebutton	; branch if hidden

	iaddiu		test, vi00, PAD_square
	iaddiu		test, test, 1		; get around 15bit limit
	iand		test, test, pad		; check against pad

	ibne		test, vi00, nofirebutton	; if not pressed
	ilw.x		fireflag, flagarea2addr(vi00)	; load fire flag

	ibgtz		fireflag, noshot	; branch if flag set

	iaddiu		curraddr, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxshotinfoaddr	; set loop escape

saveshot:

	ilw.x		shotframes, 0(curraddr)	; load shot frames
	ibgtz		shotframes, slotfull	; branch if slot full

	iaddiu		shotframes, vi00, maxshotframes	; set new shot life
	isw.x		shotframes, 0(curraddr)	; save shot life

	VectorSave	shippos, 1, curraddr	; save start shotpos
	loi		8.0			; shot muzzle velocity

	move		shotvel, shipvel	; fill in shotvel fields
	add		acc, vf00, shipvel	; put shipvel in acc

	msub.x		shotvel, trigtable, I
	madd.y		shotvel, trigtable, I

	VectorSave	shotvel, 2, curraddr	; save shotvel
	iaddiu		fireflag, vi00, 1	; set flag

	isw.x		fireflag, flagarea2addr(vi00)	; save flag
	b		shotsaved		; escape

slotfull:

	iaddiu		curraddr, curraddr, 3	; next shot slot
	ibne		curraddr, maxaddr, saveshot ; loop

nofirebutton:

	iaddiu		fireflag, vi00, 0	; unset flag
	isw.x		fireflag, flagarea2addr(vi00)	; save flag

shotsaved:

noshot:

	; update shot positions and lifespans, kick to gs

	iaddiu		curraddr, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxshotinfoaddr	; set loop escape
	iaddiu		curraddr2, vi00, shotvertaddr	; set shot vert addr

updateshot:

	ilw.x		shotframes, 0(curraddr)		; load shot frames
	ibeq		shotframes, vi00, nextshotslot	; branch to next slot

	isubiu		shotframes, shotframes, 1	; dec shot frames
        isw.x		shotframes, 0(curraddr)	; save shot life

	VectorLoad	shotpos, 1, curraddr	; load shot position
	VectorLoad	shotvel, 2, curraddr	; load shot velocity

	VectorAdd	shotpos, shotpos, shotvel	; update shot pos
	VectorSave	shotpos, 1, curraddr	; save shot position

	VectorLoad	vert, shotvertaddr, vi00	; load shot vert
	itof0		vert, vert		; convert z to float

	move.xy		vert, shotpos		; fill in position

	loi		0.5
	mul.y		vert, vert, I		; halve height

	loi		2048.0
	add.xy		vert, vert, I		; translate to screen centre

	VertexFPtoGsXYZ2	out, vert	; convert to gs xyzw format
	VectorSave	out, 0, curraddr2	; save vertex

	add.x		vert, vert, vf00[w]	; increment x coordinate

	VertexFPtoGsXYZ2	out, vert	; convert
	VectorSave	out, 2, curraddr2	; save vertex

	iaddiu		primaddr, vi00, shotprimaddr
	xgkick		primaddr		; kick to gs

nextshotslot:

	iaddiu		curraddr, curraddr, 3	; next shot slot
	ibne		curraddr, maxaddr, updateshot	; loop

; ----------------------------------------------------------------------------
; update particles and kick to gs
; ----------------------------------------------------------------------------

	iaddiu		curraddr, vi00, partinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxpartinfoaddr	; set loop escape

updatepart:

	; update particles held in x & y fields

	ilw.x		partframes, 0(curraddr)		; load particle frames
	ibeq		partframes, vi00, nextpartslot	; branch to next slot

	isubiu		partframes, partframes, 1	; dec particle frames
	isw.x		partframes, 0(curraddr)		; save particle life

	VectorLoad	partpos, 1, curraddr	; load particle position
	VectorLoad      partvel, 2, curraddr	; load particle velocity

	loi		0.90			; slowdown factor
	mul.xy		partvel, partvel, I	; scale velocity

	VectorSave	partvel, 2, curraddr	; save particle velocity

	add.xy		partpos, partpos, partvel	; update particle pos
	VectorSave	partpos, 1, curraddr	; save particle position

	VectorLoad	vert, partvertaddr, vi00	; load shot vert
	itof0		vert, vert		; convert z to float

	move.xy		vert, partpos		; fill in position

	loi		0.5
	mul.y		vert, vert, I		; halve height

	loi		2048.0
	add.xy		vert, vert, I		; translate to screen centre

	VertexFPtoGsXYZ2	vert, vert	; convert to gs xyzw format
	VectorSave	vert, partvertaddr, vi00	; save vertex
	isw.w		partframes, partcoladdr(vi00)	; save alpha info

	iaddiu		primaddr, vi00, partprimaddr
	xgkick		primaddr		; kick to gs

nextpartslot:

	; update particles held in z & w fields

	ilw.z		partframes, 0(curraddr)		; load particle frames
	ibeq		partframes, vi00, nextpartslot2	; branch to next slot

	isubiu		partframes, partframes, 1	; dec particle frames
	isw.z		partframes, 0(curraddr)		; save particle life

	VectorLoad	partpos, 1, curraddr	; load particle position
	VectorLoad      partvel, 2, curraddr	; load particle velocity

	loi		0.90			; slowdown factor
	mul.zw		partvel, partvel, I	; scale velocity

	VectorSave	partvel, 2, curraddr	; save particle velocity

	add.zw		partpos, partpos, partvel	; update particle pos
	VectorSave	partpos, 1, curraddr	; save particle position

	VectorLoad	vert, partvertaddr, vi00	; load shot vert
	itof0		vert, vert		; convert z to float

	add.x		vert, vf00, partpos[z]	; fill in x position
	add.y		vert, vf00, partpos[w]	; fill in y position

	loi		0.5
	mul.y		vert, vert, I		; halve height

	loi		2048.0
	add.xy		vert, vert, I		; translate to screen centre

	VertexFPtoGsXYZ2	vert, vert	; convert to gs xyzw format
	VectorSave	vert, partvertaddr, vi00	; save vertex
	isw.w		partframes, partcoladdr(vi00)	; save alpha info

	iaddiu		primaddr, vi00, partprimaddr
	xgkick		primaddr		; kick to gs

nextpartslot2:

	iaddiu		curraddr, curraddr, 3	; next particle slot
	ibne		curraddr, maxaddr, updatepart	; loop

; ----------------------------------------------------------------------------
; update asteroid info and kick to gs
; ----------------------------------------------------------------------------

	; check if new wave is needed

	ilw.x		wavetimer, wavetimeraddr(vi00)	; load timer
	ibgtz		wavetimer, skipcheck3	; skip if more than zero

	iaddiu		wavetimer, vi00, maxwavetimer	; set wave timer

	; update asteroid positions

	iaddiu		curraddr, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

updateast:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextastslot	; branch to next slot

	iaddiu		wavetimer, vi00, 0	; zero wave timer

	VectorLoad	astpos, 1, curraddr	; load asteroid position
	VectorLoad	astvel, 2, curraddr	; load asteroid velocity

	VectorAdd	astpos, astpos, astvel	; update asteroid position

	; wrap at screen edges

	abs		temp, astpos

	loi		320.0			; max x coord
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080

	fmand		test, test		; check for max x pos
	ibgtz		test, noastwrapx	; branch if not at max

	loi		-0.996875		; try to avoid getting stuck
	mul.x		astpos, astpos, I	; wrap x pos

noastwrapx:

	loi		224.0			; max y coord
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040

	fmand		test, test		; check for max y pos
	ibgtz		test, noastwrapy	; branch if not at max

	loi		-0.99553571		; try to avoid getting stuck
	mul.y           astpos, astpos, I	; wrap y pos

noastwrapy:

	VectorSave	astpos, 1, curraddr	; save asteroid position

	; update asteroid rotations

	VectorLoad	astrot, 3, curraddr	; load asteroid rotation
	VectorLoad	temp, 4, curraddr	; load rotation delta

	VectorAdd	astrot, astrot, temp	; update asteroid rot
	VectorSave	astrot, 3, curraddr	; save asteroid rotation

	AngleSinCos	astrot, asttrigtable	; calc asteroid trig table

	add.x		asttrigtable2, vf00, asttrigtable[y]
	add.y		asttrigtable2, vf00, asttrigtable[x]	; swap

	; assume asteroid is small

	iaddiu		curraddr2, vi00, smlaststartaddr	; set start
	iaddiu		maxaddr2, vi00, smlastmaxaddr	; set loop escape

	iaddiu		loadaddr, vi00, smlastvertaddr	; set load address
	iaddiu		primaddr, vi00, smlastprimaddr	; set prim address

	isubiu		asttype, asttype, 1	; dec asteroid type
	ibeq		asttype, vi00, storeast	; branch to update

	; assume asteroid is medium

	iaddiu		curraddr2, vi00, medaststartaddr
	iaddiu		maxaddr2, vi00, medastmaxaddr

	iaddiu		loadaddr, vi00, medastvertaddr
	iaddiu		primaddr, vi00, medastprimaddr

	isubiu		asttype, asttype, 1
	ibeq		asttype, vi00, storeast	; branch to update

	; asteroid is large

	iaddiu		curraddr2, vi00, bigaststartaddr
	iaddiu		maxaddr2, vi00, bigastmaxaddr

	iaddiu		loadaddr, vi00, bigastvertaddr
	iaddiu		primaddr, vi00, bigastprimaddr

storeast:

	VectorLoad	vert, 0, loadaddr	; load asteroid vert
	iaddiu		loadaddr, loadaddr, 1	; increment load address

	move		temp2, vert		; fill in out fields

        mul.xy          temp, vert, asttrigtable2
        sub.x           temp2, temp, temp[y]	; rotate x coord

        mul.xy          temp, vert, asttrigtable
        add.y           temp2, temp, temp[x]	; rotate y coord

	VectorAdd	temp2, temp2, astpos	; translate to ast pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr2	; save vertex


	iaddiu		curraddr2, curraddr2, 2	; next vertex
	ibne		curraddr2, maxaddr2, storeast	; loop

	xgkick		primaddr		; kick asteroid to gs

	iaddiu		temp, vi00, dummyprimaddr	; set dummy prim
	xgkick		temp			; cause a stall

nextastslot:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, updateast	; loop

	isw.x		wavetimer, wavetimeraddr(vi00)	; save timer

skipcheck3:

; ----------------------------------------------------------------------------
; transform ship vertices
; ----------------------------------------------------------------------------

	; translate and rotate ship vertices

	iaddiu		curraddr, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr, vi00, shipmaxaddr	; set loop escape
	iaddiu		curraddr2, vi00, shipvertaddr	; set load address

storeship:

	VectorLoad	vert, 0, curraddr2	; load ship vert
	iaddiu		curraddr2, curraddr2, 1	; increment load address

	move		temp2, vert		; fill in out fields

	mul.xy		temp, vert, trigtable2
	sub.x		temp2, temp, temp[y]	; rotate x coord

	mul.xy		temp, vert, trigtable
	add.y		temp2, temp, temp[x]	; rotate y coord

	; transform ship while teleporting

	ilw.y		teleportflag, flagarea2addr(vi00)	; load flag
	ibeq		teleportflag, vi00, notransform	; branch if zero

	ilw.z		temp, flagarea2addr(vi00)	; load teleport frames
	mfir.x		temp, temp		; convert to integer register

	itof0.x		temp, temp		; convert to floating point

	loi		30.0			; half of maxteleframes
	sub.x		temp, temp, I		; transform around midpoint

	loi		0.1
	mul.x		temp, temp, I		; divide by 10

	mul.x		temp3, temp, temp	; square

	loi		9.0
	sub.x		temp, temp3, I		; subtract from max size

	loi		-1.0
	mul.x		temp, temp, I		; invert

	mul.xy		temp2, temp2, temp[x]	; magnify ship

	; set ship transparency while teleporting

	loi		10.666667		; transparency multiplier
	mul.x		temp3, temp3, I		; scale transparency

	loi		32.0			; minumum transparency
	add.x		temp3, temp3, I		; offset transparency

	add.w		temp3, vf00, temp3[x]	; transfer to w field
	ftoi0.w		temp3, temp3		; convert to fixed

	sq.w		temp3, -1(curraddr)	; save transparency

notransform:

	VectorAdd	temp2, temp2, shippos	; translate to ship pos

        loi             0.5
        mul.y           temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr	; save vertex

	iaddiu		curraddr, curraddr, 2	; next vertex
	ibne		curraddr, maxaddr, storeship	; loop

; ----------------------------------------------------------------------------
; collision detection
; ----------------------------------------------------------------------------

	; loop through asteroids and check for collisions

	iaddiu		curraddr, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

collision:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextcollision	; branch to next slot

	VectorLoad	astpos, 1, curraddr	; load asteroid position

	; set asteroid collision radius

	loi		8.0			; small asteroid radius
	add.x		astradius, vf00, I	; set collision radius

	loi		4.0			; small asteroid mass
	add.x		astmass, vf00, I	; set asteroid mass

	isubiu		asttype, asttype, 1	; dec asteroid type
	ibeq		asttype, vi00, foundtype	; branch if found

	loi		18.0			; med asteroid radius
	add.x		astradius, vf00, I

	loi		10.0			; med asteroid mass
	add.x		astmass, vf00, I

	isubiu		asttype, asttype, 1
	ibeq		asttype, vi00, foundtype

	loi		30.0			; big asteroid radius
	add.x		astradius, vf00, I

	loi		28.0			; big asteroid mass
	add.x		astmass, vf00, I

foundtype:

	; check for asteroid-shot collisions

	iaddiu		curraddr2, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr2, vi00, maxshotinfoaddr	; set loop escape

shotcollision:

	ilw.x		shotframes, 0(curraddr2)	; load shot frames
	ibeq		shotframes, vi00, nextshotcollision	; if empty

	VectorLoad	shotpos, 1, curraddr2	; load shot position
	VectorSub	temp, astpos, shotpos	; calculate distance

	mul.xy		temp, temp, temp	; x and y squared
	add.x		temp, temp, temp[y]	; add squares

	sqrt		q, temp[x]		; square root
	sub.x		temp, astradius, q	; sub asteroid radius

	iaddiu		test, vi00, H'0080	; load test bitmask
	fmand		test, test		; check for x collision

	ibne		test, vi00, nextshotcollision	; no collision branch

	; remove shot and asteroid

	isw.x		vi00, 0(curraddr2)	; remove shot

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	isw.x		vi00, 0(curraddr)	; remove asteroid

	isubiu		asttype, asttype, 1	; downgrade asteroid
	ibeq		asttype, vi00, noasteroid	; branch if zero type

	; add new asteroids

	VectorLoad	astvel, 2, curraddr	; load asteroid velocity
	VectorLoad	astrot, 4, curraddr	; load asteroid rotation speed

	VectorLoad	shotvel, 2, curraddr2	; load shot velocity

	loi		0.2			; shot velocity factor
	mul.xy		shotvel, shotvel, I

	move		temp, astvel		; save asteroid velocity
	sub.x		temp2, vf00, astvel[y]
	add.y		temp2, vf00, astvel[x]	; calculate perpendicular

	loi		0.5			; velocity scale factor
	mul.xy		temp2, temp2, I

	add.xy		astvel, temp, temp2	; add perpendicular
	add		astvel, astvel, shotvel	; add shot velocity
	bal		calladdr, addasteroid	; add asteroid

	sub.xy		astvel, temp, temp2	; subtract perpendicular
	add		astvel, astvel, shotvel	; add shot velocity
	bal		calladdr, addasteroid	; add asteroid

noasteroid:

	; add bang

	iaddiu		bangframes, vi00, maxbangframes	; set bang life
	move		bangpos, astpos		; set bang position

	bal		calladdr, addbang	; add bang

	; add explosion particles

	iaddiu		curraddr3, vi00, explosioninfo	; set start address
	iaddiu		maxaddr3, vi00, maxexplosion	; set loop escape

nextpart2:

	iaddiu		partframes, vi00, maxpartframes	; set particle life
	move		partpos, astpos		; set particle position

	VectorLoad	partvel, 0, curraddr3	; load velocity vector
	bal		calladdr, addpart	; add particle

	iaddiu		curraddr3, curraddr3, 1	; increment address
	ibne		curraddr3, maxaddr3, nextpart2	; loop if not done

	; increment score

	loi		42.0			; score per asteroid
	add.z		score, score, I		; increment score

	sq.z		score, flagarea3addr(vi00)	; save score

nextshotcollision:

	iaddiu		curraddr2, curraddr2, 3	; next shot slot
	ibne		curraddr2, maxaddr2, shotcollision	; loop

	; check for asteroid-ship collisions

	ibne		hideflag, vi00, skipcheck	; skip if hidden

	iaddiu		curraddr2, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr2, vi00, shipmaxaddr	; set loop escape

shipcollision:

	VectorLoad	vert, 0, curraddr2	; load ship vertex
	itof4		vert, vert		; change to float

	loi		2048.0
	sub.xy		vert, vert, I		; translate from screen coords

	loi		2.0
	mul.y		vert, vert, I		; double y coordinate

	VectorSub	temp, astpos, vert	; calculate distance

	mul.xy		temp, temp, temp	; square
	add.x		temp, temp, temp[y]

	sqrt		q, temp[x]		; root
	sub.x		temp, astradius, q

	iaddiu		test, vi00, H'0080
	fmand		test, test

	ibne		test, vi00, nextshipcollision

	; set dead and hidden flags in a collision

	iaddiu		deadflag, vi00, 1	; set dead flag
	isw.z		deadflag, flagareaaddr(vi00)	; save dead flag

	iaddiu		hideflag, vi00, 1	; set shiphide flag
	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag

	; set respawn timer

	iaddiu		temp, vi00, maxspawntimer	; set timer
	isw.x		temp, flagarea4addr(vi00)	; save timer

	; set ship position and velocity

	VectorSave	vf00, shipposaddr, vi00	; save ship position
	VectorSave	vf00, shipveladdr, vi00	; save ship velocity
	VectorSave	vf00, shiprotaddr, vi00	; save ship rotation

	; add bang

	iaddiu		bangframes, vi00, maxbangframes	; set bang life
	move		bangpos, shippos	; set bang position

	bal		calladdr, addbang	; add bang

	; add explosion particles

	iaddiu		curraddr3, vi00, explosioninfo	; set start address
	iaddiu		maxaddr3, vi00, maxexplosion	; set loop escape

nextpart3:

	iaddiu		partframes, vi00, maxpartframes	; set particle life
	move		partpos, shippos	; set particle position

	VectorLoad	partvel, 0, curraddr3	; load velocity vector
	bal		calladdr, addpart	; add particle

	iaddiu		curraddr3, curraddr3, 1	; increment address
	ibne		curraddr3, maxaddr3, nextpart3	; loop if not done

nextshipcollision:

	iaddiu		curraddr2, curraddr2, 2	; next ship vert
	ibne		curraddr2, maxaddr2, shipcollision	; loop

skipcheck:

	; check for asteroid-asteroid collisions

	iaddiu		curraddr2, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr2, vi00, maxastinfoaddr	; set loop escape

astcollision:

	ilw.x		asttype2, 0(curraddr2)	; load asteroid type
	ibeq		asttype2, vi00, nextastcollision	; branch

	ilw.y		temp, 0(curraddr2)	; load collision flag
	ibgtz		temp, nextastcollision	; branch if set

	VectorLoad	astpos2, 1, curraddr2	; load asteroid position
	sub.xy		temp, astpos, astpos2	; subtract positions

	iaddiu		test, vi00, H'000C	; mask for zx and zy
	fmand		test, test

	ibne		test, vi00, nextastcollision	; branch if same ast

	; set asteroid collision radius

	loi		8.0			; small asteroid radius
	add.x		astradius2, vf00, I	; set collision radius

	loi		4.0			; small asteroid mass
	add.x		astmass2, vf00, I	; set asteroid mass

	isubiu		asttype2, asttype2, 1	; dec asteroid type
	ibeq		asttype2, vi00, foundtype2	; branch if found

	loi		18.0			; med asteroid radius
	add.x		astradius2, vf00, I

	loi		10.0			; med asteroid mass
	add.x		astmass2, vf00, I

	isubiu		asttype2, asttype2, 1
	ibeq		asttype2, vi00, foundtype2

	loi		30.0			; big asteroid radius
	add.x		astradius2, vf00, I

	loi		28.0			; big asteroid mass
	add.x		astmass2, vf00, I

foundtype2:

	VectorSub	nvector, astpos, astpos2	; calculate distance
	add.x		temp2, astradius, astradius2	; sum of radii

	mul.xy		temp, nvector, nvector	; square
	add.x		temp, temp, temp[y]

	sqrt		q, temp[x]		; root
	sub.x		temp, temp2, q

	iaddiu		test, vi00, H'0080
	fmand		test, test

	ibne		test, vi00, nextastcollision

	; set collision flags

	iaddiu		temp, vi00, 1
	isw.y		temp, 0(curraddr)	; set collision flag
	isw.y		temp, 0(curraddr2)	; set collision flag

	ilw.z		temp, 0(curraddr2)	; load previous collision flag
	ibne		temp, vi00, nextastcollision	; branch if set

	; add particles

	VectorNormalize	nvector, nvector	; normalize n
	mul.xy		temp, nvector, astradius2[x]	; scale to edge
	add.xy		temp, temp, astpos2	; translate

	iaddiu		curraddr3, vi00, explosioninfo	; set start address
	iaddiu		maxaddr3, vi00, maxexplosion	; set loop escape

nextpart4:

	iaddiu		partframes, vi00, maxpartframes	; set particle life
	move		partpos, temp		; set particle position

	VectorLoad	partvel, 0, curraddr3	; load velocity vector
	bal		calladdr, addpart	; add particle

	iaddiu		curraddr3, curraddr3, 1	; increment address
	ibne		curraddr3, maxaddr3, nextpart4	; loop if not done

	; calculate rebounds

	VectorLoad	astvel, 2, curraddr
	VectorLoad	astvel2, 2, curraddr2	; load velocities

	VectorDotProduct	temp, astvel, nvector
	VectorDotProduct	temp2, astvel2, nvector	; calc components

	sub.x		temp, temp, temp2	; subtract components
	add.x		temp, temp, temp	; double components

	loi		0.9			; energy loss factor
	mul.x		temp, temp, I

	add.x		temp2, astmass, astmass2	; add masses
	div		q, temp[x], temp2[x]		; divide

	mul		nvector, nvector, q	; scale nvector

	mul		temp, nvector, astmass2[x]
	sub		astvel, astvel, temp	; change asteroid velocity

	mul		temp, nvector, astmass[x]
	add		astvel2, astvel2, temp	; change asteroid velocity

	VectorSave	astvel, 2, curraddr
	VectorSave	astvel2, 2, curraddr2	; save asteroid velocity

nextastcollision:

	iaddiu		curraddr2, curraddr2, 5	; next asteroid slot
	ibne		curraddr2, maxaddr2, astcollision	; loop

nextcollision:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, collision	; loop

; ----------------------------------------------------------------------------
; kick ship to gs
; ----------------------------------------------------------------------------

	ilw.y		teleportflag, flagarea2addr(vi00)	; load flag
	ibne		teleportflag, vi00, drawship	; branch if flag set

	ibne		hideflag, vi00, hideship	; branch if flag set

drawship:

	iaddiu		primaddr, vi00, shipprimaddr
	xgkick		primaddr		; display ship

hideship:

; ----------------------------------------------------------------------------
; update bangs and kick to gs
; ----------------------------------------------------------------------------

	iaddiu		curraddr, vi00, banginfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxbanginfoaddr	; set loop escape

updatebang:

	ilw.x		bangframes, 0(curraddr)		; load bang frames
	ibeq		bangframes, vi00, nextbangslot	; branch to next slot

	isubiu		bangframes, bangframes, 1	; dec bang frames
	isw.x		bangframes, 0(curraddr)		; save bang life

	VectorLoad	bangpos, 1, curraddr	; load bang position

	iaddiu		curraddr2, vi00, bangstartaddr
	iaddiu		maxaddr2, vi00, bangmaxaddr

	iaddiu		loadaddr, vi00, bangvertaddr

storebang:

	VectorLoad	vert, 0, loadaddr	; load bang vert

	move		temp2, vert		; fill in out fields
	VectorAdd	temp2, temp2, bangpos	; translate to bang pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr2	; save vertex

	VectorLoad	vert, 18, loadaddr	; load bang2 vert

	move		temp2, vert		; fill in out fields
	VectorAdd	temp2, temp2, bangpos	; translate to bang pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 37, curraddr2	; save vertex

	iaddiu		loadaddr, loadaddr, 1	; increment load address
	iaddiu		curraddr2, curraddr2, 2	; next vertex

	ibne		curraddr2, maxaddr2, storebang	; loop

	iaddiu		primaddr, vi00, bangprimaddr
	xgkick		primaddr		; kick to gs

	iaddiu		temp, vi00, dummyprimaddr	; set dummy prim
	xgkick		temp		; cause a stall

nextbangslot:

	iaddiu		curraddr, curraddr, 2	; next bang slot
	ibne		curraddr, maxaddr, updatebang	; loop

; ----------------------------------------------------------------------------
; check for respawn
; ----------------------------------------------------------------------------

	ilw.z		deadflag, flagareaaddr(vi00)	; read dead flag
	ibeq		deadflag, vi00, skipcheck2	; skip if not dead

	ilw.x		temp, flagarea4addr(vi00)	; load timer
	ibne		temp, vi00, skipcheck2		; skip if not zero

	iaddiu		deadflag, vi00, 0	; unset dead flag
	iaddiu		hideflag, vi00, 0	; unset shiphide flag

	iaddiu		curraddr, vi00, astinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

astslot:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextastslot2	; branch to next slot

	VectorLoad	astpos, 1, curraddr	; load asteroid position
	abs		temp, astpos

	loi		100.0			; bounding box width
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080
	fmand		test, test		; check if inside box

	ibeq		test, vi00, nextastslot2	; branch if not inside

	loi		100.0			; bounding box height
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040
	fmand		test, test		; check if inside box

	ibeq		test, vi00, nextastslot2	; branch if not inside

	iaddiu		deadflag, vi00, 1	; set dead flag
	iaddiu		hideflag, vi00, 1	; set shiphide flag

nextastslot2:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, astslot	; branch if not done

	; decrement number of lives

	ibne		deadflag, vi00, norespawn	; branch if no respawn
	isubiu		numlives, numlives, 1		; decrement lives

	isw.w		numlives, flagareaaddr(vi00)	; save lives

norespawn:

	isw.z		deadflag, flagareaaddr(vi00)	; save dead flag
	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag

skipcheck2:

; ---------------------------------------------------------------------------
; check for game end
; ---------------------------------------------------------------------------

	ibgez		numlives, notended	; branch if not at end

	; clear all asteroids

	iaddiu		curraddr, vi00, astinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

clearast:

	isw.x		vi00, 0(curraddr)	; zero asteroid type

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, clearast	; loop

	; clear all particles

	iaddiu		curraddr, vi00, partinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxpartinfoaddr	; set loop escape

clearpart:

	isw.x		vi00, 0(curraddr)	; zero particle life
	isw.z		vi00, 0(curraddr)	; zero particle life

	iaddiu		curraddr, curraddr, 3	; next particle slot
	ibne		curraddr, maxaddr, clearpart	; loop

	; change flags

	iaddiu		deadflag, vi00, 1	; set dead flag
	iaddiu		hideflag, vi00, 1	; set shiphide flag
	iaddiu		gameflag, vi00, 0	; unset game flag

	isw.z		deadflag, flagareaaddr(vi00)	; save dead flag
	isw.x		hideflag, flagarea3addr(vi00)	; save shiphide flag
	isw.y		gameflag, flagareaaddr(vi00)	; save game flag

notended:

; ----------------------------------------------------------------------------
; create new asteroid wave
; ----------------------------------------------------------------------------

	ibeq		gameflag, vi00, skipcheck4	; branch if at title

	iaddiu		temp, vi00, 1		; set test integer
	ibne		wavetimer, temp, skipcheck4	; skip if not equal

	; add more asteroids

	ilw.x		temp2, astnumberaddr(vi00)	; load asteroid number

spawnast:

	iaddiu		asttype, vi00, 3	; set big asteroid type

	rnext.x		random, r		; get random number
	rnext.y		random, r		; get random number

	loi		1.5
	sub.xy		random, random, I	; normalise range

	loi		2.0
	mul.xy		random, random, I	; scale to 1.0

	loi		320.0			; max x position
	mul.x		astpos, random, I

	loi		224.0			; max y position
	mul.y		astpos, random, I

	rnext.x		random, r
	rnext.y		random, r

	loi		1.5
	sub.xy		random, random, I	; normalise range

	loi		2.0
	mul.xy		random, random, I	; scale to 1.0

	loi		2.5
	mul.xy		astvel, random, I	; max velocity

	rnext.x		random, r		; get random number

	loi		1.5
	sub.x		random, random, I	; normalise range

	loi		2.0
	mul.x		random, random, I	; scale to 1.0

	loi		0.3
	mul.x		astrot, random, I	; max rotational speed

	bal		calladdr, addasteroid	; add asteroid

	isubiu		temp2, temp2, 1		; decrement asteroid number
	ibgtz		temp2, spawnast		; branch if not done

	ilw.x		temp2, astnumberaddr(vi00)	; load asteroid number

	iaddiu		temp, vi00, 14		; asteroid limit
	ibeq		temp2, temp, skipcheck4	; branch if at limit

	iaddiu		temp2, temp2, 1		; increment asteroid number
	isw.x		temp2, astnumberaddr(vi00)	; save asteroid number

skipcheck4:

	b		endfunctions		; branch to end

; ----------------------------------------------------------------------------
; function: add a particle
; ----------------------------------------------------------------------------

addpart:

	iaddiu		curraddr4, vi00, partinfoaddr	; set start address
	iaddiu		maxaddr4, vi00, maxpartinfoaddr	; set loop escape

savepart:

	; try to save in xy component

	ilw.x		temp3, 0(curraddr4)	; load particle frames
	ibgtz		temp3, partslotfull	; branch if slot full

	isw.x		partframes, 0(curraddr4)	; save particle life
	sq.xy		partpos, 1(curraddr4)	; save start particle pos

	sq.xy		partvel, 2(curraddr4)	; save particle velocity
	b		partsaved		; escape

partslotfull:

	; try to save in zw component

	ilw.z		temp3, 0(curraddr4)	; load particle frames
	ibgtz		temp3, partslotfull2	; branch if slot full

	isw.z		partframes, 0(curraddr4)	; save particle life

	add.z		partpos, vf00, partpos[x]	; copy to z component
	add.w		partpos, vf00, partpos[y]	; copy to w component

	sq.zw		partpos, 1(curraddr4)	; save start particle pos

	add.z		partvel, vf00, partvel[x]	; copy to z component
	add.w		partvel, vf00, partvel[y]	; copy to w component

	sq.zw		partvel, 2(curraddr4)	; save particle velocity
	b		partsaved		; escape

partslotfull2:

	iaddiu		curraddr4, curraddr4, 3	; next particle slot
	ibne		curraddr4, maxaddr4, savepart	; loop

partsaved:

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; function: add a bang
; ----------------------------------------------------------------------------

addbang:

	iaddiu		curraddr4, vi00, banginfoaddr	; set start address
	iaddiu		maxaddr4, vi00, maxbanginfoaddr	; set loop escape

savebang:

	ilw.x		temp3, 0(curraddr4)	; load bang frames
	ibgtz		temp3, bangslotfull	; branch if slot full

	isw.x		bangframes, 0(curraddr4)	; save bang life
	VectorSave	bangpos, 1, curraddr4	; save bang position

	b		bangsaved		; escape

bangslotfull:

	iaddiu		curraddr4, curraddr4, 2	; next bang slot
	ibne		curraddr4, maxaddr4, savebang	; loop

bangsaved:

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; function: add an asteroid
; ----------------------------------------------------------------------------

addasteroid:

	ibeq		asttype, vi00, astsaved	; branch if zero type

	iaddiu		curraddr4, vi00, astinfoaddr	; set start address
	iaddiu		maxaddr4, vi00, maxastinfoaddr	; set loop escape

saveast:

	ilw.x		temp3, 0(curraddr4)	; load asteroid type
	ibgtz		temp3, astslotfull	; branch if slot full

	isw.x		asttype, 0(curraddr4)	; save asteroid type

	iaddiu		temp3, vi00, 1
	isw.y		temp3, 0(curraddr4)	; set collision flag

	VectorSave	astpos, 1, curraddr4	; save asteroid position

	VectorSave	astvel, 2, curraddr4	; save asteroid velocity
	VectorSave	astrot, 4, curraddr4	; save asteroid rotation speed

	b		astsaved		; escape

astslotfull:

	iaddiu		curraddr4, curraddr4, 5	; next asteroid slot
	ibne		curraddr4, maxaddr4, saveast	; loop

astsaved:

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; function: display a digit
; ----------------------------------------------------------------------------

displaydigit:

	; draw first 16 bits of the digit

	iaddiu		test, vi00, 1		; set starting test bitmask
	ilw.x		temp, digitinfoaddr(digit)	; load digit data

	loi		2048.0			; origin
	add.xy		digitpos, digitpos, I	; translate to origin

	iaddiu		maxaddr, vi00, 32768	; set loop escape
	isubiu		temp3, vi00, 5		; character cell width

nextbit:

	iand		temp2, temp, test	; check against bitmask
	ibeq		temp2, vi00, dontplot	; branch if zero

	ftoi4.xy	out, digitpos		; convert to fixed point
	sq.xy		out, digitstartaddr(vi00)	; store plot position

	loi		1.0
	add.x		digitpos, digitpos, I	; increment x position

	ftoi4.xy	out, digitpos
	sq.xy		out, digitstart2addr(vi00)

	iaddiu		primaddr, vi00, digitprimaddr	; digit primitive addr
	xgkick		primaddr		; plot digit

	loi		3.0
	add.x		digitpos, digitpos, I	; increment x position

	b		plotcomplete		; jump out

dontplot:

	loi		4.0
	add.x		digitpos, digitpos, I	; update x position

plotcomplete:

	iaddiu		temp3, temp3, 1		; increment counter
	ibne		temp3, vi00, dontadd	; branch if not zero

	isubiu		temp3, temp3, 5		; reset counter

	loi		20.0
	sub.x		digitpos, digitpos, I	; reset x position

	loi		2.0
	add.y		digitpos, digitpos, I	; increment y position

dontadd:

	iaddiu		primaddr, vi00, dummyprimaddr	; set dummy prim
	xgkick		primaddr		; cause a stall

	iadd		test, test, test	; double test bitmask
	ibne		test, maxaddr, nextbit	; branch if not finished

	; draw last 16 bits of digit

	iaddiu		test, vi00, 1		; set starting test bitmask
	ilw.y		temp, digitinfoaddr(digit)	; load digit data

nextbit2:

	iand		temp2, temp, test	; check against bitmask
	ibeq		temp2, vi00, dontplot2	; branch if zero

	ftoi4.xy	out, digitpos		; convert to fixed point
	sq.xy		out, digitstartaddr(vi00)	; store plot position

	loi		1.0
	add.x		digitpos, digitpos, I	; increment x position

	ftoi4.xy	out, digitpos
	sq.xy		out, digitstart2addr(vi00)

	iaddiu		primaddr, vi00, digitprimaddr	; digit primitive addr
	xgkick		primaddr		; plot digit

	loi		3.0
	add.x		digitpos, digitpos, I	; increment x position

	b		plotcomplete2		; jump out

dontplot2:

	loi		4.0
	add.x		digitpos, digitpos, I	; update x position

plotcomplete2:

	iaddiu		temp3, temp3, 1		; increment counter
	ibne		temp3, vi00, dontadd2	; branch if not zero

	isubiu		temp3, temp3, 5		; reset counter

	loi		20.0
	sub.x		digitpos, digitpos, I	; reset x position

	loi		2.0
	add.y		digitpos, digitpos, I	; increment y position

dontadd2:

	iaddiu		primaddr, vi00, dummyprimaddr	; set dummy prim
	xgkick		primaddr		; cause a stall

	iadd		test, test, test	; double test bitmask
	ibne		test, maxaddr, nextbit2	; branch if not finished

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; end of functions
; ----------------------------------------------------------------------------

endfunctions:

--exit
--endexit

.end
