//------------------------------------------------------------
// Copyright (C)2002 Sony Computer Entertainment America Inc.
//
// This file is subject to the terms and conditions of the GNU
// General Public Licence Version 2.  See the file "COPYING"
// in the main directory of this archive for more details.
//------------------------------------------------------------

#ifndef _MAIN_H
#define _MAIN_H

#define MAX_STRING   256
#define FB3_OFFSET   210                        // offset to third fb page where pcrtc reads demo title, etc...  (zbp + 0x46)

typedef struct DC_S
{
   struct DC_S  *next;
   struct DC_S  *prev;
   char         name[MAX_STRING];
   char         helpText[20 * MAX_STRING];
   u_int        code_size;                      // in __u64 (max is 2048)
   u_int        data_size;                      // in qwords  (max is 1023)(1024 is for host data)
   __u64        *code;
   OS_Qword     *data;
} DEMO_CODE_NODE;

typedef struct
{
   DEMO_CODE_NODE  head;                        // dummy just used to keep track of list
   DEMO_CODE_NODE  tail;                        // dummy just used to keep track of list
   DEMO_CODE_NODE  *current;                    // current node in list
} DEMO_CODE_LIST;

void load_demo_list (char           *filename,  // name of inifile
                     char           *path,      // path to inifile and all data files
                     DEMO_CODE_LIST *dcl);      // demo code structure

//returns ptr to end of data record recovered
char *get_ini_record (char *ini_data,           // ini data file (pointer to start of record to recover)
                      char *path,               // path where demos are stored
                      char *name,               // name of demo
                      char *code,               // name of code file 
                      char *data,               // name of data file
                      char *help);              // name of help file

void init_demo_list (DEMO_CODE_LIST *dcl);

//returns the created node
DEMO_CODE_NODE *insert_demo_node (DEMO_CODE_LIST* dcl,
                                  char *name);           // name of demo

void next_demo_node (DEMO_CODE_LIST *dcl,
                     int            dir);       // greater than 0 next else prev

//returns null on failure or address of node on successs
DEMO_CODE_NODE *load_vu1_code_from_disk (DEMO_CODE_NODE *node,           // node to attach code to
                                         char           *code_filename); // file where code is stored

//returns null on failure or address of node on successs
DEMO_CODE_NODE *load_vu1_data_from_disk (DEMO_CODE_NODE *node,           // node to attach data to
                                         char           *data_filename); // file where data is stored


#endif

